%define version 6.1
%define versionnodot 61
%define release 0
%define _binary_payload w9.bzdio
Summary: A music notation program that can also generate MIDI files
Name: mup
Version: %{version}
Release: %{release}
License: Free, open source, from Arkkra Enterprises
Vendor: Arkkra Enterprises
Group: Sound
BuildRequires: glibc-devel fltk-devel libjpeg-devel libpng-devel zlib-devel
Source: mup%{versionnodot}src.tar.gz
BuildRoot: %{_tmppath}/%{name}-buildroot

%description
Mup takes a text description of music as input and
creates either high quality PostScript output for printing
or a MIDI file.


%prep
%setup -q

%build
# User can set MUP_CC_OPTIONS in the environment to add some compiler options.
# E.g. could set to -m32 to force 32-bit compile on a 64-bit machine.
# User can also set MUP_VGA_OPTION to where their libvga.a is located,
# if they want to compile with that, typically /usr/lib/libvga.a or
# /usr/lib64/libvga.a
(cd mup; cc -o mup -O -s -DDEBUG $MUP_CC_OPTIONS *.c -static -lm)
(cd mupdisp; cc -O -L/usr/X11/lib -o mupdisp $MUP_CC_OPTIONS *.c ${MUP_VGA_OPTION:--DNO_VGA_LIB} -lX11 -lm)
(cd mkmupfnt; cc -O -s $MUP_CC_OPTIONS -o mkmupfnt mkmupfnt.c)
(cd mupmate; g++ -O -s $MUP_CC_OPTIONS -I/usr/X11R6/include -I../mup -L/usr/X11R6/lib -o mupmate Config.C Edit.C File.C Help.C Main.C Preferences.C Run.C template.C utils.C -lfltk -lfltk_images -lXext -lX11 -lXpm -lXft -lXinerama -ljpeg -lpng -lz -lm)

%install
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
install -m 755 mup/mup $RPM_BUILD_ROOT/%{_bindir}
install -m 755 mupdisp/mupdisp $RPM_BUILD_ROOT/%{_bindir}
install -m 755 mkmupfnt/mkmupfnt $RPM_BUILD_ROOT/%{_bindir}
install -m 755 mupprnt $RPM_BUILD_ROOT/%{_bindir}
install -m 755 mupmate/mupmate $RPM_BUILD_ROOT/%{_bindir}

mkdir -p $RPM_BUILD_ROOT/%{_docdir}/mup
install -m 644 docs/license.txt $RPM_BUILD_ROOT/%{_docdir}/mup
install -m 644 docs/README0 $RPM_BUILD_ROOT/%{_docdir}/mup
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
install -m 644 docs/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1

mkdir -p $RPM_BUILD_ROOT/%{_docdir}/mup
install -m 644 docs/*.ps docs/*.mup docs/*.txt docs/*.html $RPM_BUILD_ROOT/%{_docdir}/mup

mkdir -p $RPM_BUILD_ROOT/%{_docdir}/mup/uguide
install -m 644 docs/uguide/*.html docs/uguide/*.gif $RPM_BUILD_ROOT/%{_docdir}/mup/uguide

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/mup
install -m 644 lib/* $RPM_BUILD_ROOT/%{_libdir}/mup

%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(755,root,root)%{_bindir}/mup
%attr(755,root,root)%{_bindir}/mupdisp
%attr(755,root,root)%{_bindir}/mkmupfnt
%attr(755,root,root)%{_bindir}/mupprnt
%attr(755,root,root)%{_bindir}/mupmate
%attr(644,root,root)%{_docdir}/mup/README0
%defattr(644,root,root)
%attr(644,root,root)%{_docdir}/mup/*.ps
%attr(644,root,root)%{_docdir}/mup/*.mup
%attr(644,root,root)%{_docdir}/mup/*.txt
%attr(644,root,root)%{_docdir}/mup/*.html
%attr(644,root,root)%{_mandir}/man1/*
%attr(644,root,root)%{_docdir}/mup/uguide/*
%attr(644,root,root)%{_libdir}/mup/*

%changelog
* Tue Oct 2 2012 Arkkra Enterprises <support@arkkra.com> 6.1
- Free, registration fee no longer required
- Gradual MIDI changes can be specified
* Tue Jun 5 2012 Arkkra Enterprises <support@arkkra.com> 6.0
- custom accidentals and alternate tunings
- keyboard mapping
- left/right pages (headers, footers, top, bottom)
- new indentrestart parameter
- new flipmargins parameter
- new minalignscale parameter
- margin overrides on newscore can be relative
- additional macros files
* Mon Mar 7 2011 Arkkra Enterprises <support@arkkra.com> 5.8
- Coordinates can include full arithmetic expressions
- Ties and slur can be to a different voice on the same staff
- An "auto" option on rightmargin override
- New "restsonly" value for vcombine parameter
- New mingridheight parameter
- Location tags can be set on lyric syllables
- Font and size can be changed before circled or boxed text
* Tue Mar 2 2010 Arkkra Enterprioses <support@arkkra.com> 5.7
- Support for all the standard non-ASCII PostScript characters
- New shortcuts for changing to a different font within the same family
- Alternate way of specifying phrase marks, using ph and eph
- Grace backup at the end of items
- New maxmeasure parameter
- Enhanced measnum parameter, to put a measure number on every Nth bar line
- New MupMate button to leave Run Parameters window visible
- Improved MupMate error messages for errors in macro expansions
* Mon Mar 30 2009 Arkkra Enterprises <support@arkkra.com> 5.6
- Full support for Apple Mac OS X
- Mupmate highlights error lines and jumps to the first error line
- Mupmate expansion of environment variables and add MUPPATH to include path
- New parameters: slashesbetween, bracketrepeats, repeatdots, alignrests
- til clause can have optional stepsize offset
- More lenient acceptance of tuplets that are not mathematically correct
- Good-til-canceled "with" list items don't apply to rests
- MIDI channel prefix meta events are generated
* Fri May 16 2008 Arkkra Enterprises <support@arkkra.com> 5.5
- new parameters: emptymeas, withsize, withfont, withfontfamily
- staff and voice contexts can apply to a list
- new optional values to stemshorten parameter
- possible to force stem direction on grace notes
- possible to put "with" items on rests
- MIDI processes legato marks
* Wed Jun 20 2007 Arkkra Enterprises <support@arkkra.com> 5.4
- User defined symbols and override of builtin symbols
- Index for HTML User's Guide
- New parameters: lyrdist, useaccs, carryaccs, measnumstyle, maxscores
- Some errors relaxed to warnings
- Alignment tags
* Tue Oct 24 2006 Arkkra Enterprises <support@arkkra.com> 5.3
- Mupmate front end program. New pagesize and vcombine parameters.
Optional maximum for scorepad parameter. Enhanced error messages.
* Sat Jan 14 2006 Arkkra Enterprises <support@arkkra.com> 5.2
- generalized 'if' clauses, beamstyle parameter is remembered,
support for complicated time signatures, ability to force stem direction,
beam angle improvements.
* Fri Apr 29 2005 Arkkra Enterprises <support@arkkra.com> 5.1
- cross-staff stems, number-of-pages string, additive time values,
beaming across spaces, alternate multirest notation, upward roll arrow,
alternate tuplet numbering style, voice 3 placement improvements,
miscellaneous bug fixes.
* Mon May 17 2004 Arkkra Enterprises <support@arkkra.com> 5.0
- shaped notes, stemlen parameter, mid-measure clef changes,
raw PostScript, swingunit parameter, etc.
* Fri Sep 26 2003 Arkkra Enterprises <support@arkkra.com> 4.6
- new contexts for top/bottom/top2/bottom2/block, paragraphs, etc
