/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 2 "gram.y"


/*
 Copyright (c) 1995-2012  by Arkkra Enterprises.
 All rights reserved.

 Redistribution and use in source and binary forms,
 with or without modification, are permitted provided that
 the following conditions are met:

 1. Redistributions of source code must retain
 the above copyright notice, this list of conditions
 and the following DISCLAIMER.

 2. Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and
 the following DISCLAIMER in the documentation and/or
 other materials provided with the distribution.

 3. Any additions, deletions, or changes to the original files
 must be clearly indicated in accompanying documentation.
 including the reasons for the changes,
 and the names of those who made the modifications.

	DISCLAIMER

 THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* This file contains the parser code for the Mup music publication program.
 * It uses lex to get the tokens.
 */


#include "rational.h"
#include "globals.h"
#include "defines.h"
#include "structs.h"
#include <errno.h>

#define YYDEBUG 1


/* how many items to allocate at a time for
 * "with" list, and location lists, etc */
#define ITEMS	(4)

/* Shorter way to refer to the current entry when building an entry from
 * accidentals context */
#define CURR_ACC_ENTRY	Acc_contexts_list_p->info[Curr_acc_index]

static struct MAINLL *Currstruct_p;	/* main list struct being filled in */
static struct BLOCKHEAD *Currblock_p;	/* current block, if non-zero */

static struct INPCOORD *Curr_loc_info_p; /* location info being collected */
static struct USER_SYMBOL *Curr_usym_p;	/* user-defined symbol being defined */


static short Getting_tup_dur;		/* YES if currently collection tuplet
					 * duration rather than GRPSYL dur */

static struct GRPSYL *Curr_grpsyl_p;	/* current GRPSYL struct being filled in */
static struct GRPSYL *Last_grpsyl_p;	/* previous GRPSYL struct filled in (contains
					 * defaults for the current one */
static struct TIMELIST *Extra_time_p;	/* If user enters times to be added
					 * together, like 2.+16 this points to
					 * a linked list of the extra times */
static struct TIMELIST *Curr_timelist_p;/* current additive time, used to know
					 * where to link items to the list */
static struct TIMELIST *Last_alloced_timelist_p; /* Most recently allocated
					 * list. Keeping track of this lets us
					 * avoid trying to free the list
					 * when Extra_time_p is pointing
					 * to a list from an SSV. */
static struct GRPSYL *Prev_grpsyl_p;	/* Like Last_grpsyl_p except in the
					 * case of additive times,
					 * in which case it points to the
					 * first group. This is needed in case
					 * the following group is to get its
					 * time value by defaulting to that
					 * of its previous group. */
static int Extra_basictime;		/* for saving basictime, when doing
					 * additive times */
static int Doing_timeunit = NO;		/* YES if gathering timeunit param */
static struct GRPSYL *Lyrics_p;		/* pointer to current list of lyrics */
static char **Curr_marklist;		/* current "with" list */
static struct PRINTDATA **Next_print_link_p_p;	/* points to where to attach next
						 * print command that we get */
static int Item_count;			/* items in current list */
static int Max_items;			/* current amount of space in lists
					 * "with" list, curve locations, etc) */

static int Plus_minus;			/* if 1 add, if -1 subtract offset */
static int Defining_multiple = NO;	/* if defining multiple voices at once */
static int Chord_at_a_time = NO;	/* YES for chord-at-a-time,
					 * NO for voice-at-a-time */
static int EM_staff;			/* Staff number of most recent
					 * emptymeas parameter usage */
static short Endingloc;			/* if current bar starts or ends an
					 * ending, etc (STARTITEM, ENDITEM, etc) */
static short Got_ending;		/* YES if got ending on this bar */

static int Til_bars;			/* number of bars in "til" clause */
static double Dist;			/* dist for a specific STUFF */
static int Dist_usage;			/* meaning of Dist field */
static int Aligntag = NOALIGNTAG;	/* align tag number for STUFF */
static short User_meas_time;		/* YES if user specified a time for
					 * an 'm' item. Only valid on mr */
static int Order_place;			/* PL_* for markorder in SSV */
static int Order_prio;			/* value in markorder in SSV */
static int Start_gracebackup;		/* how many grace notes to back up
					 * before starting a "stuff" */
static int End_gracebackup;		/* how many grace notes to back up
					 * before ending a "stuff" */
static float Til_offset;		/* beat count in "til" clause */
static float Til_steps;			/* stepsize offset of "til" clause */
static int Linetype;			/* L_DOTTED, L_DASHED, or L_NORMAL */

static char *String1, *String2;		/* to temporarily keep track
					 * of labels and other temporary
					 * strings */
static char Tmpbuff[20];		/* temporary buffer for converting
					 * float numbers */
static char Stringbuff[100];		/* temporary string storage */
static int Titlefont, Titlesize;	/* font/size for title command */
static double Extra;			/* extra vertical space for prints */
static short Good_till_canceled = NO;	/* if [] things should be continued
					 * until turned off */
static short Curr_paratype = J_JUSTPARA; /* current paragraph type */
static char Curr_accs[2*MAX_ACCS];	/* list of current note's accidentals */
static int Acc_offset;			/* Current place in Curr_accs */
static int Curr_acc_index;		/* Current place in info array of
					 * current accidentals context */
static struct TIMEDSSV *Curr_tssv_p;	/* current mid-measure param change */
static char Timerep[MAXTSLEN];		/* Internal representation of time
					 * signature being collected */
static int Tsig_offset;			/* Current place in Timerep while
					 * collecting a time signature */
static char *Alt_timesig_list;		/* If user specified alternating
					 * time signatures, this points to
					 * the beginning of the list, for
					 * when we need to wrap around */
static char *Next_alt_timesig;		/* If user specified alternating
					 * time signatures, this points to
					 * the one for the next measure */
static short Tsig_visibility;		/* If EACHMEAS, alternating
					 * time signatures will be done
					 * by explicitly printing
					 * the appropriate time signature at
					 * the beginning of every measure,
					 * rather than printing them all just
					 * once at the beginning of the run
					 * of measures that alternate. */
static struct TAG_REF *Curr_timeref_tag_p; /* Time offsets are relative
					 * to the most recent horizontal tag.
					 * This points to that tag,
					 * or is zero if no such tag yet */

/* Row index values must match the PS_* value definitions in defines.h.
 * Column [0] is height in portrait mode, and column [1] is height. */
double pagesztbl[7][2] = {
	{ 8.5, 11.0 },		/* PS_LETTER */
	{ 8.5, 14.0 },		/* PS_LEGAL */
	{ 8.5, 13.0 },		/* PS_FLSA */
	{ 5.5, 8.5 },		/* PS_HALFLETTER */
	{ 8.26, 11.69 },	/* PS_A4 */
	{ 5.84, 8.26 },		/* PS_A5 */
	{ 4.12, 5.84 }		/* PS_A6 */
};



/* static functions */
static char *stripquotes P((char *string));	/* rmv double quotes
						 * from string */
static void chkdup_headfoot P((int bit, char *which, struct BLOCKHEAD *block_p));
static void chkdup_topbot P((struct BLOCKHEAD **block_p_p, char *blocktype));
static void end_prev_context P((void));
static void clone_staff_ssvs P((struct MAINLL *insert_p));
static void clone_voice_ssvs P((struct MAINLL *insert_p));
static void clone1ssv P((struct SSV *clone_src_p, struct MAINLL *insert_p,
		int staffno, int voiceno));
static void chk_ssv_ranges P((UINT32B context));
static void var_valid P((void));	 /* check if okay to set location var */
static void proc_printcmd P((int justifytype, struct INPCOORD *inpc_p,
		char *str, int font, int size, int got_nl,
		int isPostScript, double extra));
static double extra_needed P((int font, int size, char **string_p));
static void keyword_notes P((char *str));
static void free_extra_time P((void));
static void tsig_item P((int item));
static struct EXPR_NODE *newnode P((int op));
static void clear_curr_accs P((void));
static void add_acc P((char *acc_name));
static void new_acc_entry P((char *acc_name));
static void add_acc_offset P((int letter, double offset));




/* Line 268 of yacc.c  */
#line 285 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_1ARG_FUNC = 258,
     T_2ARG_FUNC = 259,
     T_2FNUMVAR = 260,
     T_ACCIDENTALS = 261,
     T_ADDSUB_OP = 262,
     T_ALIGN = 263,
     T_ALL = 264,
     T_ALT = 265,
     T_AMPERSAND = 266,
     T_AUTO = 267,
     T_BARSTLISTVAR = 268,
     T_BARTYPE = 269,
     T_BBOX = 270,
     T_BLOCKHEAD = 271,
     T_BM = 272,
     T_BULGE = 273,
     T_CENTS = 274,
     T_CLEF = 275,
     T_CLEFVAR = 276,
     T_COLON = 277,
     T_COMMA = 278,
     T_COMMON = 279,
     T_CUE = 280,
     T_CURVE = 281,
     T_CUT = 282,
     T_DASH = 283,
     T_DBLFLAT = 284,
     T_DIAM = 285,
     T_DOT = 286,
     T_DOWN = 287,
     T_DRUM = 288,
     T_EBM = 289,
     T_EM_BEGIN = 290,
     T_EM_END = 291,
     T_ENDENDING = 292,
     T_ENDING = 293,
     T_ENDSTYLE = 294,
     T_ENDTYPE = 295,
     T_EPH = 296,
     T_EQUAL = 297,
     T_ESBM = 298,
     T_EVERY = 299,
     T_EXCLAM = 300,
     T_FAMILY = 301,
     T_FFAMILY = 302,
     T_FIRSTPAGE = 303,
     T_FNUMVAR = 304,
     T_FONT = 305,
     T_FONTVAR = 306,
     T_GRACE = 307,
     T_GRIDS = 308,
     T_HAT = 309,
     T_HEADSHAPES = 310,
     T_HIDECHANGES = 311,
     T_HO = 312,
     T_HS = 313,
     T_KEY = 314,
     T_KEYMAP = 315,
     T_KEYMAPVAR = 316,
     T_LBRACE = 317,
     T_LBRACKET = 318,
     T_LEN = 319,
     T_LET = 320,
     T_LETTER = 321,
     T_LET_M = 322,
     T_LET_N = 323,
     T_LET_R = 324,
     T_LET_S = 325,
     T_LET_U = 326,
     T_LET_X = 327,
     T_LINE = 328,
     T_LINETYPE = 329,
     T_LPAREN = 330,
     T_LVAR = 331,
     T_LYRICS = 332,
     T_L_ANGLE = 333,
     T_L_DBLANGLE = 334,
     T_MEASNUM = 335,
     T_MIDI = 336,
     T_MNUM = 337,
     T_MODIFIER = 338,
     T_MULDIV_OP = 339,
     T_MULTIREST = 340,
     T_MULTIWHOLE = 341,
     T_MUSIC = 342,
     T_MUSSYM = 343,
     T_NEWLINE = 344,
     T_NL = 345,
     T_NONE = 346,
     T_NONNAT = 347,
     T_NOWHERE_SLIDE = 348,
     T_NUM = 349,
     T_NUMBER = 350,
     T_NUMVAR = 351,
     T_OCTAVE = 352,
     T_OPTSTRVAR = 353,
     T_ORDER = 354,
     T_ORIENTATION = 355,
     T_OTHERTEXT = 356,
     T_PAD = 357,
     T_PAGESIDE = 358,
     T_PAGESIZE = 359,
     T_PARAGRAPH = 360,
     T_PARATYPE = 361,
     T_PEDAL = 362,
     T_PEDSTAR = 363,
     T_PEDSTYLE = 364,
     T_PH = 365,
     T_PHRASE = 366,
     T_PITCH = 367,
     T_PLACE = 368,
     T_PLUS = 369,
     T_POSTSCRIPT = 370,
     T_PRINTTYPE = 371,
     T_PSVAR = 372,
     T_QUESTION = 373,
     T_RANGELISTVAR = 374,
     T_RATNUMLISTVAR = 375,
     T_RBRACE = 376,
     T_RBRACKET = 377,
     T_REHEARSAL = 378,
     T_REHTYPE = 379,
     T_REH_STYLE = 380,
     T_REPEATDOTS = 381,
     T_ROLL = 382,
     T_RPAREN = 383,
     T_RPT = 384,
     T_R_ANGLE = 385,
     T_R_DBLANGLE = 386,
     T_SCORE = 387,
     T_SCOREFEED = 388,
     T_SCOREPAD = 389,
     T_SCORESEP = 390,
     T_SEMICOLON = 391,
     T_SHARP = 392,
     T_SHORTEN = 393,
     T_SLASH = 394,
     T_SLASHMARK = 395,
     T_SLOPE = 396,
     T_SLUR = 397,
     T_STAFF = 398,
     T_STAFFLINES = 399,
     T_STANDARD = 400,
     T_STAR = 401,
     T_STEMOFFSET = 402,
     T_STRING = 403,
     T_STRVAR = 404,
     T_SWINGUNIT = 405,
     T_SYMBOL = 406,
     T_TAB = 407,
     T_TICKS = 408,
     T_TIE = 409,
     T_TIL = 410,
     T_TILDE = 411,
     T_TIME = 412,
     T_TIMEUNIT = 413,
     T_TITLE = 414,
     T_TO = 415,
     T_TRANSPOSE = 416,
     T_TUNINGTYPE = 417,
     T_TUNINGVAR = 418,
     T_UNITS = 419,
     T_UNITTYPE = 420,
     T_UNSET = 421,
     T_UP = 422,
     T_USEACCS = 423,
     T_VCOMBINE = 424,
     T_VCOMBVAL = 425,
     T_VISVAR = 426,
     T_VOICE = 427,
     T_VVAR = 428,
     T_WHEREUSED = 429,
     T_WITH = 430,
     T_XNOTE = 431,
     T_XPOS_INT = 432,
     T_YESNOVAR = 433
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 218 "gram.y"

int	intval;		/* for tokens/nonterminals that return int values */
char	*stringval;	/* for tokens/nonterminals that return strings */
float	floatval;	/* for nonterminals that return floats */
RATIONAL ratval;	/* for nonterminals that return rational numbers */
struct INPCOORD *inpcoord_p;	/* for nonterminals that return coord info */
struct EXPR_NODE *expr_p;/* for nonterminals that return coord expression */
struct TAG_REF *tag_p;	/* for nonterminals that return a tag reference */



/* Line 293 of yacc.c  */
#line 511 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 523 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  208
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1326

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  179
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  304
/* YYNRULES -- Number of rules.  */
#define YYNRULES  704
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1077

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   433

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    15,    17,    19,
      22,    24,    26,    30,    32,    35,    37,    39,    41,    43,
      45,    47,    49,    52,    56,    57,    63,    64,    70,    72,
      76,    78,    80,    84,    87,    88,    89,    92,    94,    96,
     100,   101,   103,   107,   109,   112,   114,   117,   121,   125,
     127,   131,   134,   138,   140,   143,   145,   147,   149,   152,
     155,   157,   159,   164,   167,   172,   176,   182,   187,   192,
     193,   198,   203,   208,   214,   219,   224,   228,   232,   236,
     240,   244,   248,   252,   256,   260,   264,   268,   272,   275,
     276,   281,   285,   290,   295,   299,   303,   307,   313,   317,
     321,   325,   329,   333,   337,   347,   353,   355,   357,   359,
     360,   362,   364,   366,   369,   370,   372,   374,   375,   376,
     378,   380,   382,   386,   390,   391,   396,   401,   403,   404,
     406,   407,   410,   413,   415,   417,   418,   419,   421,   423,
     427,   431,   432,   435,   436,   441,   442,   445,   447,   448,
     449,   451,   455,   458,   460,   462,   464,   466,   470,   474,
     476,   478,   480,   482,   484,   486,   488,   490,   492,   495,
     497,   498,   502,   504,   505,   510,   512,   514,   518,   522,
     524,   526,   530,   532,   533,   535,   536,   538,   542,   546,
     549,   550,   552,   554,   556,   559,   562,   564,   569,   571,
     574,   579,   580,   582,   583,   585,   587,   589,   591,   592,
     595,   598,   599,   603,   604,   608,   609,   614,   616,   619,
     620,   622,   623,   626,   627,   629,   631,   633,   635,   637,
     638,   640,   642,   645,   647,   649,   656,   659,   660,   662,
     663,   665,   666,   670,   672,   675,   679,   687,   688,   690,
     692,   694,   696,   698,   700,   702,   704,   706,   708,   710,
     712,   714,   716,   718,   720,   722,   724,   726,   728,   730,
     732,   734,   736,   738,   740,   742,   744,   746,   748,   750,
     752,   754,   756,   758,   760,   762,   764,   768,   771,   776,
     780,   782,   783,   785,   787,   789,   792,   796,   798,   800,
     802,   806,   808,   812,   814,   816,   819,   821,   823,   827,
     830,   831,   834,   837,   842,   843,   846,   848,   851,   853,
     859,   860,   862,   864,   867,   872,   874,   876,   878,   880,
     884,   888,   892,   896,   899,   901,   906,   913,   914,   918,
     919,   924,   925,   926,   928,   930,   934,   938,   940,   942,
     944,   946,   950,   953,   956,   959,   962,   964,   966,   969,
     970,   972,   973,   975,   977,   981,   983,   987,   990,   993,
     995,   999,  1003,  1004,  1005,  1007,  1008,  1012,  1014,  1018,
    1020,  1022,  1024,  1026,  1028,  1030,  1032,  1034,  1036,  1038,
    1040,  1042,  1044,  1047,  1049,  1051,  1052,  1054,  1055,  1059,
    1061,  1063,  1064,  1067,  1072,  1073,  1074,  1076,  1077,  1080,
    1082,  1086,  1087,  1089,  1091,  1093,  1096,  1099,  1100,  1102,
    1106,  1109,  1113,  1116,  1119,  1121,  1122,  1125,  1128,  1129,
    1133,  1135,  1136,  1140,  1142,  1144,  1146,  1149,  1151,  1153,
    1155,  1157,  1159,  1161,  1163,  1165,  1169,  1172,  1178,  1184,
    1188,  1194,  1202,  1208,  1213,  1220,  1225,  1231,  1236,  1237,
    1239,  1241,  1242,  1244,  1245,  1247,  1248,  1250,  1254,  1255,
    1256,  1259,  1261,  1263,  1265,  1267,  1269,  1273,  1275,  1277,
    1279,  1281,  1283,  1285,  1287,  1289,  1291,  1294,  1296,  1299,
    1305,  1307,  1308,  1310,  1312,  1314,  1317,  1320,  1323,  1325,
    1327,  1329,  1331,  1333,  1335,  1337,  1339,  1341,  1350,  1351,
    1353,  1355,  1357,  1359,  1361,  1362,  1364,  1365,  1368,  1373,
    1377,  1379,  1380,  1382,  1383,  1385,  1387,  1389,  1393,  1396,
    1397,  1400,  1403,  1404,  1405,  1411,  1413,  1415,  1417,  1421,
    1424,  1425,  1428,  1429,  1432,  1433,  1435,  1437,  1440,  1443,
    1447,  1449,  1455,  1456,  1458,  1460,  1463,  1466,  1472,  1475,
    1477,  1479,  1480,  1484,  1486,  1487,  1490,  1495,  1497,  1499,
    1500,  1502,  1503,  1505,  1507,  1509,  1513,  1514,  1519,  1522,
    1524,  1525,  1530,  1531,  1534,  1536,  1539,  1541,  1543,  1547,
    1551,  1555,  1563,  1566,  1568,  1569,  1571,  1573,  1575,  1577,
    1584,  1585,  1587,  1589,  1592,  1594,  1595,  1599,  1603,  1607,
    1612,  1619,  1621,  1625,  1628,  1630,  1632,  1634,  1636,  1638,
    1640,  1644,  1647,  1648,  1650,  1652,  1654,  1662,  1663,  1664,
    1666,  1667,  1672,  1680,  1681,  1684,  1687,  1689,  1693,  1695,
    1699,  1702,  1704,  1708,  1716,  1723,  1726,  1728,  1730,  1732,
    1734,  1737,  1739,  1741,  1743,  1745,  1747,  1748,  1752,  1753,
    1755,  1756,  1759,  1762,  1766,  1767,  1769,  1770,  1773,  1775,
    1778,  1784,  1787,  1788,  1793,  1794,  1799,  1800,  1802,  1804,
    1805,  1808,  1811,  1814,  1817,  1820,  1825,  1831,  1832,  1834,
    1836,  1839,  1841,  1844,  1845,  1848,  1852,  1855,  1859,  1863,
    1867,  1869,  1871,  1872,  1874
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     180,     0,    -1,   181,    -1,   180,   181,    -1,   182,   416,
      -1,   211,    -1,   278,    -1,   284,    -1,   288,    -1,   417,
      89,    -1,   204,    -1,   198,    -1,   410,   416,    89,    -1,
      89,    -1,     1,    89,    -1,   183,    -1,   192,    -1,   194,
      -1,   205,    -1,   195,    -1,   203,    -1,   206,    -1,   193,
     191,    -1,   132,   191,   190,    -1,    -1,   143,   191,   184,
     186,   190,    -1,    -1,   172,   191,   185,   188,   190,    -1,
     187,    -1,   186,   298,   187,    -1,   301,    -1,   189,    -1,
     188,   298,   189,    -1,   301,   304,    -1,    -1,    -1,    16,
     217,    -1,    87,    -1,    53,    -1,     6,   196,   197,    -1,
      -1,   287,    -1,   199,   200,    89,    -1,   287,    -1,     9,
     202,    -1,   201,    -1,   361,   202,    -1,   201,   361,   202,
      -1,   430,   436,    19,    -1,   436,    -1,   436,   139,   436,
      -1,    60,   287,    -1,   287,   287,    89,    -1,    55,    -1,
     151,   287,    -1,   209,    -1,   209,    -1,    95,    -1,   347,
     209,    -1,   213,   212,    -1,   136,    -1,    89,    -1,    96,
      42,   347,   209,    -1,    96,    42,    -1,    48,    42,   209,
     217,    -1,    49,    42,   436,    -1,     5,    42,   436,    23,
     436,    -1,   138,    42,   436,   267,    -1,   117,    42,   269,
     270,    -1,    -1,   169,    42,   214,   271,    -1,   102,    42,
     347,   436,    -1,   173,    42,   209,   219,    -1,   120,    42,
     220,   221,   227,    -1,   119,    42,   228,   229,    -1,    13,
      42,   236,   237,    -1,   126,    42,   239,    -1,   240,    42,
     241,    -1,    59,    42,   254,    -1,   168,    42,   255,    -1,
     157,    42,   244,    -1,   144,    42,   257,    -1,    51,    42,
      50,    -1,    46,    42,    47,    -1,    21,    42,    20,    -1,
     178,    42,   262,    -1,   171,    42,   216,    -1,    80,    42,
     218,    -1,   166,   286,    -1,    -1,   158,    42,   215,   225,
      -1,   150,    42,   226,    -1,   135,    42,   263,   264,    -1,
     134,    42,   265,   266,    -1,    39,    42,   273,    -1,   125,
      42,   124,    -1,   109,    42,   276,    -1,   161,    42,   274,
     277,   209,    -1,   164,    42,   165,    -1,   149,    42,   287,
      -1,    98,    42,   468,    -1,   163,    42,   162,    -1,    61,
      42,   468,    -1,   115,    42,   287,    -1,    15,    42,   210,
      23,   210,    23,   210,    23,   210,    -1,   147,    42,   210,
      23,   210,    -1,   174,    -1,    66,    -1,    68,    -1,    -1,
     103,    -1,    66,    -1,    68,    -1,    44,   209,    -1,    -1,
     112,    -1,    66,    -1,    -1,    -1,   222,    -1,   225,    -1,
     223,    -1,   222,    23,   225,    -1,   222,    23,   223,    -1,
      -1,    75,   224,   222,   128,    -1,   339,   344,   340,   343,
      -1,    67,    -1,    -1,   225,    -1,    -1,    69,    70,    -1,
      70,    69,    -1,    70,    -1,    69,    -1,    -1,    -1,   230,
      -1,   231,    -1,   230,    23,   231,    -1,   209,   232,   233,
      -1,    -1,    28,   209,    -1,    -1,    75,   235,   234,   128,
      -1,    -1,    23,   235,    -1,   287,    -1,    -1,    -1,   238,
      -1,   237,    23,   238,    -1,   209,   232,    -1,     9,    -1,
     145,    -1,    99,    -1,   242,    -1,   241,    23,   242,    -1,
     241,    11,   242,    -1,   243,    -1,    88,    -1,    97,    -1,
     101,    -1,    83,    -1,    77,    -1,    38,    -1,   123,    -1,
     107,    -1,   245,   252,    -1,   247,    -1,    -1,   245,   246,
     247,    -1,   249,    -1,    -1,   247,   114,   248,   249,    -1,
      27,    -1,    24,    -1,   250,   139,   209,    -1,   250,   114,
      86,    -1,    86,    -1,   251,    -1,   250,   114,   251,    -1,
     209,    -1,    -1,   262,    -1,    -1,    68,    -1,   209,   369,
     275,    -1,   361,   362,   275,    -1,   262,   256,    -1,    -1,
      91,    -1,     9,    -1,    92,    -1,   209,   253,    -1,   209,
      33,    -1,   152,    -1,   152,    75,   258,   128,    -1,   259,
      -1,   258,   259,    -1,   361,   260,   261,   364,    -1,    -1,
     369,    -1,    -1,   153,    -1,    66,    -1,    68,    -1,   209,
      -1,    -1,    23,   209,    -1,   347,   209,    -1,    -1,    23,
     347,   209,    -1,    -1,    23,   436,   268,    -1,    -1,    23,
     210,    23,   210,    -1,   104,    -1,   361,   209,    -1,    -1,
     100,    -1,    -1,   304,   272,    -1,    -1,   170,    -1,    40,
      -1,    16,    -1,   167,    -1,    32,    -1,    -1,   177,    -1,
      73,    -1,    10,   108,    -1,   108,    -1,   177,    -1,   159,
     279,   282,   283,   416,    89,    -1,   281,   280,    -1,    -1,
      50,    -1,    -1,    47,    -1,    -1,    75,   209,   128,    -1,
     287,    -1,   287,   287,    -1,   287,   287,   287,    -1,   285,
     105,   279,   282,   287,   416,    89,    -1,    -1,   106,    -1,
      96,    -1,   178,    -1,   135,    -1,   144,    -1,   158,    -1,
     150,    -1,   102,    -1,    13,    -1,    49,    -1,     5,    -1,
      48,    -1,   138,    -1,   126,    -1,   164,    -1,    39,    -1,
     125,    -1,    80,    -1,   109,    -1,   173,    -1,   169,    -1,
     134,    -1,   119,    -1,    99,    -1,   168,    -1,    59,    -1,
     157,    -1,   161,    -1,   120,    -1,   171,    -1,   149,    -1,
      98,    -1,   163,    -1,    61,    -1,    51,    -1,    46,    -1,
      21,    -1,   148,    -1,   287,   114,   148,    -1,   289,    89,
      -1,   290,   291,   300,   306,    -1,    85,   209,   416,    -1,
     386,    -1,    -1,   297,    -1,   292,    -1,   293,    -1,   292,
     293,    -1,   294,   296,   295,    -1,    63,    -1,   122,    -1,
     297,    -1,   296,   136,   297,    -1,   299,    -1,   297,   298,
     299,    -1,    11,    -1,   301,    -1,   301,   304,    -1,    22,
      -1,   302,    -1,   301,    23,   302,    -1,   207,   303,    -1,
      -1,    28,   207,    -1,   208,   305,    -1,   208,    28,   208,
     305,    -1,    -1,    23,   304,    -1,   307,    -1,   306,   307,
      -1,   380,    -1,   308,   314,   348,   324,   136,    -1,    -1,
     309,    -1,   310,    -1,   309,   310,    -1,    79,   311,   312,
     131,    -1,   132,    -1,   143,    -1,   172,    -1,   313,    -1,
     312,   136,   313,    -1,    21,    42,    20,    -1,    96,    42,
     209,    -1,   178,    42,   262,    -1,   315,   337,    -1,   318,
      -1,    63,    28,   122,   318,    -1,    63,   318,   319,   122,
     316,   317,    -1,    -1,    31,    31,    31,    -1,    -1,   317,
      63,   319,   122,    -1,    -1,    -1,   320,    -1,   321,    -1,
     320,   136,   321,    -1,   175,   327,   330,    -1,   378,    -1,
     334,    -1,   345,    -1,   335,    -1,    49,   347,   209,    -1,
      57,   322,    -1,    58,   287,    -1,    64,   436,    -1,   140,
     209,    -1,   114,    -1,    28,    -1,   323,   436,    -1,    -1,
     430,    -1,    -1,   325,    -1,   326,    -1,   325,    23,   326,
      -1,   336,    -1,   141,   347,   436,    -1,    10,   209,    -1,
     110,   390,    -1,    41,    -1,   142,   328,   329,    -1,   154,
     328,   329,    -1,    -1,    -1,   335,    -1,    -1,   160,   172,
     209,    -1,   331,    -1,   330,    23,   331,    -1,   332,    -1,
     333,    -1,   287,    -1,    31,    -1,    28,    -1,   130,    -1,
      54,    -1,    25,    -1,    52,    -1,    30,    -1,   176,    -1,
     167,    -1,    32,    -1,    17,   338,    -1,    43,    -1,    34,
      -1,    -1,   225,    -1,    -1,   175,   143,   113,    -1,    86,
      -1,   209,    -1,    -1,   340,   341,    -1,   430,   342,   339,
     344,    -1,    -1,    -1,    67,    -1,    -1,   344,    31,    -1,
     346,    -1,   102,   347,   436,    -1,    -1,    28,    -1,   354,
      -1,   349,    -1,   350,   353,    -1,   351,   352,    -1,    -1,
     118,    -1,   156,   328,   329,    -1,    42,   379,    -1,    54,
     361,   364,    -1,    54,   139,    -1,    58,   287,    -1,   373,
      -1,    -1,   353,   352,    -1,   357,   355,    -1,    -1,   356,
     357,   113,    -1,   175,    -1,    -1,   357,   358,   353,    -1,
     359,    -1,    69,    -1,    70,    -1,    71,    70,    -1,   129,
      -1,    14,    -1,    52,    -1,    40,    -1,   106,    -1,   119,
      -1,    20,    -1,   168,    -1,    75,   359,   128,    -1,   361,
     360,    -1,   361,    75,   365,   128,   364,    -1,   361,    75,
     370,   128,   360,    -1,   361,    75,   361,    -1,   361,   365,
     261,   364,   360,    -1,   361,   365,   261,    75,   370,   128,
     360,    -1,   361,   365,   261,    75,   361,    -1,   361,   153,
     364,   360,    -1,   361,   153,    75,   370,   128,   360,    -1,
     361,   370,   363,   360,    -1,   361,   370,    75,   365,   128,
      -1,   361,   370,    75,   361,    -1,    -1,   287,    -1,   112,
      -1,    -1,   369,    -1,    -1,   365,    -1,    -1,   370,    -1,
     366,   368,   367,    -1,    -1,    -1,   367,   368,    -1,   137,
      -1,    11,    -1,    68,    -1,    72,    -1,    29,    -1,    62,
     287,   121,    -1,   137,    -1,    11,    -1,    68,    -1,    72,
      -1,    29,    -1,   209,    -1,   371,    -1,   372,    -1,    28,
      -1,   371,    28,    -1,   114,    -1,   372,   114,    -1,   374,
     375,   130,   328,   329,    -1,    78,    -1,    -1,    93,    -1,
     376,    -1,   377,    -1,   376,   377,    -1,   361,   364,    -1,
      42,   379,    -1,    66,    -1,   112,    -1,    67,    -1,    69,
      -1,    70,    -1,    71,    -1,    68,    -1,    72,    -1,    76,
      -1,   382,   306,   383,   384,   209,   381,   385,   136,    -1,
      -1,    68,    -1,    94,    -1,    66,    -1,    62,    -1,   121,
      -1,    -1,   113,    -1,    -1,    23,   225,    -1,    77,   387,
      22,   401,    -1,   388,   391,   394,    -1,   389,    -1,    -1,
     113,    -1,    -1,   113,    -1,   392,    -1,     9,    -1,   391,
      23,   392,    -1,   209,   393,    -1,    -1,    28,   209,    -1,
      11,   209,    -1,    -1,    -1,   394,   136,   113,   395,   391,
      -1,   397,    -1,   112,    -1,   398,    -1,   397,    23,   398,
      -1,   209,   399,    -1,    -1,    28,   209,    -1,    -1,   402,
     408,    -1,    -1,   403,    -1,   404,    -1,   403,   404,    -1,
     405,   136,    -1,   400,   337,   407,    -1,   406,    -1,   382,
     403,   383,   209,   385,    -1,    -1,    70,    -1,   409,    -1,
     408,   409,    -1,   287,   136,    -1,    63,   396,   122,   287,
     136,    -1,   418,   423,    -1,   440,    -1,   444,    -1,    -1,
     133,   411,   412,    -1,   479,    -1,    -1,   412,   413,    -1,
      49,   415,   323,   414,    -1,   436,    -1,    12,    -1,    -1,
      42,    -1,    -1,   136,    -1,   451,    -1,   473,    -1,   442,
     419,   420,    -1,    -1,    75,   442,    14,   128,    -1,   421,
     422,    -1,    14,    -1,    -1,   422,    35,   288,    36,    -1,
      -1,   423,   424,    -1,   346,    -1,    42,   379,    -1,   425,
      -1,    56,    -1,    82,    42,   209,    -1,    65,    42,   287,
      -1,    94,    42,   209,    -1,   123,   426,   281,   280,   457,
     427,   459,    -1,    38,   287,    -1,    37,    -1,    -1,   287,
      -1,    82,    -1,    94,    -1,    65,    -1,    75,   429,   431,
      23,   432,   128,    -1,    -1,   114,    -1,    28,    -1,   433,
     434,    -1,   434,    -1,    -1,    75,   434,   128,    -1,   434,
       7,   434,    -1,   434,    84,   434,    -1,     3,    75,   434,
     128,    -1,     4,    75,   434,    23,   434,   128,    -1,   436,
      -1,   439,    31,   435,    -1,   157,   436,    -1,    66,    -1,
      72,    -1,   112,    -1,    68,    -1,    70,    -1,   209,    -1,
     209,    31,   437,    -1,    31,   438,    -1,    -1,   438,    -1,
      95,    -1,   379,    -1,   442,    73,   441,   428,   160,   428,
     443,    -1,    -1,    -1,    74,    -1,    -1,   175,   279,   282,
     287,    -1,   442,    26,   445,   450,   160,   450,   446,    -1,
      -1,   160,   447,    -1,    18,   448,    -1,   450,    -1,   447,
     160,   450,    -1,   449,    -1,   448,    23,   449,    -1,   347,
     436,    -1,   428,    -1,   452,    22,   463,    -1,   455,   457,
     458,   389,   391,   459,   462,    -1,   442,   111,   457,   389,
     391,   459,    -1,   453,   454,    -1,    81,    -1,   297,    -1,
       9,    -1,   456,    -1,   281,    50,    -1,    78,    -1,   130,
      -1,   107,    -1,    88,    -1,    97,    -1,    -1,    75,   209,
     128,    -1,    -1,    83,    -1,    -1,    49,   460,    -1,   436,
     461,    -1,    28,   436,   461,    -1,    -1,    45,    -1,    -1,
       8,   209,    -1,   464,    -1,   463,   464,    -1,   465,   467,
     468,   469,   136,    -1,   436,   466,    -1,    -1,    75,    28,
     209,   128,    -1,    -1,    63,   430,   436,   122,    -1,    -1,
     146,    -1,   287,    -1,    -1,   155,   470,    -1,   436,   471,
      -1,   466,   467,    -1,    67,   472,    -1,   466,   467,    -1,
     114,   436,   466,   467,    -1,   127,   474,   475,    22,   478,
      -1,    -1,   167,    -1,    32,    -1,   476,   477,    -1,   207,
      -1,   207,   208,    -1,    -1,   160,   207,    -1,   160,   207,
     208,    -1,   436,   136,    -1,   478,   436,   136,    -1,   481,
     482,   287,    -1,   480,   482,   287,    -1,   115,    -1,   116,
      -1,    -1,    90,    -1,   428,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   521,   521,   524,   527,   530,   533,   536,   539,   542,
     545,   548,   551,   554,   560,   571,   578,   584,   588,   592,
     596,   600,   604,   619,   628,   628,   648,   648,   666,   668,
     672,   677,   679,   682,   688,   694,   700,   949,   954,   961,
     966,   972,  1014,  1022,  1030,  1040,  1044,  1050,  1056,  1062,
    1068,  1078,  1087,  1106,  1115,  1125,  1128,  1134,  1144,  1150,
    1153,  1156,  1159,  1178,  1193,  1199,  1205,  1211,  1217,  1226,
    1226,  1230,  1237,  1243,  1253,  1259,  1265,  1274,  1282,  1285,
    1291,  1297,  1302,  1308,  1314,  1342,  1348,  1351,  1357,  1386,
    1386,  1399,  1409,  1414,  1419,  1429,  1449,  1476,  1503,  1509,
    1515,  1521,  1532,  1538,  1557,  1578,  1598,  1610,  1626,  1637,
    1642,  1648,  1661,  1667,  1687,  1693,  1706,  1719,  1724,  1728,
    1732,  1738,  1741,  1747,  1751,  1751,  1756,  1814,  1832,  1837,
    1842,  1847,  1853,  1859,  1865,  1871,  1877,  1881,  1885,  1888,
    1891,  1900,  1906,  1918,  1924,  1931,  1937,  1943,  1947,  1952,
    1956,  1959,  1963,  1971,  1977,  1982,  2002,  2010,  2018,  2025,
    2037,  2043,  2049,  2055,  2074,  2080,  2086,  2092,  2098,  2120,
    2123,  2123,  2129,  2134,  2134,  2140,  2146,  2152,  2175,  2187,
    2195,  2198,  2201,  2220,  2225,  2231,  2236,  2244,  2255,  2294,
    2313,  2321,  2327,  2333,  2340,  2346,  2352,  2362,  2369,  2375,
    2381,  2390,  2395,  2403,  2409,  2420,  2430,  2435,  2449,  2467,
    2477,  2492,  2510,  2522,  2526,  2532,  2536,  2548,  2551,  2577,
    2582,  2590,  2595,  2604,  2609,  2616,  2622,  2631,  2637,  2643,
    2648,  2664,  2670,  2676,  2681,  2684,  2688,  2708,  2713,  2719,
    2724,  2729,  2734,  2740,  2749,  2768,  2790,  2884,  2891,  2898,
    2901,  2904,  2907,  2910,  2913,  2916,  2919,  2922,  2925,  2928,
    2931,  2934,  2937,  2940,  2943,  2946,  2949,  2952,  2955,  2958,
    2961,  2964,  2967,  2970,  2973,  2976,  2979,  2982,  2985,  2988,
    2991,  2994,  2997,  3000,  3003,  3006,  3017,  3030,  3042,  3061,
    3096,  3102,  3106,  3112,  3118,  3121,  3124,  3127,  3132,  3137,
    3143,  3149,  3156,  3159,  3166,  3174,  3183,  3190,  3193,  3199,
    3208,  3214,  3224,  3237,  3258,  3262,  3267,  3270,  3274,  3277,
    3320,  3324,  3328,  3331,  3335,  3344,  3350,  3356,  3363,  3366,
    3370,  3380,  3397,  3413,  3417,  3433,  3439,  3444,  3449,  3455,
    3459,  3467,  3474,  3481,  3484,  3487,  3490,  3497,  3500,  3503,
    3506,  3523,  3540,  3551,  3578,  3589,  3614,  3620,  3626,  3646,
    3651,  3656,  3659,  3663,  3666,  3670,  3673,  3686,  3714,  3726,
    3737,  3752,  3766,  3776,  3781,  3788,  3793,  3810,  3813,  3816,
    3830,  3839,  3843,  3850,  3857,  3864,  3870,  3881,  3894,  3904,
    3915,  3921,  3927,  3955,  3961,  3992,  4001,  4012,  4017,  4033,
    4060,  4108,  4113,  4117,  4132,  4153,  4158,  4171,  4176,  4182,
    4202,  4208,  4214,  4220,  4233,  4238,  4242,  4246,  4265,  4281,
    4300,  4341,  4359,  4372,  4391,  4394,  4397,  4401,  4408,  4413,
    4453,  4460,  4468,  4474,  4477,  4484,  4497,  4510,  4526,  4547,
    4554,  4566,  4577,  4589,  4601,  4609,  4614,  4626,  4636,  4646,
    4662,  4668,  4678,  4694,  4700,  4706,  4715,  4721,  4735,  4740,
    4757,  4764,  4770,  4775,  4780,  4784,  4790,  4795,  4800,  4805,
    4809,  4814,  4820,  4826,  4832,  4838,  4844,  4851,  4857,  4863,
    4870,  4877,  4883,  4889,  4901,  4911,  4917,  4923,  4929,  4936,
    4943,  4950,  4959,  4966,  4970,  4973,  4977,  4989,  4998,  5004,
    5012,  5019,  5026,  5033,  5040,  5047,  5053,  5059,  5066,  5072,
    5079,  5086,  5098,  5103,  5109,  5114,  5123,  5130,  5135,  5139,
    5144,  5154,  5161,  5167,  5172,  5180,  5183,  5193,  5196,  5204,
    5211,  5221,  5227,  5231,  5231,  5235,  5240,  5251,  5256,  5261,
    5269,  5275,  5281,  5290,  5302,  5308,  5314,  5317,  5320,  5323,
    5345,  5349,  5356,  5362,  5368,  5371,  5375,  5386,  5391,  5500,
    5503,  5507,  5506,  5587,  5590,  5594,  5597,  5667,  5673,  5678,
    5681,  5684,  5687,  5691,  5694,  5697,  5749,  5755,  5777,  5785,
    5808,  5812,  5818,  5821,  5825,  5833,  5844,  5876,  5890,  5897,
    5903,  5908,  5925,  5933,  5946,  5956,  5964,  5973,  5982,  5990,
    5998,  6007,  6013,  6020,  6028,  6038,  6055,  6061,  6069,  6077,
    6085,  6093,  6100,  6146,  6168,  6185,  6191,  6201,  6207,  6213,
    6218,  6224,  6231,  6237,  6240,  6245,  6248,  6270,  6277,  6282,
    6287,  6292,  6297,  6310,  6323,  6326,  6329,  6332,  6336,  6339,
    6343,  6359,  6396,  6404,  6411,  6426,  6436,  6443,  6446,  6453,
    6462,  6486,  6498,  6504,  6510,  6516,  6523,  6529,  6535,  6540,
    6546,  6552,  6565,  6571,  6584,  6589,  6595,  6600,  6611,  6614,
    6618,  6626,  6636,  6641,  6647,  6652,  6658,  6663,  6675,  6681,
    6686,  6691,  6709,  6717,  6723,  6731,  6738,  6742,  6747,  6754,
    6761,  6765,  6772,  6778,  6781,  6788,  6795,  6801,  6806,  6819,
    6830,  6835,  6839,  6846,  6853
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_1ARG_FUNC", "T_2ARG_FUNC",
  "T_2FNUMVAR", "T_ACCIDENTALS", "T_ADDSUB_OP", "T_ALIGN", "T_ALL",
  "T_ALT", "T_AMPERSAND", "T_AUTO", "T_BARSTLISTVAR", "T_BARTYPE",
  "T_BBOX", "T_BLOCKHEAD", "T_BM", "T_BULGE", "T_CENTS", "T_CLEF",
  "T_CLEFVAR", "T_COLON", "T_COMMA", "T_COMMON", "T_CUE", "T_CURVE",
  "T_CUT", "T_DASH", "T_DBLFLAT", "T_DIAM", "T_DOT", "T_DOWN", "T_DRUM",
  "T_EBM", "T_EM_BEGIN", "T_EM_END", "T_ENDENDING", "T_ENDING",
  "T_ENDSTYLE", "T_ENDTYPE", "T_EPH", "T_EQUAL", "T_ESBM", "T_EVERY",
  "T_EXCLAM", "T_FAMILY", "T_FFAMILY", "T_FIRSTPAGE", "T_FNUMVAR",
  "T_FONT", "T_FONTVAR", "T_GRACE", "T_GRIDS", "T_HAT", "T_HEADSHAPES",
  "T_HIDECHANGES", "T_HO", "T_HS", "T_KEY", "T_KEYMAP", "T_KEYMAPVAR",
  "T_LBRACE", "T_LBRACKET", "T_LEN", "T_LET", "T_LETTER", "T_LET_M",
  "T_LET_N", "T_LET_R", "T_LET_S", "T_LET_U", "T_LET_X", "T_LINE",
  "T_LINETYPE", "T_LPAREN", "T_LVAR", "T_LYRICS", "T_L_ANGLE",
  "T_L_DBLANGLE", "T_MEASNUM", "T_MIDI", "T_MNUM", "T_MODIFIER",
  "T_MULDIV_OP", "T_MULTIREST", "T_MULTIWHOLE", "T_MUSIC", "T_MUSSYM",
  "T_NEWLINE", "T_NL", "T_NONE", "T_NONNAT", "T_NOWHERE_SLIDE", "T_NUM",
  "T_NUMBER", "T_NUMVAR", "T_OCTAVE", "T_OPTSTRVAR", "T_ORDER",
  "T_ORIENTATION", "T_OTHERTEXT", "T_PAD", "T_PAGESIDE", "T_PAGESIZE",
  "T_PARAGRAPH", "T_PARATYPE", "T_PEDAL", "T_PEDSTAR", "T_PEDSTYLE",
  "T_PH", "T_PHRASE", "T_PITCH", "T_PLACE", "T_PLUS", "T_POSTSCRIPT",
  "T_PRINTTYPE", "T_PSVAR", "T_QUESTION", "T_RANGELISTVAR",
  "T_RATNUMLISTVAR", "T_RBRACE", "T_RBRACKET", "T_REHEARSAL", "T_REHTYPE",
  "T_REH_STYLE", "T_REPEATDOTS", "T_ROLL", "T_RPAREN", "T_RPT",
  "T_R_ANGLE", "T_R_DBLANGLE", "T_SCORE", "T_SCOREFEED", "T_SCOREPAD",
  "T_SCORESEP", "T_SEMICOLON", "T_SHARP", "T_SHORTEN", "T_SLASH",
  "T_SLASHMARK", "T_SLOPE", "T_SLUR", "T_STAFF", "T_STAFFLINES",
  "T_STANDARD", "T_STAR", "T_STEMOFFSET", "T_STRING", "T_STRVAR",
  "T_SWINGUNIT", "T_SYMBOL", "T_TAB", "T_TICKS", "T_TIE", "T_TIL",
  "T_TILDE", "T_TIME", "T_TIMEUNIT", "T_TITLE", "T_TO", "T_TRANSPOSE",
  "T_TUNINGTYPE", "T_TUNINGVAR", "T_UNITS", "T_UNITTYPE", "T_UNSET",
  "T_UP", "T_USEACCS", "T_VCOMBINE", "T_VCOMBVAL", "T_VISVAR", "T_VOICE",
  "T_VVAR", "T_WHEREUSED", "T_WITH", "T_XNOTE", "T_XPOS_INT", "T_YESNOVAR",
  "$accept", "song", "item", "context", "ssv_context", "$@1", "$@2",
  "ssv_stafflist", "ssv_staff_item", "ssv_sv_list", "ssv_sv_item",
  "alloc_ssv", "new_context", "blockhead_context", "music_context",
  "grid_context", "accidentals_context", "begin_acc_context",
  "acc_context_name", "acc_entry", "acc_name", "offsets_spec",
  "offsets_list", "acc_offset", "keymap_context", "stringpair",
  "headshape_context", "symbol_context", "staffnum", "voicenum", "num",
  "value", "assignment", "terminator", "assign", "$@3", "$@4", "visval",
  "opt_pageside", "measnumval", "vschemetype", "allocbeamlist",
  "ratnumlist", "nonempty_ratnumlist", "subbeam", "$@5", "time_item",
  "swing_time", "opt_rs", "alloc_rangelist", "rangelist", "rangelistA",
  "rangeitem", "rangetail", "grplabel", "optlabel2", "glabel",
  "alloc_barstlist", "barstlist", "barst_item", "repeatdots_value",
  "mark_order", "orderlist", "orderitem", "marktype", "timesig",
  "tsiglist", "$@6", "meas_tsig", "$@7", "fraction", "numerator",
  "numerator_value", "opt_ts_visibility", "opt_n", "keyspec",
  "useaccs_value", "useaccs_qual", "stafflinedef", "tab_string_list",
  "tab_item", "opt_str_acc", "opt_ticks", "flagval", "minscsep",
  "maxscsep", "minscpad", "maxscpad", "shorten_opts", "shorten_range",
  "pagesize", "orientation", "vcombine_value", "opt_vcombine_qualifier",
  "end_type", "updown", "majmin", "pedstyle", "transpose_interval",
  "title", "tfont", "title_font", "font_family", "title_size", "titleA",
  "paragraph", "opt_paratype", "paramname", "string", "music_input",
  "noteinfo", "init_staff", "sv_spec", "sv_map_list", "sv_map_entry",
  "map_start", "map_finish", "sv_map_item_list", "voice_id", "sv_and",
  "sv_item", "notecolon", "grp_stafflist", "grp_staff_item",
  "grp_staff_range", "voice_spec", "voice_tail", "groupinfo", "groupdata",
  "mid_meas_param", "mid_meas_list", "mid_meas_item", "mm_context",
  "mm_params", "mm_param_item", "grp_attributes", "styleinfo", "gtc",
  "extra_styleinfo", "alloc_grpsyl", "marklist", "marklistA", "markitem",
  "hor_offset", "opt_plus_or_minus", "other_attr", "attr_list",
  "attr_item", "alloc_marklist", "opt_dir", "opt_to_voice", "marks",
  "mark", "mark_item", "shorthand_mark", "notetype", "dir", "beammark",
  "time_val", "crossbeam", "basic_time_val", "opt_more_time",
  "more_time_item", "alloc_timelist", "opt_m", "dots", "padding",
  "padspec", "opt_minus", "group", "special_group", "extra_attr",
  "spec_grp_alloc", "extra_item", "note_opts", "notelist",
  "opt_other_staff", "css_with", "some_notes", "notedata", "notedata1",
  "opt_bend", "pitch", "opt_accidental", "opt_acc_list", "opt_octave",
  "acc_list", "begin_acc_list", "acc_list_tail", "note_acc", "acc_symbol",
  "octave", "minuslist", "pluslist", "slur_item", "start_slur", "slurlist",
  "fullslurlist", "slurnote", "grp_locsave", "loc_variable", "ntuplet",
  "printtup", "start_tuplet", "rbrace", "opt_side", "opt_time",
  "lyricinfo", "lyric_id", "lyr_opt_place", "opt_place", "ph_opt_place",
  "staff_list", "staff_item", "staff_range", "more_lyric_ids", "$@8",
  "verse_spec", "verselist", "verse_item", "verse_range",
  "alloc_lyr_grpsyl", "lyricdata", "lyr_tlist", "lyrics_timelist",
  "lyr_time_item", "lyr_tm", "lyrtuplet", "opt_space", "lyr_verse",
  "verse_string", "os_directive", "$@9", "opt_temp_margin", "temp_margin",
  "margin_override", "opt_equals", "opt_semi", "directive", "barinfo",
  "precbartype", "barline", "bartype", "emptymeas_input", "bar_items",
  "bar_opt", "ending_info", "chk_dup_reh", "rehearsal_mark", "location",
  "alloc_loc", "plus_or_minus", "xcoord", "ycoord", "coord_setup",
  "expression", "direction", "floatnum", "opt_decimal_part", "numstr",
  "variable", "line", "line_alloc", "linetype", "opt_line_str", "curve",
  "curve_alloc", "curve_tail", "loc_list", "bulgelist", "bulge_value",
  "curve_loc", "stuff_info", "stuff_header", "midi", "midi_staff",
  "stuff_id", "stuff_type", "opt_size", "opt_modifier", "opt_dist",
  "stuff_dist", "opt_exclam", "opt_align", "stufflist", "stuff_item",
  "beat_offset", "gracebackup", "steps_offset", "opt_string", "til_clause",
  "til_val", "til_suffix", "til_offset", "roll_cmd", "opt_roll_dir",
  "roll_extent", "roll_start", "roll_end", "roll_offsetlist", "printcmd",
  "postscript", "printtype", "opt_loc", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   179,   180,   180,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   182,   182,   182,   182,   182,
     182,   182,   182,   183,   184,   183,   185,   183,   186,   186,
     187,   188,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   200,   201,   201,   202,   202,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   212,   213,   213,   213,   213,   213,   213,   213,   214,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   215,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   216,   216,   216,   217,
     217,   218,   218,   218,   219,   219,   219,   220,   221,   221,
     222,   222,   222,   222,   224,   223,   225,   225,   226,   226,
     227,   227,   227,   227,   227,   228,   229,   229,   230,   230,
     231,   232,   232,   233,   233,   234,   234,   235,   236,   237,
     237,   237,   238,   239,   239,   240,   241,   241,   241,   242,
     243,   243,   243,   243,   243,   243,   243,   243,   244,   245,
     246,   245,   247,   248,   247,   249,   249,   249,   249,   249,
     250,   250,   251,   252,   252,   253,   253,   254,   254,   255,
     256,   256,   256,   256,   257,   257,   257,   257,   258,   258,
     259,   260,   260,   261,   261,   262,   262,   263,   264,   264,
     265,   266,   266,   267,   267,   268,   268,   269,   269,   270,
     270,   271,   271,   272,   272,   273,   273,   274,   274,   275,
     275,   276,   276,   276,   277,   278,   279,   280,   280,   281,
     281,   282,   282,   283,   283,   283,   284,   285,   285,   286,
     286,   286,   286,   286,   286,   286,   286,   286,   286,   286,
     286,   286,   286,   286,   286,   286,   286,   286,   286,   286,
     286,   286,   286,   286,   286,   286,   286,   286,   286,   286,
     286,   286,   286,   286,   286,   287,   287,   288,   289,   289,
     289,   290,   291,   291,   292,   292,   293,   294,   295,   296,
     296,   297,   297,   298,   299,   299,   300,   301,   301,   302,
     303,   303,   304,   304,   305,   305,   306,   306,   307,   307,
     308,   308,   309,   309,   310,   311,   311,   311,   312,   312,
     313,   313,   313,   314,   315,   315,   315,   316,   316,   317,
     317,   318,   319,   319,   320,   320,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   322,   322,   322,   323,
     323,   324,   324,   325,   325,   326,   326,   326,   326,   326,
     326,   326,   327,   328,   328,   329,   329,   330,   330,   331,
     332,   332,   333,   333,   333,   333,   334,   334,   334,   334,
     335,   335,   336,   336,   336,   337,   337,   338,   338,   339,
     339,   340,   340,   341,   342,   343,   343,   344,   344,   345,
     346,   347,   347,   348,   348,   349,   350,   351,   352,   352,
     352,   352,   352,   352,   352,   353,   353,   354,   355,   355,
     356,   357,   357,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   358,   358,   358,   358,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   360,   360,
     361,   362,   362,   363,   363,   364,   364,   365,   366,   367,
     367,   368,   368,   368,   368,   368,   368,   369,   369,   369,
     369,   369,   370,   370,   370,   371,   371,   372,   372,   373,
     374,   375,   375,   375,   376,   376,   377,   378,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   380,   381,   381,
     381,   381,   382,   383,   384,   384,   385,   385,   386,   387,
     388,   389,   389,   390,   390,   391,   391,   391,   392,   393,
     393,   393,   394,   395,   394,   396,   396,   397,   397,   398,
     399,   399,   400,   401,   402,   402,   403,   403,   404,   405,
     405,   406,   407,   407,   408,   408,   409,   409,   410,   410,
     410,   411,   410,   410,   412,   412,   413,   414,   414,   415,
     415,   416,   416,   417,   417,   418,   419,   419,   420,   421,
     422,   422,   423,   423,   424,   424,   424,   424,   424,   424,
     424,   424,   425,   425,   426,   427,   427,   427,   427,   428,
     429,   430,   430,   431,   432,   433,   434,   434,   434,   434,
     434,   434,   434,   434,   435,   435,   435,   435,   435,   436,
     436,   436,   437,   437,   438,   439,   440,   441,   442,   442,
     443,   443,   444,   445,   446,   446,   447,   447,   448,   448,
     449,   450,   451,   452,   452,   452,   453,   454,   454,   455,
     456,   456,   456,   456,   456,   456,   457,   457,   458,   458,
     459,   459,   460,   460,   461,   461,   462,   462,   463,   463,
     464,   465,   466,   466,   467,   467,   468,   468,   468,   469,
     469,   470,   471,   471,   472,   472,   473,   474,   474,   474,
     475,   476,   476,   477,   477,   477,   478,   478,   479,   479,
     480,   481,   482,   482,   482
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     0,     5,     0,     5,     1,     3,
       1,     1,     3,     2,     0,     0,     2,     1,     1,     3,
       0,     1,     3,     1,     2,     1,     2,     3,     3,     1,
       3,     2,     3,     1,     2,     1,     1,     1,     2,     2,
       1,     1,     4,     2,     4,     3,     5,     4,     4,     0,
       4,     4,     4,     5,     4,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     0,
       4,     3,     4,     4,     3,     3,     3,     5,     3,     3,
       3,     3,     3,     3,     9,     5,     1,     1,     1,     0,
       1,     1,     1,     2,     0,     1,     1,     0,     0,     1,
       1,     1,     3,     3,     0,     4,     4,     1,     0,     1,
       0,     2,     2,     1,     1,     0,     0,     1,     1,     3,
       3,     0,     2,     0,     4,     0,     2,     1,     0,     0,
       1,     3,     2,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       0,     3,     1,     0,     4,     1,     1,     3,     3,     1,
       1,     3,     1,     0,     1,     0,     1,     3,     3,     2,
       0,     1,     1,     1,     2,     2,     1,     4,     1,     2,
       4,     0,     1,     0,     1,     1,     1,     1,     0,     2,
       2,     0,     3,     0,     3,     0,     4,     1,     2,     0,
       1,     0,     2,     0,     1,     1,     1,     1,     1,     0,
       1,     1,     2,     1,     1,     6,     2,     0,     1,     0,
       1,     0,     3,     1,     2,     3,     7,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     4,     3,
       1,     0,     1,     1,     1,     2,     3,     1,     1,     1,
       3,     1,     3,     1,     1,     2,     1,     1,     3,     2,
       0,     2,     2,     4,     0,     2,     1,     2,     1,     5,
       0,     1,     1,     2,     4,     1,     1,     1,     1,     3,
       3,     3,     3,     2,     1,     4,     6,     0,     3,     0,
       4,     0,     0,     1,     1,     3,     3,     1,     1,     1,
       1,     3,     2,     2,     2,     2,     1,     1,     2,     0,
       1,     0,     1,     1,     3,     1,     3,     2,     2,     1,
       3,     3,     0,     0,     1,     0,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     0,     1,     0,     3,     1,
       1,     0,     2,     4,     0,     0,     1,     0,     2,     1,
       3,     0,     1,     1,     1,     2,     2,     0,     1,     3,
       2,     3,     2,     2,     1,     0,     2,     2,     0,     3,
       1,     0,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     5,     5,     3,
       5,     7,     5,     4,     6,     4,     5,     4,     0,     1,
       1,     0,     1,     0,     1,     0,     1,     3,     0,     0,
       2,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     5,
       1,     0,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     8,     0,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     4,     3,
       1,     0,     1,     0,     1,     1,     1,     3,     2,     0,
       2,     2,     0,     0,     5,     1,     1,     1,     3,     2,
       0,     2,     0,     2,     0,     1,     1,     2,     2,     3,
       1,     5,     0,     1,     1,     2,     2,     5,     2,     1,
       1,     0,     3,     1,     0,     2,     4,     1,     1,     0,
       1,     0,     1,     1,     1,     3,     0,     4,     2,     1,
       0,     4,     0,     2,     1,     2,     1,     1,     3,     3,
       3,     7,     2,     1,     0,     1,     1,     1,     1,     6,
       0,     1,     1,     2,     1,     0,     3,     3,     3,     4,
       6,     1,     3,     2,     1,     1,     1,     1,     1,     1,
       3,     2,     0,     1,     1,     1,     7,     0,     0,     1,
       0,     4,     7,     0,     2,     2,     1,     3,     1,     3,
       2,     1,     3,     7,     6,     2,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     0,     3,     0,     1,
       0,     2,     2,     3,     0,     1,     0,     2,     1,     2,
       5,     2,     0,     4,     0,     4,     0,     1,     1,     0,
       2,     2,     2,     2,     2,     4,     5,     0,     1,     1,
       2,     1,     2,     0,     2,     3,     2,     3,     3,     3,
       1,     1,     0,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,    40,     0,     0,   109,     0,     0,     0,
     240,     0,     0,     0,    38,    53,     0,     0,     0,   629,
     521,   651,     0,   646,     0,    37,   654,    13,     0,   655,
       0,   155,     0,   248,   653,     0,   700,   701,     0,     0,
       0,     0,     0,   687,   652,    35,   561,     0,     0,     0,
      35,     0,     0,   285,     0,     0,     0,     0,     0,   239,
       0,     0,     0,     0,     0,     0,     0,    35,     0,     0,
       0,     2,   571,    15,    16,    35,    17,    19,    11,     0,
      20,    10,    18,    21,     5,     0,     0,     6,     0,     7,
       0,    43,     8,     0,     0,   290,   571,     0,   582,   559,
     576,   560,   573,     0,     0,   656,   649,   574,   563,   702,
     702,    14,     0,     0,   148,   411,   110,    36,     0,     0,
       0,     0,     0,     0,     0,    51,   676,   522,     0,     0,
     520,     0,    57,   571,    63,   676,   411,     0,     0,     0,
     135,   117,     0,     0,   689,   688,     0,    34,   564,   411,
       0,     0,    24,     0,   411,     0,   128,    54,     0,    89,
     241,   237,     0,     0,     0,   258,   256,   284,   263,   283,
     259,   257,   282,   273,   281,   265,   249,   279,   271,   255,
     266,   270,   276,   264,   261,   269,   251,   260,   252,   278,
     254,   274,   253,   275,   280,   262,   272,   268,   277,   267,
     250,    88,     0,    69,     0,    26,     0,     0,     1,     3,
     572,     4,    22,     0,   460,     0,    45,     0,    61,    60,
      59,     0,   650,   239,     0,     0,   287,   297,   310,    55,
       0,   293,   294,     0,   292,   301,   304,   307,     0,     9,
     558,   633,   627,   628,   656,     0,     0,   648,   647,   645,
       0,   658,   600,   703,   704,     0,     0,     0,   619,     0,
      39,    41,   149,   412,     0,     0,    84,   226,   225,    94,
      83,   109,    65,    82,     0,    78,   461,   677,   678,   102,
     542,   526,   529,   532,   525,     0,   111,   112,    87,   289,
       0,   100,     0,     0,   231,   233,    96,   103,   217,   219,
       0,   136,   118,    95,   153,   154,    76,   691,     0,   693,
      23,   562,   211,     0,   207,   208,   213,     0,   196,   185,
      81,     0,    99,   127,   399,   400,   129,    91,   407,   176,
     175,   179,   182,    80,   170,   169,   172,     0,   180,     0,
       0,     0,   238,   236,   228,   227,     0,   101,    98,   205,
     206,    79,   190,   221,   107,   108,   106,    86,     0,   114,
      85,   602,   601,    44,     0,    49,    42,     0,    46,   165,
     164,   163,   160,   161,   162,   167,   166,    77,   156,   159,
     241,   286,    52,     0,   309,   306,   320,   295,     0,   299,
     303,     0,     0,   314,    56,   305,    12,   593,     0,     0,
     587,     0,     0,     0,   411,   594,   584,   583,   586,     0,
       0,     0,   521,   579,   575,   580,   672,   642,   668,   674,
       0,   659,   521,   605,   699,   698,   624,   621,   622,     0,
     141,    75,   150,   411,    58,    64,   478,   481,   479,   480,
     477,   229,   229,   462,   512,   542,   395,   518,     0,   542,
     546,     0,   550,     0,     0,   528,     0,   519,   113,    62,
      71,   232,   220,    68,   218,   141,    74,   137,   138,   124,
     130,   119,   121,   120,   692,     0,     0,   690,   569,   565,
     411,    93,   210,     0,    92,     0,    67,    34,    28,    30,
       0,   195,   186,   194,   411,   401,     0,   168,   184,   173,
       0,     0,    90,     0,   571,   243,   234,     0,   192,   191,
     193,   189,    70,   223,    34,    31,     0,   116,   115,    72,
       0,     0,    47,     0,     0,     0,   311,     0,   320,   316,
     341,   321,   322,   318,   320,   298,     0,   296,   302,   308,
       0,     0,   312,   592,   498,   500,   504,   501,   502,   503,
     505,   506,   499,   585,     0,     0,     0,     0,   239,   641,
       0,     0,     0,     0,   578,     0,   671,   669,     0,   676,
     657,     0,     0,     0,   620,   623,    66,     0,   152,     0,
       0,   230,   187,   188,   542,   396,   552,     0,     0,   543,
     554,   547,   548,   531,   530,   527,     0,   143,     0,     0,
     134,   133,    73,     0,     0,   686,   694,   570,   359,     0,
     209,   215,    25,     0,     0,   198,   201,   105,   408,   405,
     171,     0,   178,   181,   177,   242,     0,   244,    97,   224,
     222,    27,     0,    33,    48,    50,   158,   157,   571,   325,
     326,   327,     0,   317,   341,   431,   395,   334,   323,   320,
     300,   315,   314,   589,   588,   590,   410,   237,     0,     0,
     577,   660,   291,     0,     0,   679,   660,     0,     0,     0,
       0,     0,   625,   603,   611,     0,   142,   151,   411,   513,
       0,   553,   549,   536,   540,     0,   535,   537,   556,   555,
     533,     0,   140,   139,     0,   131,   132,   123,   122,   696,
       0,   695,     0,   360,   212,   411,   214,    29,   197,   199,
     203,   202,   406,   402,   126,   404,   174,   235,   245,    32,
       0,     0,     0,     0,     0,   328,     0,   342,   361,   414,
     425,     0,   413,   428,   333,   514,   313,   656,     0,   630,
       0,   644,     0,     0,     0,     0,     0,   666,     0,   604,
       0,     0,     0,   613,     0,     0,     0,     0,   516,     0,
     539,     0,     0,     0,   145,   147,   125,   697,   568,   566,
     567,     0,   204,   465,     0,   246,     0,     0,     0,   324,
       0,   341,   386,   388,   391,     0,   411,   387,   359,     0,
       0,     0,   390,   372,   389,     0,   343,   344,   348,   350,
     349,   409,   347,     0,   397,   394,   369,   393,   523,   411,
     373,   373,     0,   362,   363,   365,   415,     0,     0,     0,
     490,   418,   373,   416,   424,   491,   438,   443,   440,   439,
     434,   435,     0,     0,   441,   442,   437,   444,   430,   427,
     431,   425,   433,   458,   515,     0,     0,   411,     0,   632,
     239,   626,     0,   664,   661,   581,   673,   675,   672,   680,
     670,     0,   643,   599,     0,     0,   606,   607,   608,   614,
     617,   618,   615,   616,   612,   411,     0,   551,   541,     0,
     538,   534,     0,     0,   411,   485,   487,   482,   200,   466,
     483,   484,   407,   330,   331,   332,   329,   335,   497,     0,
     357,   356,   352,     0,   353,   354,   355,     0,   337,     0,
     367,     0,   392,   524,   368,     0,   375,   374,   375,   319,
       0,   426,   420,   422,   465,   423,   375,   492,   465,     0,
     493,   494,   436,     0,     0,   432,   468,   465,   459,   446,
     203,     0,   463,   508,   598,   596,   597,   595,   660,     0,
     635,   638,   634,   636,   241,   664,   665,   662,   672,   674,
     681,   667,   609,     0,   104,   517,   557,   146,   144,   216,
     486,   488,   403,   351,   358,   383,   382,   385,   384,   381,
     346,   377,   379,   380,     0,   339,   345,     0,   366,     0,
     370,   371,   364,   421,   419,   496,   373,   495,   445,   429,
     449,     0,     0,     0,   458,   465,   472,   475,     0,   473,
     474,   471,   469,   468,   458,   464,   511,   509,   510,   516,
     591,   640,   411,     0,     0,   663,     0,   674,   683,   682,
       0,     0,     0,   336,   398,     0,   375,   465,   458,     0,
     453,     0,   458,     0,   467,   457,     0,   455,     0,   639,
     637,   631,   672,   684,   610,   378,   338,   342,   376,   489,
     447,   448,   458,   452,     0,   450,   476,   470,   456,   507,
     674,     0,   454,   458,   685,   340,   451
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    70,    71,    72,    73,   317,   358,   487,   488,   514,
     515,   310,   147,    74,    75,    76,    77,   113,   260,    78,
      79,   215,   216,   363,    80,    81,    82,    83,   228,   393,
     258,   264,    84,   220,    85,   353,   339,   357,   117,   288,
     519,   302,   470,   471,   472,   599,   473,   327,   602,   301,
     466,   467,   468,   578,   692,   883,   764,   262,   431,   432,
     306,    86,   377,   378,   379,   333,   334,   496,   335,   621,
     336,   337,   338,   497,   493,   275,   351,   511,   320,   614,
     615,   710,   773,   352,   315,   484,   312,   481,   486,   706,
     299,   463,   512,   630,   269,   346,   582,   296,   507,    87,
     160,   343,   161,   341,   504,    89,    90,   201,   938,    92,
      93,    94,   230,   231,   232,   233,   537,   388,   234,   391,
     235,   386,   236,   237,   384,   395,   542,   528,   529,   530,
     531,   532,   642,   724,   725,   645,   646,   985,  1033,   647,
     795,   796,   797,   902,   702,   812,   813,   814,   907,   916,
     990,   980,   981,   982,   983,   798,   917,   815,   586,   912,
     328,   619,   713,   774,   714,   495,   800,   801,   265,   728,
     729,   730,   731,   921,   816,   732,   839,   840,   733,   841,
     842,   939,   843,   442,  1014,   888,   940,   941,  1044,  1012,
     441,   889,   890,   891,   824,   825,   929,   930,   931,   802,
     672,   533,  1019,   445,   680,   845,   877,    95,   128,   129,
     130,   914,   283,   284,   455,   457,   763,   685,   686,   687,
     760,   446,   447,   448,   449,   450,   451,   452,   682,   589,
     590,    96,   148,   311,   479,   769,   608,   211,    97,    98,
     245,   414,   415,   564,   240,   407,   408,   558,   948,   559,
     423,   364,   572,   748,   573,   673,   874,   674,   574,   427,
     675,    99,   410,   100,   851,   101,   409,   849,   952,   950,
     951,   560,   102,   103,   104,   249,   105,   106,   251,   422,
     741,   854,   957,   862,   417,   418,   419,   566,   569,   279,
     746,   859,   960,  1028,   107,   146,   308,   309,   477,   605,
     108,   109,   110,   255
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -909
static const yytype_int16 yypact[] =
{
    1148,   -14,   141,  -909,   182,   233,   101,   298,   314,   367,
    -909,   394,   407,   504,  -909,  -909,   511,   355,   517,  -909,
     457,  -909,   532,  -909,   480,  -909,  -909,  -909,   537,  -909,
     538,  -909,   540,  -909,  -909,   543,   546,  -909,   550,   551,
     552,   553,   554,     9,  -909,  -909,  -909,   556,   558,   559,
    -909,   560,   561,  -909,   562,   564,   355,   565,   566,   575,
     567,   569,   570,   799,   581,   584,   587,  -909,   588,   589,
     979,  -909,   498,  -909,  -909,  -909,  -909,  -909,  -909,    41,
    -909,  -909,  -909,  -909,  -909,   109,   590,  -909,   585,  -909,
     531,   -19,  -909,   548,   287,  -909,   498,   555,  -909,  -909,
     257,  -909,  -909,   616,    62,   568,  -909,  -909,  -909,   162,
     162,  -909,   179,   355,  -909,   611,  -909,  -909,   620,   461,
     595,   480,   179,   596,     8,   533,   418,  -909,   623,   193,
    -909,   329,  -909,   498,   205,   418,   611,    48,   355,   446,
    -909,  -909,   524,    35,  -909,  -909,   480,  -909,  -909,   611,
     480,   179,  -909,   -29,   611,   355,   313,   533,   324,  -909,
     574,   600,    20,   489,   487,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,   337,  -909,    -9,  -909,   480,   337,  -909,  -909,
    -909,  -909,  -909,    45,  -909,   571,   542,    45,  -909,  -909,
    -909,   429,  -909,   575,   507,   323,  -909,  -909,   628,  -909,
     635,   599,  -909,   480,   648,  -909,   104,  -909,   576,  -909,
     277,  -909,  -909,   593,   568,   649,   179,  -909,   648,  -909,
     480,   586,  -909,  -909,  -909,   355,   355,   573,   633,   647,
    -909,   533,   480,  -909,   650,   480,  -909,  -909,  -909,  -909,
    -909,   101,  -909,  -909,   190,  -909,   190,  -909,   533,  -909,
      25,  -909,   499,   651,  -909,   480,  -909,  -909,  -909,  -909,
     480,  -909,   179,   572,  -909,  -909,  -909,   533,  -909,   577,
     480,   480,   371,  -909,  -909,  -909,  -909,   480,   653,   512,
    -909,   629,   656,   480,  -909,   658,   659,   480,   608,   270,
    -909,   661,   533,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,   292,   578,  -909,   345,  -909,   313,
     480,   355,  -909,  -909,  -909,  -909,   508,  -909,  -909,  -909,
    -909,  -909,    54,   480,  -909,  -909,  -909,  -909,   480,    51,
    -909,  -909,  -909,  -909,   179,   547,  -909,    45,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,   433,  -909,  -909,
     574,  -909,  -909,   480,  -909,  -909,   453,  -909,   375,   648,
    -909,   480,   480,   519,  -909,  -909,  -909,  -909,   355,   549,
    -909,   645,   646,   652,   611,  -909,  -909,  -909,  -909,   614,
     614,   676,   457,  -909,  -909,  -909,   618,   179,  -909,   632,
     579,  -909,   457,  -909,   533,   533,  -909,  -909,   573,   179,
     668,   674,  -909,   611,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,   521,   521,  -909,  -909,   637,   313,  -909,     6,   160,
    -909,   582,  -909,   480,   480,  -909,   480,   583,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,   668,  -909,   677,  -909,  -909,
     454,   678,  -909,  -909,  -909,   179,   480,  -909,   660,  -909,
     611,  -909,  -909,   480,  -909,   179,  -909,   648,  -909,   680,
     542,  -909,  -909,  -909,   611,   673,   324,  -909,  -909,  -909,
     427,   480,  -909,   580,   498,   -19,  -909,   480,  -909,  -909,
    -909,  -909,  -909,   535,   648,  -909,   104,  -909,  -909,  -909,
     687,   179,  -909,   429,   429,   355,  -909,   -42,    19,  -909,
     654,   630,  -909,  -909,   453,  -909,   480,  -909,  -909,  -909,
     480,   480,  -909,   533,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,   355,   480,   480,   179,   575,  -909,
     563,   594,   592,   193,   675,   683,  -909,  -909,   197,   418,
    -909,   193,   689,   318,  -909,  -909,  -909,   480,  -909,   480,
     690,  -909,  -909,  -909,   243,  -909,   655,   426,   158,     6,
    -909,  -909,  -909,  -909,  -909,  -909,   602,   657,   480,   371,
     663,   662,  -909,   371,   591,   179,   480,  -909,   197,   480,
    -909,   698,  -909,   480,   154,  -909,   190,  -909,  -909,   133,
     578,   324,  -909,  -909,  -909,  -909,   640,   -19,  -909,  -909,
    -909,  -909,   480,  -909,  -909,  -909,  -909,  -909,   326,  -909,
    -909,  -909,    16,  -909,   694,   211,   313,  -909,  -909,   225,
     648,  -909,   701,   533,  -909,  -909,  -909,   600,   614,   614,
    -909,   368,   460,   480,   179,   598,   368,   318,   664,   667,
     318,   179,  -909,   157,  -909,   699,  -909,  -909,   611,  -909,
     480,  -909,  -909,  -909,   706,   622,   713,  -909,  -909,  -909,
    -909,   355,  -909,  -909,    39,  -909,  -909,  -909,  -909,  -909,
     609,  -909,   239,  -909,  -909,   611,  -909,  -909,  -909,  -909,
     603,  -909,  -909,  -909,  -909,  -909,  -909,  -909,   533,  -909,
     669,   696,   704,   705,   412,  -909,   626,   438,    75,  -909,
    -909,   219,  -909,   138,  -909,   636,  -909,   568,    22,   597,
     334,  -909,   721,   631,   638,   179,   627,   754,   639,   157,
     318,   318,    38,  -909,   318,   318,   348,   741,   742,   480,
    -909,   355,   480,   193,   743,   533,  -909,  -909,  -909,  -909,
    -909,   745,  -909,   120,   449,  -909,   750,   480,   337,  -909,
      16,  -909,  -909,  -909,  -909,   549,   611,  -909,   210,   355,
     179,   480,  -909,  -909,  -909,   665,   641,  -909,  -909,  -909,
    -909,  -909,  -909,   480,   601,  -909,  -909,  -909,   666,   611,
      21,    21,   644,   748,  -909,  -909,   219,   549,    -7,   355,
    -909,  -909,    21,  -909,  -909,   395,  -909,  -909,  -909,  -909,
    -909,  -909,   703,   542,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,   414,  -909,   480,     2,   611,   614,  -909,
     575,  -909,   179,   729,  -909,  -909,  -909,  -909,   496,  -909,
    -909,   480,  -909,  -909,    53,   279,  -909,   691,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,   611,   313,  -909,  -909,   336,
    -909,   651,   355,   670,   611,  -909,  -909,  -909,  -909,  -909,
     755,   671,  -909,  -909,  -909,  -909,  -909,  -909,  -909,   480,
     181,   204,  -909,   179,   533,  -909,  -909,   116,   751,   438,
    -909,   643,  -909,  -909,  -909,   179,   624,  -909,   624,  -909,
      75,  -909,  -909,  -909,   120,   533,   624,  -909,   120,   672,
     542,  -909,  -909,   679,   352,   219,   214,   221,   533,  -909,
     603,    32,   164,   308,  -909,  -909,  -909,   533,   739,   179,
     767,  -909,   634,  -909,   574,   729,  -909,  -909,   269,   632,
    -909,  -909,  -909,   318,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,   673,  -909,  -909,  -909,  -909,  -909,  -909,   533,
     768,  -909,  -909,  -909,   761,  -909,  -909,   682,  -909,   621,
    -909,  -909,  -909,  -909,  -909,  -909,    21,  -909,  -909,  -909,
    -909,   681,   685,   120,   355,   282,  -909,  -909,   355,  -909,
    -909,  -909,  -909,   542,   355,  -909,  -909,  -909,  -909,   742,
    -909,  -909,   611,   614,   355,  -909,   179,   632,  -909,  -909,
      67,   116,   765,   734,  -909,   480,   624,   120,   355,   686,
    -909,   214,   355,   378,    32,  -909,   688,  -909,   692,  -909,
    -909,   533,   618,  -909,  -909,  -909,  -909,   438,  -909,  -909,
    -909,  -909,   355,  -909,   697,  -909,  -909,  -909,  -909,  -909,
     632,   684,  -909,   355,  -909,  -909,  -909
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -909,  -909,   730,  -909,  -909,  -909,  -909,  -909,   186,  -909,
     169,  -233,   441,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -181,  -909,  -909,  -909,  -909,  -124,  -281,
     -22,  -149,  -909,  -909,  -909,  -909,  -909,  -909,   534,  -909,
    -909,  -909,  -909,   209,   200,  -909,  -148,  -909,  -909,  -909,
    -909,  -909,   212,   346,  -909,  -909,   -67,  -909,  -909,   238,
    -909,  -909,  -909,    49,  -909,  -909,  -909,  -909,   322,  -909,
     201,  -909,   327,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
     216,  -909,  -114,  -192,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,   382,  -909,  -909,  -909,
    -217,   174,    10,  -371,  -909,  -909,  -909,  -909,     0,   170,
    -909,  -909,  -909,  -909,   604,  -909,  -909,  -909,   -84,   -81,
     442,  -909,  -293,   444,  -909,  -319,   185,   300,  -481,  -909,
    -909,   309,  -909,  -909,    63,  -909,  -909,  -909,  -909,  -602,
    -215,  -909,   -65,  -909,    61,  -909,  -909,   -69,  -909,  -776,
    -840,  -909,  -179,  -909,  -909,  -909,  -704,  -909,   207,  -909,
      82,  -909,  -909,  -909,  -909,   -35,  -909,   619,  -133,  -909,
    -909,  -909,  -909,   131,    23,  -909,  -909,  -909,    26,  -909,
      30,  -569,   -75,  -909,  -909,  -831,  -853,  -909,  -909,  -177,
    -262,  -811,  -909,  -909,  -909,  -909,  -909,  -909,   -62,  -909,
    -378,  -909,  -909,  -357,   220,  -909,  -154,  -909,  -909,  -909,
      29,  -909,  -532,   415,  -909,  -909,  -909,  -909,  -909,   108,
    -909,  -909,  -909,  -909,   428,  -395,  -909,  -909,  -909,  -909,
     283,  -909,  -909,  -909,  -909,  -909,  -909,   -78,  -909,  -909,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,   -98,
    -909,  -540,  -909,  -909,  -909,  -640,  -909,   -74,  -909,   448,
    -909,  -909,  -909,   642,  -909,  -909,  -909,  -909,  -909,  -909,
    -144,  -645,  -909,  -909,  -909,  -909,  -909,  -909,  -237,  -909,
    -641,  -909,   -72,  -909,  -909,   463,  -909,  -825,  -908,  -116,
    -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,  -909,
    -909,  -909,  -909,   764
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -629
static const yytype_int16 yytable[] =
{
      91,   290,   133,   292,   217,   321,   380,   412,   326,   525,
      88,   254,   254,   738,   443,   360,   313,   125,   238,   291,
     248,   553,   307,   799,   489,   747,   474,   749,   664,   534,
     752,   661,   942,   959,   513,   918,   368,   721,   259,   666,
     847,   144,   727,  1006,   304,   754,   926,   643,   272,   276,
     213,  1029,   344,   784,   591,   289,   157,   354,   293,   355,
     754,  1007,   603,   508,   300,   516,   132,   944,   703,   587,
      91,   247,   229,   361,   754,   111,   257,   316,   991,   715,
      88,   444,   229,  1001,   945,   803,   994,   444,  -544,  1015,
     639,   225,   804,   993,  1008,   224,   946,   995,   527,   271,
    1009,   640,   274,   132,  1010,   214,  1004,   282,  -288,   805,
     864,   865,   722,   261,   867,   868,   806,   517,   807,  1053,
     214,   294,   755,   318,   229,  1002,   278,   392,   314,    53,
     641,   319,   923,  1027,   325,   278,   332,   755,   297,   365,
     132,   367,   498,   365,   975,   509,   510,   976,   885,   389,
      53,   755,   826,   214,    53,   322,   295,   132,   827,   362,
    1046,   361,  1074,   518,   754,   356,   866,   766,   643,  1011,
     977,   534,   416,  -544,  1042,  -468,   145,   534,   828,   897,
     305,   962,   848,   112,   359,   808,   522,   345,   792,   591,
     829,   502,  1039,  -468,   723,  1054,  1059,   633,   218,   132,
     712,   436,   281,   953,   116,   799,  1060,   830,   831,   832,
     257,   229,  -602,   833,   394,   132,   809,   810,   460,   437,
    1036,   651,   444,  -545,   114,   361,  -468,  1070,   420,   811,
    1064,   881,  -468,   263,   886,  -601,  -468,   252,   900,  1013,
     430,   755,   885,   434,   834,   219,   978,   362,   703,   885,
     214,   768,   253,  -417,   612,   424,   425,   835,   438,   526,
     652,   817,   439,   458,    53,  -417,   214,   836,   459,  -417,
     257,   557,   224,   818,   132,   115,  -602,   819,   464,   465,
     325,   631,   708,   241,   580,   394,   754,   444,   132,  -417,
     520,   482,   534,   365,   688,   229,  1003,   820,   585,  -601,
    -411,  -468,   963,   491,   527,   444,   837,  1020,  -545,   132,
     885,   362,   561,   838,   397,   398,   132,   325,   503,   399,
     489,   668,   669,  1030,   901,   701,   214,   440,   886,  -417,
     242,   394,   243,   400,   132,   886,   229,   821,   492,   516,
     118,   505,   401,   416,   565,   617,   679,   609,   329,   257,
     227,   330,   606,   799,   711,   576,   119,  1041,   349,   402,
     350,   229,   852,   755,   679,   257,   826,  -417,   244,   229,
     229,   403,   827,   285,  1016,   822,  1017,   132,  1050,   404,
     323,  -183,   132,  1026,   544,   545,   546,   547,   548,   549,
     550,   456,   828,   670,   551,   286,   886,   287,   543,   324,
     405,   604,  1018,   349,   829,   350,   613,   898,   132,   120,
     331,   611,   382,   132,   869,   616,   870,   740,   871,   132,
     872,   830,   831,   832,   325,  -468,   626,   833,  -183,   132,
     552,   593,   594,   632,   282,  1040,   121,   224,   323,   922,
     224,   563,   885,  -468,   523,  1047,   469,   635,   588,   122,
     224,   571,   650,   665,   229,   698,   524,   324,   834,   500,
     873,   610,   210,   782,   214,   999,   132,   369,   783,  1061,
     784,   835,   966,  1065,   332,   671,  -468,   267,   332,   624,
     785,   836,  -468,   656,   501,   628,  -468,   786,   927,   936,
     787,   152,   224,  1072,   394,   788,   789,   535,   585,  1066,
     846,   268,   790,    53,  1076,   627,   370,   214,   205,   132,
     453,   536,   371,   622,   229,   444,   212,   372,   394,   394,
     837,   132,   132,   600,   601,   638,   373,   454,   886,   757,
     374,   700,   527,   654,   655,   324,   375,    20,   683,   616,
     404,   282,   540,   779,   132,    24,   123,   541,   780,   282,
     298,  -468,   376,   124,   653,   676,   771,   430,   214,   126,
     720,   739,    53,   958,   277,   684,    53,   937,   657,   278,
     127,   565,   636,   637,   131,   132,   465,   325,   791,   134,
     135,   325,   136,  1024,   394,   137,   895,   704,   138,   588,
     744,   229,   139,   140,   141,   142,   143,   753,   149,   332,
     150,   151,   153,   154,   155,   792,   156,   158,   159,   162,
     229,   163,   164,   793,   794,   544,   545,   546,   547,   548,
     549,   550,    10,   202,   325,   551,   203,   718,   770,   204,
     206,   207,   221,   954,   210,   222,   223,   226,   246,   263,
     266,   743,   270,   250,   239,   280,   273,   224,   303,   340,
     342,   347,   348,   899,   214,   381,   383,   385,   758,   390,
     366,   552,   227,   413,   428,   396,   853,    19,   426,   421,
     429,   858,   476,   433,   456,   475,   915,   462,   478,   480,
     461,   483,   485,   490,   494,   506,   521,   554,   555,   252,
     562,   765,   499,   565,   556,   568,   577,   579,   581,   444,
     598,   603,   607,   392,   618,   629,   634,   570,   625,   527,
     662,   663,   667,   678,   949,   690,   905,   644,   592,   596,
     660,   705,   726,   658,   540,   681,   964,   699,   965,   717,
     756,   696,   691,   695,   759,   969,   762,   878,   776,   750,
     684,   282,   751,   924,   761,   767,   777,   778,   781,   844,
     928,   887,   325,   745,   659,   894,   772,   855,   775,   856,
     857,   879,   861,   860,   875,   876,   882,   863,   884,   906,
     893,   920,   850,   932,   956,   755,   911,   909,   955,   913,
     919,   910,   984,   970,   989,   971,   987,   908,   740,   904,
    1022,  1031,  1032,  1035,  1023,  1034,  1056,  1057,   968,   707,
     209,   719,   996,   697,   165,   435,  1075,   998,   694,  1037,
     693,   597,   166,  1038,  1062,   967,  1068,   677,   620,   925,
     167,   887,   716,   943,   583,  1073,  1005,   623,  1069,   974,
     709,   737,   742,   538,   649,   387,   539,   736,   168,   961,
     648,   988,  1071,   896,   986,   169,   947,   170,   171,   903,
     172,   992,  1055,   734,   325,   928,   892,   972,   173,   406,
     174,  1000,   823,   933,   935,  1048,   934,  1067,   997,   735,
     880,   595,   689,   584,   256,  1021,   575,   973,  1049,   175,
     567,     0,   765,  1025,     0,   411,     0,     0,     0,   949,
       0,     0,     0,     0,     0,   176,     0,   177,   178,     0,
       0,   179,   887,     0,     0,     0,   887,   979,   180,     0,
       0,     0,     0,     0,   887,   887,     0,     0,   181,   182,
       0,     0,     0,     0,   183,   184,     0,     0,     0,     0,
       0,     0,     0,   185,   186,     0,     0,   187,  1045,     0,
       0,     0,     0,   188,     0,     0,     0,     0,   189,   190,
       0,     0,  1052,     0,     0,     0,   191,   192,     0,     0,
     193,     0,   194,   195,     0,     0,  1063,   196,   197,     0,
     198,     0,   199,     0,     0,     0,     0,   200,     0,   208,
       1,   887,     0,   887,     2,     3,     0,     0,     0,     0,
       0,     0,     4,  -628,     5,     6,     0,     0,     0,     0,
       7,     0,     0,     0,     0,  -628,     0,     0,  1043,     0,
       0,     0,     0,  1058,     0,   887,     0,     0,     8,   887,
       0,     0,     0,     0,  1051,     9,    10,    11,    12,  -239,
      13,   979,    14,     0,    15,     0,     0,     0,    16,    17,
      18,     0,  -291,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -628,    19,  -628,     0,    20,    21,     0,    22,
      23,     0,     0,     0,    24,     0,    25,    26,    27,     0,
       0,     0,     0,     0,  -291,    28,    29,    30,    31,     0,
       0,    32,     0,     0,  -247,    33,    34,     0,    35,     0,
    -628,     0,     0,     0,    36,    37,    38,     0,    39,    40,
       0,     0,     0,     0,    41,    42,    43,     0,     0,    44,
       0,    45,    46,    47,    48,     0,     0,    49,     0,     0,
       0,     0,    50,    51,     0,     0,    52,    53,    54,    55,
      56,     0,     0,     0,     0,     0,    57,    58,    59,     0,
      60,     0,    61,    62,     0,    63,     0,    64,    65,     1,
      66,    67,    68,     2,     3,     0,     0,    69,     0,     0,
       0,     4,  -628,     5,     6,     0,     0,     0,     0,     7,
       0,     0,     0,     0,  -628,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     8,     0,     0,
       0,     0,     0,     0,     9,    10,    11,    12,  -239,    13,
       0,    14,     0,    15,     0,     0,     0,    16,    17,    18,
       0,  -291,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -628,    19,  -628,     0,    20,    21,     0,    22,    23,
       0,     0,     0,    24,     0,    25,    26,    27,     0,     0,
       0,     0,     0,  -291,    28,    29,    30,    31,     0,     0,
      32,     0,     0,  -247,    33,    34,     0,    35,     0,  -628,
       0,     0,     0,    36,    37,    38,     0,    39,    40,     0,
       0,     0,     0,    41,    42,    43,     0,     0,    44,     0,
      45,    46,    47,    48,     0,     0,    49,     0,     0,     0,
       0,    50,    51,     0,     0,    52,    53,    54,    55,    56,
       0,     0,     0,     0,     0,    57,    58,    59,     0,    60,
       0,    61,    62,     0,    63,     0,    64,    65,     0,    66,
      67,    68,     0,     0,     0,     0,    69
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-909))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       0,   134,    24,   136,    79,   154,   223,   244,   156,   380,
       0,   109,   110,   658,   276,   207,   149,    17,    96,   135,
     104,   399,   146,   727,   317,   666,   307,   667,   568,   386,
     670,   563,   843,   858,   353,   811,   217,    21,   112,   571,
      18,    32,   644,    11,     9,     7,   822,   528,   122,   124,
       9,   959,    32,    32,   449,   133,    56,    66,    10,    68,
       7,    29,    23,     9,   139,   358,    95,    65,   608,    63,
      70,     9,    94,    28,     7,    89,    31,   151,   918,   619,
      70,    62,   104,   936,    82,    10,   926,    62,    63,   942,
     132,    91,    17,   924,    62,   114,    94,   928,    79,   121,
      68,   143,   124,    95,    72,   112,   937,   129,    89,    34,
     750,   751,    96,   113,   754,   755,    41,    66,    43,  1027,
     112,    73,    84,   152,   146,   936,   126,    23,   150,   148,
     172,   153,   139,   958,   156,   135,   158,    84,   138,   213,
      95,   216,   334,   217,    28,    91,    92,    31,    28,   233,
     148,    84,    14,   112,   148,   155,   108,    95,    20,   114,
    1013,    28,  1070,   112,     7,   174,   128,   128,   649,   137,
      54,   528,   246,   148,  1005,    11,   167,   534,    40,   781,
     145,   128,   160,    42,   206,   110,   367,   167,   167,   584,
      52,   339,  1003,    29,   178,   128,  1036,   516,    89,    95,
      67,    11,     9,   848,   103,   909,  1037,    69,    70,    71,
      31,   233,    31,    75,   236,    95,   141,   142,   292,    29,
     996,   540,    62,    63,    42,    28,    62,  1052,   250,   154,
    1041,   763,    68,    28,   114,    31,    72,    75,    28,    75,
     262,    84,    28,   265,   106,   136,   130,   114,   788,    28,
     112,    12,    90,    42,   487,   255,   256,   119,    68,   383,
     541,    42,    72,   285,   148,    54,   112,   129,   290,    58,
      31,   404,   114,    54,    95,    42,    95,    58,   300,   301,
     302,   514,   128,    26,   433,   307,     7,    62,    95,    78,
     364,   313,   649,   367,   136,   317,    75,    78,   446,    95,
      95,   137,    23,    33,    79,    62,   168,   948,   148,    95,
      28,   114,   410,   175,    37,    38,    95,   339,   340,    42,
     613,     3,     4,   963,   114,   606,   112,   137,   114,   118,
      73,   353,    75,    56,    95,   114,   358,   118,    68,   632,
      42,   341,    65,   417,    75,   494,   121,   480,    24,    31,
      63,    27,   476,  1057,   616,   429,    42,    75,    66,    82,
      68,   383,    28,    84,   121,    31,    14,   156,   111,   391,
     392,    94,    20,    44,    66,   156,    68,    95,  1023,   102,
      67,    89,    95,   114,    66,    67,    68,    69,    70,    71,
      72,    23,    40,    75,    76,    66,   114,    68,   398,    86,
     123,   475,    94,    66,    52,    68,   487,   785,    95,    42,
      86,   485,    89,    95,    66,   490,    68,    49,    70,    95,
      72,    69,    70,    71,   446,    11,   504,    75,   136,    95,
     112,   453,   454,   514,   456,  1004,    42,   114,    67,   817,
     114,   412,    28,    29,    11,  1014,    75,   521,   448,    42,
     114,   422,   536,   569,   476,   603,    23,    86,   106,   114,
     112,   483,   136,    25,   112,   113,    95,    38,    30,  1038,
      32,   119,   136,  1042,   496,   157,    62,    16,   500,   501,
      42,   129,    68,   557,   139,   507,    72,    49,    93,    75,
      52,    50,   114,  1062,   516,    57,    58,   122,   646,   121,
     737,    40,    64,   148,  1073,   505,    77,   112,    67,    95,
      11,   136,    83,    86,   536,    62,    75,    88,   540,   541,
     168,    95,    95,    69,    70,   525,    97,    28,   114,   678,
     101,   605,    79,   555,   556,    86,   107,    77,   112,   614,
     102,   563,    23,   131,    95,    85,    42,    28,   136,   571,
     104,   137,   123,    42,   554,   577,   705,   579,   112,    42,
     638,   659,   148,    67,   146,   587,   148,   153,   558,   569,
     113,    75,   523,   524,    42,    95,   598,   599,   140,    42,
      42,   603,    42,   954,   606,    42,   778,   609,    42,   589,
     664,   613,    42,    42,    42,    42,    42,   671,    42,   621,
      42,    42,    42,    42,    42,   167,    42,    42,    42,    42,
     632,    42,    42,   175,   176,    66,    67,    68,    69,    70,
      71,    72,    47,    42,   646,    76,    42,   627,   702,    42,
      42,    42,    42,   850,   136,    50,   105,    89,    22,    28,
      20,   663,    47,    75,    89,    22,    50,   114,   124,    75,
      50,   162,   165,   786,   112,   148,    28,    22,   680,    11,
      89,   112,    63,    14,    31,    89,   740,    74,    95,    83,
      23,   745,   160,    23,    23,    22,   809,   100,    49,    23,
     108,    23,    23,    75,    23,   177,   139,    42,    42,    75,
      14,   691,   114,    75,    42,    63,    28,    23,   177,    62,
      23,    23,    42,    23,    31,   170,    19,   128,   128,    79,
      35,    28,    23,    23,   847,   113,   790,    63,   136,   136,
     128,    23,    28,   160,    23,    70,   875,   136,   876,    89,
      31,    69,    75,    70,    28,   884,    23,   759,    42,    75,
     762,   763,    75,   818,   122,   136,    42,    42,   122,   113,
     825,   773,   774,   155,   160,   777,   153,    36,    89,   128,
     122,   761,     8,   136,    23,    23,    23,   128,    23,   791,
      20,    23,   175,    70,    45,    84,   175,   136,   852,   113,
     136,   803,    31,    28,   160,   114,   143,   122,    49,   789,
      23,    23,    31,   172,   160,   113,    31,    63,   128,   613,
      70,   632,   130,   603,     5,   271,   122,   128,   599,   128,
     598,   465,    13,   128,   128,   882,   128,   579,   496,   819,
      21,   843,   621,   845,   442,   128,   940,   500,   136,   903,
     614,   657,   662,   391,   534,   231,   392,   652,    39,   861,
     531,   915,  1057,   780,   909,    46,   846,    48,    49,   788,
      51,   920,  1031,   646,   876,   930,   774,   892,    59,   240,
      61,   936,   731,   833,   841,  1019,   840,  1044,   930,   649,
     762,   456,   589,   445,   110,   949,   428,   899,  1022,    80,
     417,    -1,   882,   955,    -1,   243,    -1,    -1,    -1,  1022,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    98,    99,    -1,
      -1,   102,   924,    -1,    -1,    -1,   928,   907,   109,    -1,
      -1,    -1,    -1,    -1,   936,   937,    -1,    -1,   119,   120,
      -1,    -1,    -1,    -1,   125,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,   135,    -1,    -1,   138,  1013,    -1,
      -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,   149,   150,
      -1,    -1,  1026,    -1,    -1,    -1,   157,   158,    -1,    -1,
     161,    -1,   163,   164,    -1,    -1,  1041,   168,   169,    -1,
     171,    -1,   173,    -1,    -1,    -1,    -1,   178,    -1,     0,
       1,  1003,    -1,  1005,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    16,    -1,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    -1,    26,    -1,    -1,  1008,    -1,
      -1,    -1,    -1,  1035,    -1,  1037,    -1,    -1,    39,  1041,
      -1,    -1,    -1,    -1,  1024,    46,    47,    48,    49,    50,
      51,  1031,    53,    -1,    55,    -1,    -1,    -1,    59,    60,
      61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    -1,    77,    78,    -1,    80,
      81,    -1,    -1,    -1,    85,    -1,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,    -1,
      -1,   102,    -1,    -1,   105,   106,   107,    -1,   109,    -1,
     111,    -1,    -1,    -1,   115,   116,   117,    -1,   119,   120,
      -1,    -1,    -1,    -1,   125,   126,   127,    -1,    -1,   130,
      -1,   132,   133,   134,   135,    -1,    -1,   138,    -1,    -1,
      -1,    -1,   143,   144,    -1,    -1,   147,   148,   149,   150,
     151,    -1,    -1,    -1,    -1,    -1,   157,   158,   159,    -1,
     161,    -1,   163,   164,    -1,   166,    -1,   168,   169,     1,
     171,   172,   173,     5,     6,    -1,    -1,   178,    -1,    -1,
      -1,    13,    14,    15,    16,    -1,    -1,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    47,    48,    49,    50,    51,
      -1,    53,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    -1,    77,    78,    -1,    80,    81,
      -1,    -1,    -1,    85,    -1,    87,    88,    89,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,    -1,    -1,
     102,    -1,    -1,   105,   106,   107,    -1,   109,    -1,   111,
      -1,    -1,    -1,   115,   116,   117,    -1,   119,   120,    -1,
      -1,    -1,    -1,   125,   126,   127,    -1,    -1,   130,    -1,
     132,   133,   134,   135,    -1,    -1,   138,    -1,    -1,    -1,
      -1,   143,   144,    -1,    -1,   147,   148,   149,   150,   151,
      -1,    -1,    -1,    -1,    -1,   157,   158,   159,    -1,   161,
      -1,   163,   164,    -1,   166,    -1,   168,   169,    -1,   171,
     172,   173,    -1,    -1,    -1,    -1,   178
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,     5,     6,    13,    15,    16,    21,    39,    46,
      47,    48,    49,    51,    53,    55,    59,    60,    61,    74,
      77,    78,    80,    81,    85,    87,    88,    89,    96,    97,
      98,    99,   102,   106,   107,   109,   115,   116,   117,   119,
     120,   125,   126,   127,   130,   132,   133,   134,   135,   138,
     143,   144,   147,   148,   149,   150,   151,   157,   158,   159,
     161,   163,   164,   166,   168,   169,   171,   172,   173,   178,
     180,   181,   182,   183,   192,   193,   194,   195,   198,   199,
     203,   204,   205,   206,   211,   213,   240,   278,   281,   284,
     285,   287,   288,   289,   290,   386,   410,   417,   418,   440,
     442,   444,   451,   452,   453,   455,   456,   473,   479,   480,
     481,    89,    42,   196,    42,    42,   103,   217,    42,    42,
      42,    42,    42,    42,    42,   287,    42,   113,   387,   388,
     389,    42,    95,   209,    42,    42,    42,    42,    42,    42,
      42,    42,    42,    42,    32,   167,   474,   191,   411,    42,
      42,    42,   191,    42,    42,    42,    42,   287,    42,    42,
     279,   281,    42,    42,    42,     5,    13,    21,    39,    46,
      48,    49,    51,    59,    61,    80,    96,    98,    99,   102,
     109,   119,   120,   125,   126,   134,   135,   138,   144,   149,
     150,   157,   158,   161,   163,   164,   168,   169,   171,   173,
     178,   286,    42,    42,    42,   191,    42,    42,     0,   181,
     136,   416,   191,     9,   112,   200,   201,   361,    89,   136,
     212,    42,    50,   105,   114,   287,    89,    63,   207,   209,
     291,   292,   293,   294,   297,   299,   301,   302,   416,    89,
     423,    26,    73,    75,   111,   419,    22,     9,   297,   454,
      75,   457,    75,    90,   428,   482,   482,    31,   209,   436,
     197,   287,   236,    28,   210,   347,    20,    16,    40,   273,
      47,   209,   436,    50,   209,   254,   361,   146,   287,   468,
      22,     9,   209,   391,   392,    44,    66,    68,   218,   416,
     347,   468,   347,    10,    73,   108,   276,   287,   104,   269,
     361,   228,   220,   124,     9,   145,   239,   207,   475,   476,
     190,   412,   265,   347,   209,   263,   436,   184,   152,   209,
     257,   210,   287,    67,    86,   209,   225,   226,   339,    24,
      27,    86,   209,   244,   245,   247,   249,   250,   251,   215,
      75,   282,    50,   280,    32,   167,   274,   162,   165,    66,
      68,   255,   262,   214,    66,    68,   174,   216,   185,   209,
     262,    28,   114,   202,   430,   436,    89,   361,   202,    38,
      77,    83,    88,    97,   101,   107,   123,   241,   242,   243,
     279,   148,    89,    28,   303,    22,   300,   293,   296,   297,
      11,   298,    23,   208,   209,   304,    89,    37,    38,    42,
      56,    65,    82,    94,   102,   123,   346,   424,   425,   445,
     441,   442,   457,    14,   420,   421,   436,   463,   464,   465,
     209,    83,   458,   429,   287,   287,    95,   438,    31,    23,
     209,   237,   238,    23,   209,   217,    11,    29,    68,    72,
     137,   369,   362,   369,    62,   382,   400,   401,   402,   403,
     404,   405,   406,    11,    28,   393,    23,   394,   209,   209,
     436,   108,   100,   270,   209,   209,   229,   230,   231,    75,
     221,   222,   223,   225,   208,    22,   160,   477,    49,   413,
      23,   266,   209,    23,   264,    23,   267,   186,   187,   301,
      75,    33,    68,   253,    23,   344,   246,   252,   262,   114,
     114,   139,   225,   209,   283,   287,   177,   277,     9,    91,
      92,   256,   271,   304,   188,   189,   301,    66,   112,   219,
     436,   139,   202,    11,    23,   282,   207,    79,   306,   307,
     308,   309,   310,   380,   382,   122,   136,   295,   299,   302,
      23,    28,   305,   287,    66,    67,    68,    69,    70,    71,
      72,    76,   112,   379,    42,    42,    42,   347,   426,   428,
     450,   428,    14,   389,   422,    75,   466,   464,    63,   467,
     128,   389,   431,   433,   437,   438,   436,    28,   232,    23,
     210,   177,   275,   275,   403,   225,   337,    63,   287,   408,
     409,   404,   136,   209,   209,   392,   136,   232,    23,   224,
      69,    70,   227,    23,   436,   478,   207,    42,   415,   347,
     209,   436,   190,   298,   258,   259,   361,   210,    31,   340,
     247,   248,    86,   251,   209,   128,   416,   287,   209,   170,
     272,   190,   298,   304,    19,   436,   242,   242,   287,   132,
     143,   172,   311,   307,    63,   314,   315,   318,   310,   306,
     297,   304,   208,   287,   209,   209,   436,   281,   160,   160,
     128,   391,    35,    28,   430,   468,   391,    23,     3,     4,
      75,   157,   379,   434,   436,   439,   209,   238,    23,   121,
     383,    70,   407,   112,   209,   396,   397,   398,   136,   409,
     113,    75,   233,   231,   222,    70,    69,   223,   225,   136,
     436,   208,   323,   430,   209,    23,   268,   187,   128,   259,
     260,   369,    67,   341,   343,   430,   249,    89,   287,   189,
     416,    21,    96,   178,   312,   313,    28,   318,   348,   349,
     350,   351,   354,   357,   337,   383,   305,   280,   450,   428,
      49,   459,   288,   209,   436,   155,   469,   459,   432,   434,
      75,    75,   434,   436,     7,    84,    31,   210,   209,    28,
     399,   122,    23,   395,   235,   287,   128,   136,    12,   414,
     436,   210,   153,   261,   342,    89,    42,    42,    42,   131,
     136,   122,    25,    30,    32,    42,    49,    52,    57,    58,
      64,   140,   167,   175,   176,   319,   320,   321,   334,   335,
     345,   346,   378,    10,    17,    34,    41,    43,   110,   141,
     142,   154,   324,   325,   326,   336,   353,    42,    54,    58,
      78,   118,   156,   352,   373,   374,    14,    20,    40,    52,
      69,    70,    71,    75,   106,   119,   129,   168,   175,   355,
     356,   358,   359,   361,   113,   384,   457,    18,   160,   446,
     175,   443,    28,   436,   460,    36,   128,   122,   436,   470,
     136,     8,   462,   128,   434,   434,   128,   434,   434,    66,
      68,    70,    72,   112,   435,    23,    23,   385,   209,   287,
     398,   391,    23,   234,    23,    28,   114,   209,   364,   370,
     371,   372,   339,    20,   209,   262,   313,   318,   379,   347,
      28,   114,   322,   323,   287,   436,   209,   327,   122,   136,
     209,   175,   338,   113,   390,   347,   328,   335,   328,   136,
      23,   352,   379,   139,   361,   287,   328,    93,   361,   375,
     376,   377,    70,   359,   357,   353,    75,   153,   287,   360,
     365,   366,   370,   209,    65,    82,    94,   287,   427,   347,
     448,   449,   447,   450,   279,   436,    45,   461,    67,   466,
     471,   209,   128,    23,   210,   225,   136,   235,   128,   210,
      28,   114,   344,   209,   436,    28,    31,    54,   130,   287,
     330,   331,   332,   333,    31,   316,   321,   143,   436,   160,
     329,   329,   326,   364,   329,   364,   130,   377,   128,   113,
     361,   365,   370,    75,   364,   261,    11,    29,    62,    68,
      72,   137,   368,    75,   363,   365,    66,    68,    94,   381,
     459,   436,    23,   160,   282,   461,   114,   466,   472,   467,
     434,    23,    31,   317,   113,   172,   328,   128,   128,   370,
     360,    75,   364,   287,   367,   361,   365,   360,   385,   449,
     450,   287,   436,   467,   128,   331,    31,    63,   209,   329,
     364,   360,   128,   361,   370,   360,   121,   368,   128,   136,
     466,   319,   360,   128,   467,   122,   360
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 13:

/* Line 1806 of yacc.c  */
#line 555 "gram.y"
    {
		/* for blank lines -- nothing to do */
	}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 561 "gram.y"
    {
		/* to keep going after stumbling on an input error */
		Getting_tup_dur = NO;
		Good_till_canceled = NO;
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Last_grpsyl_p = (struct GRPSYL *) 0;
		Prev_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 572 "gram.y"
    {
		/* fill in context field of the SSV struct */
		Currstruct_p->u.ssv_p->context = (short) Context;
	}
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 579 "gram.y"
    {
		Curr_family = Score.fontfamily;
	}
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 585 "gram.y"
    {}
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 589 "gram.y"
    {}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 593 "gram.y"
    {}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 597 "gram.y"
    {}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 601 "gram.y"
    {}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 605 "gram.y"
    {
		/* have lots of separate structs in music context, so
		 * mark that we have no current struct */
		Currstruct_p = (struct MAINLL *) 0;

		/* make sure at least 1 staff is visible. Not good to
		 * check when user sets visible, because it would be
		 * nice to first set everything invisible and later
		 * turn one on. So if we wait till now to check,
		 * user doesn't have to switch back and forth from
		 * score to staff to get 1 voice visible. */
		check_at_least1visible();
	}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 620 "gram.y"
    {
		Context = C_SCORE;
		Curr_font = svpath(0, FONT)->font;
		Curr_family = svpath(0, FONTFAMILY)->fontfamily;
		Curr_size = svpath(0, SIZE)->size;
	}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 628 "gram.y"
    { begin_range(PL_UNKNOWN); }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 629 "gram.y"
    {
		/* Make sure all the staffs are in range */
		chk_ssv_ranges(C_STAFF);

		/* Set current SSV's staff to the first one on the list.
		 * If there is more than one, we will clone the SSV later.
		 * Note that it is possible that the staff number the user
		 * specified is actually illegal, but we will use it anyway,
		 * because it keeps the code simpler to pretend all is well,
		 * and ssv.c code will ignore such illegal SSVs anyway.
		 */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		Context = C_STAFF;
	}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 648 "gram.y"
    { begin_range(PL_UNKNOWN); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 649 "gram.y"
    {
		/* Make sure all the staffs and voices are in range */
		chk_ssv_ranges(C_VOICE);

		/* Set current SSV's staff/voice to the first one on the list.
		 * If there are more than, we will clone the SSV later */
		if (Svrangelist_p != 0 && Svrangelist_p->stafflist_p != 0) {
			Currstruct_p->u.ssv_p->staffno
					= Svrangelist_p->stafflist_p->begin;
		}
		if (Svrangelist_p != 0 && Svrangelist_p->vnolist_p != 0) {
			Currstruct_p->u.ssv_p->voiceno
					= Svrangelist_p->vnolist_p->begin;
		}
		Context = C_VOICE;
	}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 673 "gram.y"
    {
		add_to_sv_list();
	}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 683 "gram.y"
    {
		add_to_sv_list();
	}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 688 "gram.y"
    {
		/* allocate an SSV struct */
		Currstruct_p = newMAINLLstruct(S_SSV, yylineno);
	}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 694 "gram.y"
    {
		/* entering new context, if we have a current struct,
		 * we were in a different context, so add its info to the list */
		end_prev_context();
	}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 701 "gram.y"
    {
		struct FEED *feed_p;		/* where to attach blocks */
		int calloced;			/* YES if dynamically alloced */

		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = (yyvsp[(1) - (2)].intval);
		calloced = NO;

		switch ((yyvsp[(1) - (2)].intval)) {
		case C_HEADER:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER, "header", &Header);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER,
					"header leftpage", &Leftheader);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER,
					"header rightpage", &Rightheader);
				break;
			}
			break;

		case C_HEAD2:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_HEADER2,
					"header2", &Header2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LHEADER2,
					"header2 leftpage", &Leftheader2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RHEADER2,
					"header2 rightpage", &Rightheader2);
				break;
			}
			break;
		case C_FOOTER:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER,
					"footer", &Footer); 
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER,
					"footer leftpage", &Leftfooter);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER,
					"footer rightpage", &Rightfooter);
				break;
			}
			break;
		case C_FOOT2:
			switch ((yyvsp[(2) - (2)].intval)) {
			case PGSIDE_NOT_SET:
				chkdup_headfoot(GOT_FOOTER2,
					"footer2", &Footer2);
				break;
			case PGSIDE_LEFT:
				chkdup_headfoot(GOT_LFOOTER2,
					"footer2 leftpage", &Leftfooter2);
				break;
			case PGSIDE_RIGHT:
				chkdup_headfoot(GOT_RFOOTER2,
					"footer2 rightpage", &Rightfooter2);
				break;
			}
			break;
		case C_TOP:
		case C_TOP2:
		case C_BOT:
		case C_BOT2:
		case C_BLOCK:
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			calloced = YES;
			break;
		default:
			pfatal("Unknown block-type context");
			/*NOTREACHED*/
			break;
		}
		set_win_coord(Currblock_p->c);
		/* Remember where to start attaching "print" commands */
		Next_print_link_p_p = &(Currblock_p->printdata_p);

		/* The dynamically allocated blocks
		 * (not the static head/foot blocks)
		 * need extra processing to populate
		 * the main list properly with FEEDs.
		 */
		if (calloced == YES) {
			if (Mainlltc_p == 0 || Mainlltc_p->str != S_FEED) {
				/* User had not specified a feed
				 * right before this block, so we need
				 * to add one for them implicitly.
				 * Create a new FEED and add it
				 * to the end of the main list.
				 */
				insertMAINLL(newMAINLLstruct(S_FEED, yylineno),
							Mainlltc_p);
			}
			feed_p = Mainlltc_p->u.feed_p;

			/* Normally, top/top2/bot/bot2 result in a pagefeed.
			 * But we have a special case for backward
			 * compatibility and for flexibility.
			 * User can get a separate
			 * "title" page if they really want to,
			 * by using an explicit newpage at the beginning.
			 * But in the normal case, they'd want to declare
			 * top/bot that will go on the first page without
			 * that causing a newpage. So if there hasn't been
			 * any music or block yet, we won't set newpage=YES
			 * for top/top2/bot/bot2, but otherwise we will.
			 */
			if (Context & (C_TOP|C_TOP2|C_BOT|C_BOT2)) {
				struct MAINLL *m_p;
				for (m_p = Mainlltc_p->prev; m_p != 0;
							m_p = m_p->prev) {
					if (m_p->str == S_BAR ||
							m_p->str == S_BLOCKHEAD) {
						/* There was music or block,
						 * so this is not
						 * at very beginning,
						 * so no special case:
						 * there will be new page.
						 */
						feed_p->pagefeed = YES;
						break;
					}
				}
			}

			/* Now check for redefined blocks and
			 * attach the BLOCKHEAD onto the FEED or the
			 * main list, as appropriate.
			 */
			switch (Context) {
			case C_TOP:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top_p),
							"top" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop_p),
							"top leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop_p),
							"top rightpage" );
					break;
				}
				break;
			case C_TOP2:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->top2_p),
							"top2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->lefttop2_p),
							"top2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->righttop2_p),
							"top2 rightpage" );
					break;
				}
				break;
			case C_BOT:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot_p),
							"bot" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot_p),
							"bot leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot_p),
							"bot rightpage" );
					break;
				}
				break;
			case C_BOT2:
				switch ((yyvsp[(2) - (2)].intval)) {
				case PGSIDE_NOT_SET:
					chkdup_topbot( &(feed_p->bot2_p),
							"bot2" );
					break;
				case PGSIDE_LEFT:
					chkdup_topbot( &(feed_p->leftbot2_p),
							"bot2 leftpage" );
					break;
				case PGSIDE_RIGHT:
					chkdup_topbot( &(feed_p->rightbot2_p),
							"bot2 rightpage" );
					break;
				}
				break;
			case C_BLOCK:
				insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
				Mainlltc_p->u.blockhead_p = Currblock_p;
				if ((yyvsp[(2) - (2)].intval) != PGSIDE_NOT_SET) {
					l_warning(Curr_filename, yylineno,
						"leftpage/rightpage cannot be used on blocks; ignoring");
				}
				/* These blocks count like "music" for purposes
				 * of things that can only be set
				 * before any "music"
				 */
				Got_some_data = YES;
				break;
			case C_HEADER:
			case C_HEAD2:
			case C_FOOTER:
			case C_FOOT2:
				/* These are static, not in main list,
				 * so nothing needs to be done with them.
				 */
				break;
			default:
				pfatal("unexpected context (0x%x) for block", Context);
				/*NOTREACHED*/
				break;
			}

			/* We need a feed after a block.
			 * Use -1 as lineno to mark it as internally generated.
			 * That way if user puts their own explicit feed
			 * next in the input, we can know we can
			 * discard this internally generated one.
			 */
			if (Context & C_BLOCK) {
				insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
			}
		}
	}
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 950 "gram.y"
    {
		Context = C_MUSIC;
	}
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 955 "gram.y"
    {
		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = C_GRIDS;
	}
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 962 "gram.y"
    {
	}
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 966 "gram.y"
    {
		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = C_ACCIDENTALS;
	}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 973 "gram.y"
    {
		struct ACCIDENTALS *acc_name_map_p;

		/* Make sure not already in list */
		for (acc_name_map_p = Acc_contexts_list_p; acc_name_map_p != 0;
					acc_name_map_p = acc_name_map_p->next) {
			if (strcmp(acc_name_map_p->name, (yyvsp[(1) - (1)].stringval)) == 0) {
				l_warning(Curr_filename, yylineno,
				"accidental context name %s re-defined; using last", (yyvsp[(1) - (1)].stringval));
				/* We'll free the table, since that is
				 * potentially big, and is easy to do.
				 * We'll leave the ACCIDENTALS struct itself,
				 * because it doesn't seem worth the trouble
				 * to keep track of the "prev" to free up a
				 * little memory in a rare error case.
				 * And we'll leave the name, so future loops
				 * though the list can strcmp it, even though
				 * it will never really be used. We will put
				 * the replacement at the head of the list,
				 * so we'll always see that copy first and
				 * never bother to come down to this one.
				 */
				if (acc_name_map_p->info != 0) {
					FREE(acc_name_map_p->info);
					acc_name_map_p->info = 0;
					acc_name_map_p->size = 0;
				}
				/* If redefined multiple times, don't
				 * bother giving multiple errors. */
				break;
			}
		}

		MALLOC(ACCIDENTALS, acc_name_map_p, 1);
		acc_name_map_p->name = strdup((yyvsp[(1) - (1)].stringval) + 2);
		MALLOC(ACCINFO, acc_name_map_p->info, ITEMS);
		acc_name_map_p->size = 0;
		acc_name_map_p->next = Acc_contexts_list_p;
		Acc_contexts_list_p = acc_name_map_p;
	}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 1015 "gram.y"
    {
		if (Context != C_ACCIDENTALS) {
			yyerror("something like looks like an accidentals entry when not in accidentals context");
		}
	}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 1023 "gram.y"
    {
		if (Context == C_ACCIDENTALS) {
			new_acc_entry((yyvsp[(1) - (1)].stringval) + 2);
		}
	}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 1031 "gram.y"
    {
		/* A single value to use for all notes a-g */
		int i;
		for (i = 0; i < 7; i++) {
			add_acc_offset('a' + i, (yyvsp[(2) - (2)].floatval));
		}
	}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 1045 "gram.y"
    {
		add_acc_offset((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].floatval));
	}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 1051 "gram.y"
    {
		add_acc_offset((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].floatval));
	}
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 1057 "gram.y"
    {
		(yyval.floatval) = (float) cents2value( (double) ((yyvsp[(1) - (3)].intval) * (yyvsp[(2) - (3)].floatval)));
	}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 1063 "gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 1069 "gram.y"
    {
		if ((yyvsp[(3) - (3)].floatval) == 0.0) {
			yyerror("denominator cannot be zero");
		}
		else {
			(yyval.floatval) = (yyvsp[(1) - (3)].floatval) / (yyvsp[(3) - (3)].floatval);
		}
	}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 1079 "gram.y"
    {
		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = C_KEYMAP;
		new_keymap((yyvsp[(2) - (2)].stringval) + 2);
	}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 1088 "gram.y"
    {
		if (Context == C_GRIDS) {
			add_grid((yyvsp[(1) - (3)].stringval), (yyvsp[(2) - (3)].stringval));
		}
		else if (Context == C_HEADSHAPES) {
			/* skip past the font/size bytes */
			add_shape((yyvsp[(1) - (3)].stringval) + 2, (yyvsp[(2) - (3)].stringval) + 2);
		}
		else if (Context == C_KEYMAP) {
			add_to_keymap((yyvsp[(1) - (3)].stringval), (yyvsp[(2) - (3)].stringval));
		}
		else {
			l_warning(Curr_filename, yylineno - 1,
				"unexpected pair of text strings (possibly intended to be in grids, headshapes, or keymap context, or missing + for concatenation?)");
		}
	}
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 1107 "gram.y"
    {
		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = C_HEADSHAPES;
	}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 1116 "gram.y"
    {
		end_prev_context();
		Currstruct_p = (struct MAINLL *) 0;
		Context = C_SYMBOL;
		/* The +2 to skip font/size */
		Curr_usym_p = alloc_usym((yyvsp[(2) - (2)].stringval) + 2);
	}
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 1129 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
		/* later on we check for being within current range */
	}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 1135 "gram.y"
    {
		errno = 0;
		(yyval.intval) = strtol(yytext, 0, 10);
		if (errno == ERANGE) {
			l_yyerror(Curr_filename, yylineno,
				"Number %s is beyond the range of numbers that can be handled", yytext);
		}
	}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 1145 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].intval);
	}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 1160 "gram.y"
    {
		/* Only a few things are allowed to have a negative number.
		 * Other code assumes that that restriction is enforced here,
		 * so we only honor the minus if it is legal. */
		if ((yyvsp[(3) - (4)].intval) == -1) {
			if ((yyvsp[(1) - (4)].intval) != STAFFPAD && (yyvsp[(1) - (4)].intval) != SYLPOSITION) {
				yyerror("negative value not allowed");
			}
			else {
				assign_int((yyvsp[(1) - (4)].intval), -((yyvsp[(4) - (4)].intval)), Currstruct_p);
			}
		}
		else {
			assign_int((yyvsp[(1) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
		}
	}
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 1179 "gram.y"
    {
		/* only restcombine and gridfret can be set to empty */
		if ((yyvsp[(1) - (2)].intval) == RESTCOMBINE) {
			assign_int((yyvsp[(1) - (2)].intval), NORESTCOMBINE, Currstruct_p);
		}
		else if ((yyvsp[(1) - (2)].intval) == GRIDFRET) {
			assign_int((yyvsp[(1) - (2)].intval), NOGRIDFRET, Currstruct_p);
		}
		else {
			yyerror("parameter value required");
		}
	}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 1194 "gram.y"
    {
		assign_firstpage((yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 1200 "gram.y"
    {
		assign_float((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].floatval), Currstruct_p);
	}
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 1206 "gram.y"
    {
		assign_2floats((yyvsp[(1) - (5)].intval), (yyvsp[(3) - (5)].floatval), (yyvsp[(5) - (5)].floatval), Currstruct_p);
	}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 1212 "gram.y"
    {
		assign_float((yyvsp[(1) - (4)].intval), (yyvsp[(3) - (4)].floatval), Currstruct_p);
	}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 1218 "gram.y"
    {
		double multiplier;
		multiplier = (Score.units == INCHES ? 1.0 : CMPERINCH);
		assign_float(PAGEWIDTH, pagesztbl[(yyvsp[(3) - (4)].intval)][(yyvsp[(4) - (4)].intval)] * multiplier, Currstruct_p);
		assign_float(PAGEHEIGHT, pagesztbl[(yyvsp[(3) - (4)].intval)][(yyvsp[(4) - (4)].intval) ^ 1] * multiplier, Currstruct_p);
	}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 1226 "gram.y"
    { begin_range(PL_UNKNOWN);  }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 1227 "gram.y"
    { }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 1231 "gram.y"
    {
		/* specified in stepsizes, stored in inches */
		assign_float(PAD, (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval) * STEPSIZE, Currstruct_p);
	}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 1238 "gram.y"
    {
		assign_vscheme ((yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 1244 "gram.y"
    {
		set_beamlist(Currstruct_p);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			Currstruct_p->u.ssv_p->beamrests = ((yyvsp[(5) - (5)].intval) & 0x1);
			Currstruct_p->u.ssv_p->beamspaces = (((yyvsp[(5) - (5)].intval) >> 1) & 0x1);
		}
	}
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 1254 "gram.y"
    {
		set_staffset((yyvsp[(1) - (4)].intval), Currstruct_p);
	}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 1260 "gram.y"
    {
		set_barstlist(Currstruct_p);
	}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 1266 "gram.y"
    {
		if (contextcheck(C_SCORE|C_STAFF, "repeatdots") == YES) {
			Currstruct_p->u.ssv_p->repeatdots = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[REPEATDOTS] = YES;
		}
	}
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 1275 "gram.y"
    {
		if (Currstruct_p != 0) {
			chk_order(Currstruct_p->u.ssv_p, Order_place);
		}
	}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 1286 "gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 1292 "gram.y"
    {
		/* all the work for this is done in timesig */
	}
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 1298 "gram.y"
    {
	}
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 1303 "gram.y"
    {
		set_font((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 1309 "gram.y"
    {
		set_font((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 1315 "gram.y"
    {
		if (contextcheck(C_SCORE|C_STAFF,"clef parameter") == YES) {
			used_check(Currstruct_p, CLEF, "clef");
			if (Context == C_STAFF && has_tab_staff()) {
				/* We used to be able to make this just a
				 * warning, but now that is hard, because
				 * we'd want to let it assign for any
				 * non-tab, but it is hard to know at this
				 * point which SSVs will be tab and which					 * non-tab, because we may not have created
				 * them all yet. We cannot let the tab ones
				 * get assigned, because later code would
				 * get confused by clef not being TABCLEF.
				 * While we could figure this all out with
				 * enough code, it really is a user error,
				 * so not worth bending over backwards
				 * to try to keep it just a warning.
				 */
				l_yyerror(Curr_filename, yylineno,
					"can't set clef on tab staff");
			}
			Currstruct_p->u.ssv_p->clef = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[CLEF] = YES;
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 1343 "gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 1352 "gram.y"
    {
		assign_int((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 1358 "gram.y"
    {
		if (contextcheck(C_STAFF|C_VOICE, "unset") == YES) {
			if ((yyvsp[(2) - (2)].intval) < 0 || (yyvsp[(2) - (2)].intval) >= NUMFLDS) {
				pfatal("invalid parameter index %d on line %d", (yyvsp[(2) - (2)].intval), yylineno);
			}
			if (Currstruct_p->u.ssv_p->used[(yyvsp[(2) - (2)].intval)] == YES) {
				warning("unsetting parameter overrides previous setting");
			}
			/* Note that if user tries to unset something that
			 * can't be set in the current context, we silently
			 * ignore that. We figure that since it's already unset,
			 * it doesn't hurt anything to unset it again,
			 * and it's easier to not bother to check.
			 */

			Currstruct_p->u.ssv_p->used[(yyvsp[(2) - (2)].intval)] = UNSET;

			/* special case: scoresep controls two fields */
			if ((yyvsp[(2) - (2)].intval) == MINSCSEP) {
				Currstruct_p->u.ssv_p->used[MAXSCSEP] = UNSET;
			}

			/* Assign, just in case there are new interactions */
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 1386 "gram.y"
    { Doing_timeunit = YES; }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 1387 "gram.y"
    {
		if ( contextcheck(C_SSV, "timeunit parameter") == YES ) {
			used_check(Currstruct_p, TIMEUNIT, "timeunit");
			Currstruct_p->u.ssv_p->timeunit = (yyvsp[(4) - (4)].ratval);
			Currstruct_p->u.ssv_p->timelist_p = Extra_time_p;
			Extra_time_p = 0;
			Doing_timeunit = NO;
			Currstruct_p->u.ssv_p->used[TIMEUNIT] = YES;
		}
	}
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 1400 "gram.y"
    {
		if ( contextcheck(C_SSV, "swingunit parameter") == YES ) {
			used_check(Currstruct_p, SWINGUNIT, "swingunit");
			Currstruct_p->u.ssv_p->swingunit = (yyvsp[(3) - (3)].ratval);
			Currstruct_p->u.ssv_p->used[SWINGUNIT] = YES;
		}
	}
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 1410 "gram.y"
    {
	}
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 1415 "gram.y"
    {
	}
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 1420 "gram.y"
    {
		if ( contextcheck(C_SCORE, "endingstyle parameter") == YES ) {
			used_check(Currstruct_p, ENDINGSTYLE, "endingstyle");
			Currstruct_p->u.ssv_p->endingstyle = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[ENDINGSTYLE] = YES;
		}
	}
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 1430 "gram.y"
    {
		if ((yyvsp[(1) - (3)].intval) == REHSTYLE) {
			if (contextcheck(C_SCORE | C_STAFF, "rehstyle parameter") == YES ) {
				used_check(Currstruct_p, REHSTYLE, "rehstyle");
				Currstruct_p->u.ssv_p->rehstyle = (yyvsp[(3) - (3)].intval);
				Currstruct_p->u.ssv_p->used[REHSTYLE] = YES;
			}
		}
		else if ((yyvsp[(1) - (3)].intval) == MEASNUMSTYLE) {
			if (contextcheck(C_SCORE, "measnumstyle parameter") == YES) {
				used_check(Currstruct_p, MEASNUMSTYLE, "measnumstyle");
				Currstruct_p->u.ssv_p->measnumstyle = (yyvsp[(3) - (3)].intval);
				Currstruct_p->u.ssv_p->used[MEASNUMSTYLE] = YES;
			}
		}
		
	}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 1450 "gram.y"
    {
		if ( contextcheck(C_SCORE | C_STAFF, "pedstyle parameter") == YES ) {
			used_check(Currstruct_p, PEDSTYLE, "pedstyle");
			Currstruct_p->u.ssv_p->pedstyle = (yyvsp[(3) - (3)].intval);
			Currstruct_p->u.ssv_p->used[PEDSTYLE] = YES;
			/* Since Ped_stop is a predefined string that
			 * doesn't go through fix_string(), we wouldn't
			 * realize that font ZD1 was used until printing
			 * phase after we ought to have emitted the
			 * encoding vector code, which is too late,
			 * so mark it here. If the user sets the
			 * parameter to pedstar but then never actually uses
			 * a star, this will just cause a few extraenous
			 * but otherwise harmless lines of output. It is
			 * less important the ZI gets marked as used,
			 * since we don't change its encodiong vector,
			 * so don't need to emit special code, but might as
			 * well mark that here as well. */
			if ((yyvsp[(3) - (3)].intval) != P_LINE) {
				Fontinfo[font_index(FONT_ZD1)].was_used = YES;
				Fontinfo[font_index(FONT_ZI)].was_used = YES;
			}
		}
	}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 1477 "gram.y"
    {
		char *trans_name;
		trans_name = ((yyvsp[(1) - (5)].intval) == TRANSPOSITION ?
			"transpose" : "addtranspose");
		if (contextcheck(C_SCORE|C_STAFF, trans_name) == YES) {
			if (Context == C_STAFF && has_tab_staff() == YES) {
				l_warning(Curr_filename, yylineno,
					"%s not allowed on tablature staff; ignoring",
					trans_name);
			}
			used_check(Currstruct_p, (yyvsp[(1) - (5)].intval), trans_name);
			chk_interval((yyvsp[(4) - (5)].intval), (yyvsp[(5) - (5)].intval));
			if ((yyvsp[(1) - (5)].intval) == TRANSPOSITION) {
				Currstruct_p->u.ssv_p->inttype = (yyvsp[(4) - (5)].intval);
				Currstruct_p->u.ssv_p->intnum = (yyvsp[(3) - (5)].intval) * (yyvsp[(5) - (5)].intval);
			}
			else {
				Currstruct_p->u.ssv_p->addinttype = (yyvsp[(4) - (5)].intval);
				Currstruct_p->u.ssv_p->addintnum = (yyvsp[(3) - (5)].intval) * (yyvsp[(5) - (5)].intval);
			}
			Currstruct_p->u.ssv_p->used[(yyvsp[(1) - (5)].intval)] = YES;
			asgnssv(Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 1504 "gram.y"
    {
		assign_unit((yyvsp[(3) - (3)].intval), Currstruct_p);
	}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 1510 "gram.y"
    {
		assign_string((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 1516 "gram.y"
    {
		assign_string((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 1522 "gram.y"
    {
		if (contextcheck(C_SCORE, "tuning") == YES) {
			used_check(Currstruct_p, TUNING, "tuning");
			Currstruct_p->u.ssv_p->used[TUNING] = YES;
			Currstruct_p->u.ssv_p->tuning = (yyvsp[(3) - (3)].intval);
			Tuning_used = YES;
		}
	}
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 1533 "gram.y"
    {
		set_keymap((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval), Currstruct_p);
	}
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 1539 "gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"postscript= only valid in symbol context; maybe you meant without '=' ?");
		}
		else {
			if (Curr_usym_p->flags & US_POSTSCRIPT) {
				l_warning(Curr_filename, yylineno,
					"Multiple postscript definitions given for symbol '%s'; using last",
					Curr_usym_p->name);
				FREE(Curr_usym_p->postscript);
			}
			Curr_usym_p->postscript = (yyvsp[(3) - (3)].stringval);
			Curr_usym_p->flags |= US_POSTSCRIPT;
		}
	}
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 1558 "gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"bbox= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_BBOX) {
				l_warning(Curr_filename, yylineno,
					"Multiple bbox definitions given for symbol %s; using last",
					Curr_usym_p->name);
			}
			Curr_usym_p->llx = (yyvsp[(3) - (9)].intval);
			Curr_usym_p->lly = (yyvsp[(5) - (9)].intval);
			Curr_usym_p->urx = (yyvsp[(7) - (9)].intval);
			Curr_usym_p->ury = (yyvsp[(9) - (9)].intval);
			Curr_usym_p->flags |= US_BBOX;
		}
	}
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 1579 "gram.y"
    {
		if (Curr_usym_p == 0) {
			l_yyerror(Curr_filename, yylineno,
				"stemoffset= only valid in symbol context");
		}
		else {
			if (Curr_usym_p->flags & US_STEMOFFSET) {
				l_warning(Curr_filename, yylineno,
					"Multiple stemoffset definitions given for %s; last used",
					Curr_usym_p->name);
			}
			Curr_usym_p->upstem_y = (yyvsp[(3) - (5)].intval);
			Curr_usym_p->downstem_y = (yyvsp[(5) - (5)].intval);
			Curr_usym_p->flags |= US_STEMOFFSET;
		}
	}
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1599 "gram.y"
    {
		/* whereused is not allowed on voice, just score and staff */
		if (contextcheck(C_SCORE|C_STAFF, "visible=whereused") == YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = YES;
			}
		}
	}
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1611 "gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("visible value must be y, n, or whereused");
		}
		else if (contextcheck(C_SSV, "visible parameter")
								== YES) {
			assign_int(VISIBLE, YES, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1627 "gram.y"
    {
		if (contextcheck(C_SSV, "visible parameter") == YES) {
			assign_int(VISIBLE, NO, Currstruct_p);
			if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
				Currstruct_p->u.ssv_p->hidesilent = NO;
			}
		}
	}
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1637 "gram.y"
    {
		(yyval.intval) = PGSIDE_NOT_SET;
	}
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1643 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1649 "gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("measnum value must be y, n, or every N");
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = MN_SCORE;
		}
	}
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1662 "gram.y"
    {
		(yyval.intval) = MN_NONE;
	}
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1668 "gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) < MINEVERYMEASNUM || (yyvsp[(2) - (2)].intval) > MAXEVERYMEASNUM) {
			/* We have to do range check here rather than let
			 * assign_int() do it, because internally we use
			 * additional values, and it would be confusing to
			 * the user to include those internal values in the
			 * valid range. */
			l_yyerror(Curr_filename, yylineno,
				"for measnum=every N, N must be between %d and %d",
				MINEVERYMEASNUM, MAXEVERYMEASNUM);
			(yyval.intval) = MN_NONE;
		}
		else {
			(yyval.intval) = (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1687 "gram.y"
    {
		/* none specified */
		(yyval.intval) = V_1;
	}
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1694 "gram.y"
    {
		/* only valid value here is 'f'  */
		if (*yytext == 'f') {
			(yyval.intval) = V_2FREESTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = V_1;
		}
	}
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1707 "gram.y"
    {
		/* only valid value here is 'o' */
		if (*yytext == 'o') {
			(yyval.intval) = V_2OPSTEM;
		}
		else {
			yyerror("invalid voice qualifier: must be f or o");
			(yyval.intval) = (int) V_1;
		}
	}
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 1719 "gram.y"
    {
		/* NULL token for allocating a new beamlist */
		new_beamlist();
	}
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1733 "gram.y"
    {
		add_beamlist((yyvsp[(1) - (1)].ratval));
	}
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1742 "gram.y"
    {
		add_beamlist((yyvsp[(3) - (3)].ratval));
	}
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1751 "gram.y"
    { begin_subbeam(); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 1752 "gram.y"
    {
		end_subbeam();
	}
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1757 "gram.y"
    {
		(yyval.ratval) = calcfulltime((yyvsp[(1) - (4)].ratval), (yyvsp[(2) - (4)].intval));

		/* If filling in a GRPSYL struct,
		 * need to fill in dots and basictime.
		 * Could also be here due to beamstyle
		 * or timeunit or location time offset,
		 * in which case the Curr_grpsyl_p will be NULL,
		 * or while getting tuplet duration. */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
						&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->dots = (yyvsp[(2) - (4)].intval);
			Curr_grpsyl_p->basictime = reconstruct_basictime((yyval.ratval));
		}
		else {
			struct TIMELIST *timelist_p;	/* walk thru list */
			struct TIMELIST *next_p;/* save next to delete curr */
			RATIONAL totaltime;	/* sum of extra times */

			/* Start with first time value (which was calculated
			 * above and is now in $$), then add on the added
			 * times, if any. */
			totaltime = (yyval.ratval);
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = next_p) {
				next_p = timelist_p->next;
				totaltime = radd(totaltime, timelist_p->fulltime);
				if (Doing_timeunit == NO) {
					/* For things like swingunit
					 * or tuplet time, we just need the
					 * resulting time, not the individual
					 * time units and arithmetic. */
					FREE(timelist_p);
				}
			}
			if (Extra_time_p != 0 && LE(totaltime, Zero)) {
				yyerror("Time values must add up to more than zero");
			}
			/* Current timelist is finished; can't append any
			 * more items to it. */
			Curr_timelist_p = 0;
			if (Doing_timeunit == YES) {
				/* For timeunit, we return the initial
				 * timeunit, but also preserve
				 * Extra_time_p for putting in SSV.
				 */
				(yyval.ratval) = calcfulltime((yyvsp[(1) - (4)].ratval), (yyvsp[(2) - (4)].intval));
			}
			else {
				/* the list has been freed above */
				Extra_time_p = 0;
				(yyval.ratval) = totaltime;
			}
		}
	}
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1815 "gram.y"
    {
		(yyval.ratval).n = (svpath(1, TIME))->time.n;
		(yyval.ratval).d = (svpath(1, TIME))->time.d;
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* use whole note symbol as default */
			Curr_grpsyl_p->basictime = 1;
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = NO;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 1832 "gram.y"
    {
		(yyval.ratval) = Zero;
	}
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1842 "gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 1848 "gram.y"
    {
		(yyval.intval) = (YES | (YES << 1));
	}
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 1854 "gram.y"
    {
		(yyval.intval) = ((YES << 1) | YES);
	}
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 1860 "gram.y"
    {
		(yyval.intval) = (YES << 1);
	}
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 1866 "gram.y"
    {
		(yyval.intval) = YES;
	}
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 1871 "gram.y"
    {
		/* null token for the purpose of allocating a new rangelist
		 * to be filled in with user data */
		new_staffset();
	}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 1892 "gram.y"
    {
		/* save information about this range in the list */
		/* if only a single number, not a range, rangetail will be
		 * 0, so use num as both beginning and end of range */
		add_staffset( (yyvsp[(1) - (3)].intval), ((yyvsp[(2) - (3)].intval) > 0 ? (yyvsp[(2) - (3)].intval) : (yyvsp[(1) - (3)].intval)), String1, String2);
	}
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 1900 "gram.y"
    {
		/* no end of range, so return 0 as flag that there was only 1 number */
		(yyval.intval) = 0;
	}
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 1907 "gram.y"
    {
		/* make sure isn't 0, because that it illegal and would be used
		 * later as though there were no range. Other error checking
		 * on this number will be done later. */
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("second number of range may not be zero");
		}
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 1918 "gram.y"
    {
		/* no labels */
		String1 = String2 = (char *) 0;
	}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 1925 "gram.y"
    {
		/* save label */
		String1 = (yyvsp[(2) - (4)].stringval);
	}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1931 "gram.y"
    {
		/* no second label */
		String2 = (char *) 0;
	}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1938 "gram.y"
    {
		/* save label2 for later use */
		String2 = (yyvsp[(2) - (2)].stringval);
	}
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1947 "gram.y"
    {
		/* NULL token for allocating space for a bar style list */
		new_barstlist();
	}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1964 "gram.y"
    {
		/* if only 1 number, not range, rangetail will be 0, so use
		 * same number for beginning and end */
		add_barst((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)) );
	}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1972 "gram.y"
    {
		(yyval.intval) = RD_ALL;
	}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1978 "gram.y"
    {
		(yyval.intval) = RD_STANDARD;
	}
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1983 "gram.y"
    {
		Order_place = (yyvsp[(1) - (1)].intval);
		Order_prio = 1;
		if (Currstruct_p != 0) {
			switch ((yyvsp[(1) - (1)].intval)) {
			case PL_ABOVE:
				Currstruct_p->u.ssv_p->used[ABOVEORDER] = YES;
				break;
			case PL_BELOW:
				Currstruct_p->u.ssv_p->used[BELOWORDER] = YES;
				break;
			case PL_BETWEEN:
				Currstruct_p->u.ssv_p->used[BETWEENORDER] = YES;
				break;
			}
		}
	}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 2003 "gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(1) - (1)].intval)] = Order_prio;
		}
	}
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 2011 "gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(3) - (3)].intval)] = ++Order_prio;
		}
	}
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 2019 "gram.y"
    {
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(3) - (3)].intval)] = Order_prio;
		}
	}
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 2026 "gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->markorder[Order_place][(yyvsp[(1) - (1)].intval)] != 0) {
				l_yyerror(Curr_filename, yylineno,
					"order item %s specified more than once", (yyvsp[(1) - (1)].intval));
			}
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 2038 "gram.y"
    {
		(yyval.intval) = MK_MUSSYM;
	}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 2044 "gram.y"
    {
		(yyval.intval) = MK_OCTAVE;
	}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 2050 "gram.y"
    {
		(yyval.intval) = MK_OTHERTEXT;
	}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 2056 "gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case TM_CHORD:
			(yyval.intval) = MK_CHORD;
			break;
		case TM_DYN:
			(yyval.intval) = MK_DYN;
			break;
		default:
			yyerror("invalid text modifier in order list");
			/* set to something valid, since $$ will be used
			 * as an array subscript. */
			(yyval.intval) = MK_CHORD;
			break;
		}
	}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 2075 "gram.y"
    {
		(yyval.intval) = MK_LYRICS;
	}
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 2081 "gram.y"
    {
		(yyval.intval) = MK_ENDING;
	}
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 2087 "gram.y"
    {
		(yyval.intval) = MK_REHEARSAL;
	}
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 2093 "gram.y"
    {
		(yyval.intval) = MK_PEDAL;
	}
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 2099 "gram.y"
    {
		tsig_item(TSR_END);
		if (Currstruct_p != 0 && Currstruct_p->u.ssv_p != 0) {
			MALLOCA(char, Currstruct_p->u.ssv_p->timerep, Tsig_offset);
			strcpy(Currstruct_p->u.ssv_p->timerep, Timerep);
			assign_timesig(Currstruct_p, (yyvsp[(2) - (2)].intval), &Next_alt_timesig);
			Tsig_visibility = (yyvsp[(2) - (2)].intval);
			/* If there are alternating time signatures,
			 * need to save pointer to this list */
			if (Next_alt_timesig != 0) {
				Alt_timesig_list = Timerep;
			}
			else {
				Alt_timesig_list = 0;
			}
		}
		/* Reset for next time signature usage, if any */
		Tsig_offset = 0;
	}
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 2123 "gram.y"
    { tsig_item(TSR_ALTERNATING); }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 2124 "gram.y"
    {
		/* this is for alternating time signature */
	}
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 2130 "gram.y"
    {
	}
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 2134 "gram.y"
    { tsig_item(TSR_ADD); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 2135 "gram.y"
    {
		/* This would be for things like 2/4 + 3/8 */
	}
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 2141 "gram.y"
    {
		tsig_item(TSR_CUT);
	}
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 2147 "gram.y"
    {
		tsig_item(TSR_COMMON);
	}
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 2153 "gram.y"
    {
		tsig_item(TSR_SLASH);
		if ((yyvsp[(3) - (3)].intval) < MINDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be less than %d",
				MINDENOMINATOR);
			(yyvsp[(3) - (3)].intval) = MINDENOMINATOR;
		}
		else if ((yyvsp[(3) - (3)].intval) > MAXDENOMINATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature denominator cannot be greater than %d",
				MAXDENOMINATOR);
			(yyvsp[(3) - (3)].intval) = MAXDENOMINATOR;
		}
		else if (power_of2check((yyvsp[(3) - (3)].intval), "time signature denominator") == NO) {
			(yyvsp[(3) - (3)].intval) = 1 << drmo((yyvsp[(3) - (3)].intval));
		}

		tsig_item((yyvsp[(3) - (3)].intval));
	}
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 2176 "gram.y"
    {
		/* this is something like 3+1/4 where the 1/4 get interpreted
		 * by lexer as quadwhole, but it's really 1 for numerator
		 * and 4 for denominator. 
		 */
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[(3) - (3)].intval));
	}
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 2188 "gram.y"
    {
		tsig_item(1);
		tsig_item(TSR_SLASH);
		tsig_item((yyvsp[(1) - (1)].intval));
	}
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 2202 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) < MINNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be less than %d",
				MINNUMERATOR);
			(yyvsp[(1) - (1)].intval) = MINNUMERATOR;
		}
		else if ((yyvsp[(1) - (1)].intval) > MAXNUMERATOR) {
			l_yyerror(Curr_filename, yylineno,
				"time signature numerator cannot be greater than %d",
				MAXNUMERATOR);
			(yyvsp[(1) - (1)].intval) = MAXNUMERATOR;
		}
		tsig_item((yyvsp[(1) - (1)].intval));
	}
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 2220 "gram.y"
    {
		(yyval.intval) = PTS_ONCE;
	}
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 2226 "gram.y"
    {
		(yyval.intval) = ((yyvsp[(1) - (1)].intval) == YES ? PTS_ALWAYS : PTS_NEVER);
	}
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 2231 "gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 2237 "gram.y"
    {
		/* 'n' is used in various places to mean do NOT
		 * print something that would normally be printed,
		 * so YES means we do want to inhibit the normal printing. */
		(yyval.intval) = YES;
	}
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 2245 "gram.y"
    {
		if ( ((yyvsp[(2) - (3)].intval) != '#') && ((yyvsp[(2) - (3)].intval) != '&') ) {
			yyerror("key signature must include # or &");
		}
		else {
			assign_key((yyvsp[(1) - (3)].intval), (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), Currstruct_p);
		}
	}
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 2256 "gram.y"
    {
		int sharps;

		/* Get number of sharps for the pitch letter */
		sharps = strchr(Circle, (yyvsp[(1) - (3)].intval)) - Circle - 1;

		/* adjust for sharp/flat */
		if ((yyvsp[(2) - (3)].intval) == '#') {
			sharps += 7;
		}
		else if ((yyvsp[(2) - (3)].intval) == '&') {
			sharps -= 7;
		}
		else if ((yyvsp[(2) - (3)].intval) != 0) {
			yyerror("key letter can only be followed by # or &");
			/* set to some ridiculous value, so will fail below */
			sharps = 999;
		}

		/* Adjust if needed for minor */
		if ((yyvsp[(3) - (3)].intval) == YES) {
			sharps -= 3;
		}

		/* disallow illegal keys, like f& */
		if (abs(sharps) > 7) {
			/* print error unless already printed one above */
			if (sharps < 100) {
				yyerror("invalid key--too many sharps or flats");
			}
		}
		else {
			assign_key(abs(sharps), (sharps >= 0 ? '#' : '&'),
							(yyvsp[(3) - (3)].intval), Currstruct_p);
		}
	}
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 2295 "gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) == NO) {
			if ((yyvsp[(2) - (2)].intval) != -1) {
				l_warning(Curr_filename, yylineno,
					"can't use useaccs qualifier with n; ignoring the qualifier");
			}
			(yyval.intval) = UA_N;
		}
		else {
			if ((yyvsp[(2) - (2)].intval) == -1) {
				(yyvsp[(2) - (2)].intval) = UA_Y_NONE;
			}
			(yyval.intval) = (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 2313 "gram.y"
    {
		/* Empty means UA_Y_NONE when used with 'y', but we need
		 * to distinguish temporarily, in case user erroneously
		 * tries to use std with 'n' */
		(yyval.intval) = -1;
	}
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 2322 "gram.y"
    {
		(yyval.intval) = UA_Y_NONE;
	}
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 2328 "gram.y"
    {
		(yyval.intval) = UA_Y_ALL;
	}
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 2334 "gram.y"
    {
		(yyval.intval) = UA_Y_NONNAT;
	}
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 2341 "gram.y"
    {
		asgn_stafflines((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval) == YES ? SS_NOTHING : SS_NORMAL, Currstruct_p);
	}
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 2347 "gram.y"
    {
		asgn_stafflines((yyvsp[(1) - (2)].intval), SS_DRUM, Currstruct_p);
	}
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 2353 "gram.y"
    {
		/* use default tablature */
		if (Currstruct_p != 0) {
			Currstruct_p->u.ssv_p->strinfo = Guitar;
			asgn_stafflines(DEFTABLINES, NO, Currstruct_p);
		}
	}
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 2363 "gram.y"
    {
		/* user-specified tablature */
		asgn_stafflines((yyvsp[(3) - (4)].intval), NO, Currstruct_p);
	}
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 2370 "gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 2376 "gram.y"
    {
		/* count up the number of strings */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 2382 "gram.y"
    {
		/* save info about this tablature string */
		if (Currstruct_p != 0) {
			add_tab_string_info((yyvsp[(1) - (4)].intval), (yyvsp[(2) - (4)].intval), (yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval), Currstruct_p->u.ssv_p);
		}
	}
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 2390 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 2396 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != '&' && (yyvsp[(1) - (1)].intval) != '#') {
			yyerror("accidental on string can only be & or #");
		}
	}
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 2403 "gram.y"
    {
		/* no ticks */
		(yyval.intval) = 0;
	}
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 2410 "gram.y"
    {
		/* limit number of ticks. Has to match the number of bits
		 * used by TMP_NTICKS in grpsyl.c */
		if ((yyvsp[(1) - (1)].intval) > MAXTICKS) {
			l_yyerror(Curr_filename, yylineno,
				"too many ' marks (%d max)", MAXTICKS);
			(yyvsp[(1) - (1)].intval) = MAXTICKS;
		}
	}
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 2421 "gram.y"
    {
		/* only valid letter is y */
		if (*yytext != 'y') {
			yyerror("flag value must be y or n");
		}
		(yyval.intval) = YES;
	}
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 2431 "gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 2436 "gram.y"
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scoresep; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_int(MINSCSEP, (yyvsp[(1) - (1)].intval), Currstruct_p);
		}
	}
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 2449 "gram.y"
    {
		if (Currstruct_p != 0) {
			/* if user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscsep
					> Currstruct_p->u.ssv_p->maxscsep) {
				Currstruct_p->u.ssv_p->maxscsep
					= Currstruct_p->u.ssv_p->minscsep;
			}
			else {
				/* fill in default */
				assign_int(MAXSCSEP, DEFMAXSCSEP, Currstruct_p);
			}
		}
	}
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 2468 "gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscsep > (yyvsp[(2) - (2)].intval)) {
				yyerror("scoresep maximum smaller than minimum");
			}
			assign_int(MAXSCSEP, (yyvsp[(2) - (2)].intval), Currstruct_p);
		}
	}
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 2478 "gram.y"
    {
		if (Currstruct_p == 0) {
			l_warning(Curr_filename, yylineno,
				"wrong context for setting scorepad; ignoring");
		}
		else {
			/* Assign the value of minimum vertical space
			 * between scores. */
			assign_int(MINSCPAD, (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].intval), Currstruct_p);
		}
	}
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 2492 "gram.y"
    {
		if (Currstruct_p != 0) {
			/* If user set minimum greater than default maximum,
			 * adjust maximum to equal the minimum
			 * they specified. */
			if (Currstruct_p->u.ssv_p->minscpad
					> Currstruct_p->u.ssv_p->maxscpad) {
				Currstruct_p->u.ssv_p->maxscpad
					= Currstruct_p->u.ssv_p->minscpad;
			}
			else {
				/* fill in default */
				assign_int(MAXSCPAD, DEFMAXSCPAD, Currstruct_p);
			}
		}
	}
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 2511 "gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.ssv_p->minscpad > (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval)) {
				yyerror("scorepad maximum smaller than minimum");
			}
			assign_int(MAXSCPAD, (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval), Currstruct_p);
		}
	}
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 2522 "gram.y"
    {
	}
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 2527 "gram.y"
    {
		assign_float(MAXPROSHORT, (yyvsp[(2) - (3)].floatval), Currstruct_p);
	}
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 2532 "gram.y"
    {
	}
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 2537 "gram.y"
    {
		if ((yyvsp[(2) - (4)].intval) > (yyvsp[(4) - (4)].intval)) {
			l_warning(Curr_filename, yylineno,
				"distance to begin shortening protruding stems cannot be greater than ending distance; making them equal");
			(yyvsp[(4) - (4)].intval) = (yyvsp[(2) - (4)].intval);
		}
		assign_int(BEGPROSHORT, (yyvsp[(2) - (4)].intval), Currstruct_p);
		assign_int(ENDPROSHORT, (yyvsp[(4) - (4)].intval), Currstruct_p);
	}
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 2552 "gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) == (int) 'a' && (yyvsp[(2) - (2)].intval) >= 4 && (yyvsp[(2) - (2)].intval) <= 6) {
			switch ((yyvsp[(2) - (2)].intval)) {
			case 4:
				(yyval.intval) = PS_A4;
				break;
			case 5:
				(yyval.intval) = PS_A5;
				break;
			case 6:
				(yyval.intval) = PS_A6;
				break;
			default:
				pfatal("impossible pagesize");
				break;
			}
		}
		else {
			yyerror("unsupported pagesize");
		}
	}
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 2577 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 2583 "gram.y"
    {
		(yyval.intval) = ((yyvsp[(1) - (1)].intval) == O_PORTRAIT ? 0 : 1);
	}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 2590 "gram.y"
    {
		assign_vcombine(VC_NOOVERLAP, Currstruct_p);
	}
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 2596 "gram.y"
    {
		assign_vcombine((yyvsp[(2) - (2)].intval), Currstruct_p);
		Defining_multiple = NO;
	}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 2604 "gram.y"
    {
		(yyval.intval) = VC_NOOVERLAP;
	}
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 2610 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 2617 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 2623 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != C_TOP) {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
		(yyval.intval) = ENDING_TOP;
	}
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 2632 "gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 2638 "gram.y"
    {
		(yyval.intval) = -1;
	}
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 2643 "gram.y"
    {
		(yyval.intval) = NO;
	}
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 2649 "gram.y"
    {
		switch ((yyvsp[(1) - (1)].intval)) {
		case MINOR:
			(yyval.intval) = YES;
			break;
		case MAJOR:
			(yyval.intval) = NO;
			break;
		default:
			(yyval.intval) = NO;
			yyerror("must be major or minor");
			break;
		}
	}
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 2665 "gram.y"
    {
		(yyval.intval) = P_LINE;
	}
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 2671 "gram.y"
    {
		(yyval.intval) = P_ALTPEDSTAR;
	}
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 2677 "gram.y"
    {
		(yyval.intval) = P_PEDSTAR;
	}
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 2685 "gram.y"
    {
	}
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 2689 "gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) == FONT_UNKNOWN) {
			(yyvsp[(2) - (2)].intval) = Curr_font;
		}
		if ((yyvsp[(1) - (2)].intval) == FAMILY_DFLT) {
			/* user didn't specify a family. Use the current
			 * family, unless we don't have one yet, in which
			 * case look it up */
			if (Curr_family == FAMILY_DFLT) {
				Curr_family = Score.fontfamily;
			}
			Titlefont =  Curr_family + (yyvsp[(2) - (2)].intval);
		}
		else {
			Titlefont = (yyvsp[(1) - (2)].intval) + (yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 2708 "gram.y"
    {
		(yyval.intval) = FONT_UNKNOWN;
	}
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 2714 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 2719 "gram.y"
    {
		(yyval.intval) = FAMILY_DFLT;
	}
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 2724 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 2729 "gram.y"
    {
		Titlesize = Curr_size;
	}
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 2735 "gram.y"
    {
		Titlesize = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 2741 "gram.y"
    {
		String1 = (yyvsp[(1) - (1)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, Extra);
	}
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 2750 "gram.y"
    {
		double tmp_extra;

		/* If one is taller than the default for the font/size,
		 * figure out how much more to add on. */
		String1 = (yyvsp[(1) - (2)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[(2) - (2)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, Extra);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, (double) 0.0);
	}
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 2769 "gram.y"
    {
		double tmp_extra;
		char *string3;

		String1 = (yyvsp[(1) - (3)].stringval);
		Extra = extra_needed(Titlefont, Titlesize, &String1);
		String2 = (yyvsp[(2) - (3)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &String2);
		Extra = MAX(Extra, tmp_extra);
		string3 = (yyvsp[(3) - (3)].stringval);
		tmp_extra = extra_needed(Titlefont, Titlesize, &string3);
		Extra = MAX(Extra, tmp_extra);

		proc_printcmd(J_LEFT, (struct INPCOORD *) 0, String1,
				Titlefont, Titlesize, YES, NO, Extra);
		proc_printcmd(J_CENTER, (struct INPCOORD *) 0, String2,
				Titlefont, Titlesize, NO, NO, (double) 0.0);
		proc_printcmd(J_RIGHT, (struct INPCOORD *) 0, string3,
				Titlefont, Titlesize, NO, NO, (double) 0.0);
	}
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 2791 "gram.y"
    {
		char *p;		/* pointer through the string */
		int backslash_count;	/* how many backslashes in a row */
		int font, size;		/* at end of \n-delimited segment */
		char *string_start;	/* where current segment begins */

		/* Convert unescaped input newlines to spaces.
		 * The +2 in the 'for' initialization is to skip font/size.
		 */
		backslash_count = 0;
		string_start = (yyvsp[(5) - (7)].stringval);
		/* If we are running on a file using \r or \r\n for
		 * line separator, normalize to \n instead */
		for (p = string_start + 2; *p != 0; p++) {
			if (*p == '\r') {
				if ( *(p+1) != '\n') {
					/* \r by itself. Use \n instead */
					*p = '\n';
				}
				else {
					/* delete the \r */
					char *src, *dest;
					for (src = p + 1, dest = p;  ; src++, dest++) { 
						*dest = *src;
						if (*src == '\0') {
							break;
						}
					}
				}
			}
		}

		font = Titlefont;
		size = Titlesize;
		for (p = string_start + 2; *p != 0; p++) {
			/* Real newlines not preceded by an odd number
			 * of backslashes are converted to spaces. */
			if (*p == '\n' && (backslash_count & 0x1) == 0) {
				*p = ' ';
			}

			/* Count up number of consecutive backslashes.
			 * Also, if user explicitly uses \n, split into
			 * a new paragraph
			 */
			if (*p == '\\') {
				backslash_count++;
				if (((backslash_count & 0x1) == 1)
						&& ( *(p+1) == 'n') ) {
					/* Need to split.
					 * Terminate the current string
					 * where we are in it, and process it,
					 * then arrange to continue processing
					 * on the rest of the string.
					 */
					*p = '\0';
					(void) fix_string(string_start,
						font, size,
						Curr_filename, yylineno);
					String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
					proc_printcmd((yyvsp[(1) - (7)].intval), (struct INPCOORD*) 0,
						String1, font, size,
						YES, NO, 0.0);

					/* The user could change font/size
					 * in mid-string with \f() and/or \s().
					 * so we have to determine what they
					 * are at the end of the current segment
					 * and use that for making the copy
					 * of the remainder of the string.
					 * The original copy of the remainder
					 * of the string gets "memory leaked,"
					 * but this is a rare case, so not
					 * worth worrying about.
					 */
					end_fontsize(String1, &font, &size);
					string_start = copy_string(p+2, font, size);
					p = string_start + 2;
				}
			}
			else {
				backslash_count = 0;
			}
		}
		(void) fix_string(string_start, font, size,
					Curr_filename, yylineno);
		String1 = map_print_str(strdup(string_start), Curr_filename, yylineno);
		proc_printcmd((yyvsp[(1) - (7)].intval), (struct INPCOORD*) 0, String1,
					font, size, YES, NO, 0.0);
	}
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 2884 "gram.y"
    {
		/* Use same paragraph time as last time (or default if
		 * this is the first paragraph ever in this song.) */
		(yyval.intval) = Curr_paratype;
	}
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 2892 "gram.y"
    {
		Curr_paratype = (yyvsp[(1) - (1)].intval);
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 3007 "gram.y"
    {
		/* strip the quotes from the string and make a copy for later use */
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		(yyval.stringval) = copy_string(stripquotes(yytext), Curr_family + Curr_font,
								Curr_size);
	}
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 3018 "gram.y"
    {
		char *old_string;

		/* append new string part to existing part */
		old_string = (yyvsp[(1) - (3)].stringval);
		/* new string part has quotes, so subtract 2 from needed length,
		 * but need space for null, so overall need 1 less. */
		MALLOCA(char, (yyval.stringval), strlen(old_string) + strlen(yytext) - 1);
		sprintf((yyval.stringval), "%s%s", old_string, stripquotes(yytext));
		FREE(old_string);
	}
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 3031 "gram.y"
    {
		(void) contextcheck(C_MUSIC, "music information");
		tssv_line();
		/* reset flags for next voice */
		Defining_multiple = NO;
		Curr_grpsyl_p = (struct GRPSYL *) 0;
		Good_till_canceled = NO;
		free_extra_time();
		Prev_grpsyl_p = 0;
	}
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 3043 "gram.y"
    {
		/* Here's the deal: the staff/voice specification
		 * could be lists of staff ranges and/or voices.
		 * We need a separate copy of the groupinfo
		 * for each staff/voice. So as we parse the sv_spec,
		 * we remember which staffs and voices are specified,
		 * and keep a pointer to the first STAFF in the measure.
		 * Then after collecting the groupinfo,
		 * we make copies of the group info for each staff/voice given.
		 * It has to be copies rather than just a pointer to the
		 * same stuff, because the coordinates will be different
		 * for each staff/voice. */

		/* attach the groupinfo to each of the STAFF structs */
		link_groups();
	}
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 3062 "gram.y"
    {
		add_multirest((yyvsp[(2) - (3)].intval));
		/* If there are alternating time signatures, figure out
		 * which one should be in effect at the end of the multirest */
		if (Alt_timesig_list != 0) {
			int m;

			/* The Next_alt_timesig is already pointing to
			 * the value for after the first measure in the
			 * multirest, so have to subtract 1 here */
			for (m = 0; m < (yyvsp[(2) - (3)].intval) - 1; m++) {
				if (Next_alt_timesig == 0) {
					/* Shouldn't really ever get here,
					 * since other code should do the
					 * wrap-around, but just in case... */
					Next_alt_timesig = Alt_timesig_list;
					continue;
				}
				do {
					Next_alt_timesig++;
					if (*Next_alt_timesig == TSR_END) {
						Next_alt_timesig = Alt_timesig_list;
						break;
					}
				} while (*Next_alt_timesig != TSR_ALTERNATING);
			}
			if (*Next_alt_timesig == TSR_ALTERNATING) {
				Next_alt_timesig++;
			}
		}
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 3097 "gram.y"
    {
		free_staffrange();
	}
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 3102 "gram.y"
    {
		begin_range(PL_UNKNOWN);
	}
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 3107 "gram.y"
    {
		Chord_at_a_time = NO;
	}
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 3113 "gram.y"
    {
		Chord_at_a_time = YES;
	}
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 3128 "gram.y"
    {
		begin_map();
	}
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 3133 "gram.y"
    {
		end_map();
	}
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 3138 "gram.y"
    {
		map_item();
	}
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 3144 "gram.y"
    {
		map_item();
		Defining_multiple = YES;
	}
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 3150 "gram.y"
    {
		/* initialize grpsyl info */
		Curr_grpsyl_p = Last_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 3160 "gram.y"
    {
		/* prepare for a new set of ranges */
		begin_range(Place);
		Defining_multiple = YES;
	}
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 3167 "gram.y"
    {
		/* data is for staff with only one voice */
		save_vno_range(1, 1);
		add_to_sv_list();
	}
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 3175 "gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) == YES) {
			add_to_sv_list();
		}
	}
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 3184 "gram.y"
    {
		/* set flag as to whether we are processing tab staff
		 * information or normal staff info */
		Doing_tab_staff = is_tab_range();
	}
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 3194 "gram.y"
    {
		/* several staffs have the same note data */
		Defining_multiple = YES;
	}
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 3200 "gram.y"
    {
		/* remember which staffs we are currently getting data for */
		/* if only a single number, not a range, staff_range will be
		 * 0, so use staffnum as high and low of range */
		save_staff_range((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)));
	}
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 3208 "gram.y"
    {
		/* empty - no range, just a single number */
		(yyval.intval) = 0;
	}
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 3215 "gram.y"
    {
		Defining_multiple = YES;
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 3225 "gram.y"
    {
		/* note data applies to a single voice */
		if (rangecheck((yyvsp[(1) - (2)].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			save_vno_range((yyvsp[(1) - (2)].intval), (yyvsp[(1) - (2)].intval));
			(yyval.intval) = YES;
		}
		else {
			(yyval.intval) = NO;
		}
	}
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 3238 "gram.y"
    {
		/* note data applies to range of voices */
		if (rangecheck((yyvsp[(1) - (4)].intval), MINVOICES, MAXVOICES, "voice") == YES &&
				rangecheck((yyvsp[(3) - (4)].intval), MINVOICES, MAXVOICES, "voice") == YES) {
			if ((yyvsp[(3) - (4)].intval) < (yyvsp[(1) - (4)].intval)) {
				l_yyerror(Curr_filename, yylineno,
					"end of voice range is smaller than beginning");
				(yyval.intval) = NO;
			}
			else {
				save_vno_range((yyvsp[(1) - (4)].intval), (yyvsp[(3) - (4)].intval));
				Defining_multiple = YES;
				(yyval.intval) = YES;
			}
		}
		else {
			(yyval.intval) = NO;
		}
	}
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 3263 "gram.y"
    {
		Defining_multiple = YES;
	}
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 3278 "gram.y"
    {
		/* Associate any TIMEDSSVs with this group */
		if (Curr_tssv_p != 0) {
			tssv_setgrpsyl(Curr_grpsyl_p);
			Curr_tssv_p = 0;
		}

		/* if no custom beaming indicated, fill in based on previous. */
		if ( Curr_grpsyl_p->beamloc == NOITEM) {
			setbeamloc(Curr_grpsyl_p, Last_grpsyl_p);
		}

		/* later we check that if there is an 'm', it is
		 * the only thing in the measure */

		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		Curr_marklist = 0;
		/* Save pointer to this group, in case there are additive
		 * times, and the next group gets its time value from this
		 * group. In that case, we need this group, not the last one
		 * of the added groups. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* Add groups if there were additive time values. */
		if (Extra_time_p != 0) {
			Curr_grpsyl_p = expandgrp(Curr_grpsyl_p, Extra_time_p);
			/* If there was a custom beam ebm on something with
			 * additive time, we need make sure ENDITEM is on only
			 * the last of the expanded groups. */
			if (Curr_grpsyl_p != Prev_grpsyl_p
					&& Prev_grpsyl_p->beamloc == ENDITEM) {
				struct GRPSYL *g_p;
				for (g_p = Prev_grpsyl_p; g_p != Curr_grpsyl_p;
							g_p = g_p->next) {
					g_p->beamloc = INITEM;
				}
				Curr_grpsyl_p->beamloc = ENDITEM;
			}
			Last_grpsyl_p = Curr_grpsyl_p->prev;
		}
		Curr_timelist_p = 0;
	}
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 3336 "gram.y"
    {
		if (Chord_at_a_time == YES) {
			yyerror("mid-measure changes not allowed on chord-at-a-time input");
		}
	}
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 3345 "gram.y"
    {
		Curr_tssv_p = tssv_create(C_SCORE);
	}
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 3351 "gram.y"
    {
		Curr_tssv_p = tssv_create(C_STAFF);
	}
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 3357 "gram.y"
    {
		Curr_tssv_p = tssv_create(C_VOICE);
	}
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 3371 "gram.y"
    {
		if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->grpsyl == GS_GROUP
				&& Curr_grpsyl_p->grpvalue == GV_ZERO) {
			yyerror("mid-measure clef change not allowed after grace note\n");
		}
		tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
	}
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 3381 "gram.y"
    {
		switch ((yyvsp[(1) - (3)].intval)) {

		case DEFOCT:
		case RELEASE:
			tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 3398 "gram.y"
    {
		switch ((yyvsp[(1) - (3)].intval)) {

		case ALIGNRESTS:
			tssv_update(Curr_tssv_p, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval));
			break;

		default:
			l_warning(Curr_filename, yylineno,
				"parameter type cannot be changed mid-measure; ignoring");
			break;
		}
	}
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 3418 "gram.y"
    {
		if (Good_till_canceled == NO) {
			/* use default attributes */
			Curr_grpsyl_p->grpvalue = GV_NORMAL;
			Curr_grpsyl_p->grpsize = GS_NORMAL;
			Curr_grpsyl_p->headshape = HS_UNKNOWN;
		}
		else {
			/* re-use previous style */
			copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
			Curr_grpsyl_p->with_was_gtc = YES;
		}
	}
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 3434 "gram.y"
    {
		Good_till_canceled = NO;
	}
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 3440 "gram.y"
    {
	}
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 3444 "gram.y"
    {
		Good_till_canceled = NO;
	}
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 3450 "gram.y"
    {
		Good_till_canceled = YES;
	}
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 3455 "gram.y"
    {
	}
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 3460 "gram.y"
    {
		if (Good_till_canceled == YES) {
			yyerror("can't use ... and more than one [] on same chord");
		}
	}
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 3467 "gram.y"
    {
		/* NULL token to cause allocation of a GRPSYL struct */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_GROUP);
	}
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 3474 "gram.y"
    {
		/* an empty marklist means we should use
		 * the same attributes as the last time */
		copy_attributes(Curr_grpsyl_p, Last_grpsyl_p);
	}
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 3491 "gram.y"
    {
		Curr_grpsyl_p->nwith = (short) Item_count;
		Curr_grpsyl_p->withlist = Curr_marklist;
	}
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 3507 "gram.y"
    {
		if (Curr_grpsyl_p->stemdir != UNKNOWN &&
					Curr_grpsyl_p->stemdir != (yyvsp[(1) - (1)].intval)) {
			l_warning(Curr_filename, yylineno,
				"both stem directions specified; using last instance");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"stem direction specification is pointless on tab staff; ignoring");
		}
		else {
			Curr_grpsyl_p->stemdir = (yyvsp[(1) - (1)].intval);
		}
	}
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 3524 "gram.y"
    {
		if ((yyvsp[(1) - (3)].intval) != DIST) {
			l_warning(Curr_filename, yylineno,
				"unexpected parameter name; ignoring");
		}
		else {
			if (Curr_grpsyl_p->restdist != NORESTDIST &&
					Curr_grpsyl_p->restdist != (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval)) {
				l_warning(Curr_filename, yylineno,
						"more than one dist value specified; using last instance");
			}
			Curr_grpsyl_p->restdist = (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].intval);
		}
	}
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 3541 "gram.y"
    {
		if (Curr_grpsyl_p->ho_usage != HO_NONE &&
				Curr_grpsyl_p->ho_usage != (yyvsp[(2) - (2)].intval)) {
			l_warning(Curr_filename, yylineno,
				"More than one ho type specified; last instance used");
		}
		Curr_grpsyl_p->ho_usage = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 3552 "gram.y"
    {
		if (Curr_grpsyl_p != 0) {
			if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
				l_warning(Curr_filename, yylineno,
					"multiple head shapes specified, using last");
			}
			/* +2 to skip past extraneous font/size */
			if (Doing_tab_staff == YES && strcmp((yyvsp[(2) - (2)].stringval) + 2, "allx") != 0) {
				yyerror("allx is the only headshape allowed on tab staffs");
			}
			if ((Curr_grpsyl_p->headshape = get_shape_num((yyvsp[(2) - (2)].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[(2) - (2)].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			pfatal("Curr_grpsyl_p was null for setting hs");
		}
		/* We don't need the name anymore; we have its corresponding
		 * number that we use internally. */
		FREE((yyvsp[(2) - (2)].stringval));
	}
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 3579 "gram.y"
    {
		if (Curr_grpsyl_p->stemlen != STEMLEN_UNKNOWN &&
				fabs(Curr_grpsyl_p->stemlen - (yyvsp[(2) - (2)].floatval) * STEPSIZE) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"more than one len specified; using last instance");
		}
		Curr_grpsyl_p->stemlen = (yyvsp[(2) - (2)].floatval) * STEPSIZE;
	}
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 3590 "gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) <= 0) {
			yyerror("slash number must be > 0");
		}
		else if ((yyvsp[(2) - (2)].intval) > 8) {
			/* we decided 8 slashes would be at least 256th note
			 * or shorter, and 256th is the shortest note we
			 * support, 8 slashes is plenty */
			l_warning(Curr_filename, yylineno,
				"number of slashes only allowed to be <= 8; limiting to 8");
			(yyvsp[(2) - (2)].intval) = 8;
		}
		if (Curr_grpsyl_p->slash_alt > 0 &&
					Curr_grpsyl_p->slash_alt != (yyvsp[(2) - (2)].intval)) {
			l_warning(Curr_filename, yylineno,
				"more than one slash value specified; using last instance");
		}
		if (Curr_grpsyl_p->slash_alt < 0) {
			yyerror("only one slash/alt allowed per group");
		}
		Curr_grpsyl_p->slash_alt = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 3615 "gram.y"
    {
		(yyval.intval) = HO_RIGHT;
	}
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 3621 "gram.y"
    {
		(yyval.intval) = HO_LEFT;
	}
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 3627 "gram.y"
    {
		/* We want to silently accept identical values specified
		 * more than once, so use fuzzy compare to deal with roundoff */
		if (Curr_grpsyl_p->ho_usage == HO_VALUE &&
				fabs(Curr_grpsyl_p->ho_value - (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval)) > 0.0001) {
			l_warning(Curr_filename, yylineno,
				"More than one ho value specified; last instance used");
		}
		if ((yyvsp[(1) - (2)].intval) == 0) {
			Curr_grpsyl_p->ho_value = (yyvsp[(2) - (2)].floatval);
		}
		else {
			Curr_grpsyl_p->ho_value = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval);
		}
		(yyval.intval) = HO_VALUE;
	}
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 3646 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 3652 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 3674 "gram.y"
    {
		(yyvsp[(3) - (3)].floatval) *= (yyvsp[(2) - (3)].intval);
		if (fabs(Curr_grpsyl_p->beamslope - NOBEAMANGLE) > 0.01) {
			l_warning(Curr_filename, yylineno,
				"multiple slope values specified; using last one");
		}
		if (frangecheck((yyvsp[(3) - (3)].floatval), MINBEAMANGLE, MAXBEAMANGLE, "slope") == YES) {
			Curr_grpsyl_p->beamslope = (yyvsp[(3) - (3)].floatval);
		}
	}
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 3687 "gram.y"
    {
		if ((yyvsp[(2) - (2)].intval) <= 0) {
			yyerror("alt number must be > 0");
		}
		if (Curr_grpsyl_p->slash_alt != 0) {
			yyerror("only one slash/alt allowed per group");
		}
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"alt not allowed on tablature staff; ignoring");
		}
		else {
			/* Should at least keep small enough
			 * that 1 shifted left by this still fits
			 * in a 16-bit int. For a while we limited to 15,
			 * but for slashes, we limit to 8, and
			 * that seems like more than enough for here too. */
			if ((yyvsp[(2) - (2)].intval) > 8) {
				l_warning(Curr_filename, yylineno,
					"alt value too large; limiting to 8");
				(yyvsp[(2) - (2)].intval) = 8;
			}
			Curr_grpsyl_p->slash_alt = -(yyvsp[(2) - (2)].intval);
		}
	}
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 3715 "gram.y"
    {
		if (Curr_grpsyl_p->phcount < PH_COUNT) {
			Curr_grpsyl_p->phplace[Curr_grpsyl_p->phcount++] = (yyvsp[(2) - (2)].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many ph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 3727 "gram.y"
    {
		if (Curr_grpsyl_p->ephcount < PH_COUNT) {
			Curr_grpsyl_p->ephcount++;
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"too many eph marks on the same chord; limiting to %d", PH_COUNT);
		}
	}
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 3738 "gram.y"
    {
		int n;

		/* add a slur to each note in the chord. Don't know
		 * which pitch to slur to yet, just that it will be to
		 * the "matching" note in the next chord, so use
		 * special magic pitch of 'M' to convey this */
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			add_slurto(Curr_grpsyl_p, 'M', USE_DFLT_OCTAVE, n, (yyvsp[(1) - (3)].intval));
			set_slurdir(Curr_grpsyl_p, -1, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval));
		}
	}
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 3753 "gram.y"
    {
		int n;

		Curr_grpsyl_p->tie = YES;
		for (n = 0; n < Curr_grpsyl_p->nnotes; n++) {
			Curr_grpsyl_p->notelist[n].tie = YES;
			Curr_grpsyl_p->notelist[n].tiestyle = (yyvsp[(1) - (3)].intval);
			Curr_grpsyl_p->notelist[n].tiedir = (yyvsp[(2) - (3)].intval);
			Curr_grpsyl_p->notelist[n].tied_to_voice = (yyvsp[(3) - (3)].intval);
		}
	}
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 3766 "gram.y"
    {
		if (Curr_marklist == 0) {
			/* allocate space for a list of marks */
			MALLOCA(char *, Curr_marklist, ITEMS);
			Item_count = 0;
			Max_items = ITEMS;
		}
	}
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 3776 "gram.y"
    {
		(yyval.intval) = UNKNOWN;
	}
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 3782 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 3788 "gram.y"
    {
		(yyval.intval) = NO_TO_VOICE;
	}
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 3794 "gram.y"
    {
		if ((yyvsp[(3) - (3)].intval) >= MINVOICES && (yyvsp[(3) - (3)].intval) <= MAXVOICES) {
			/* Note that if the current staff doesn't have this
			 * to voice, that error will be caught later,
			 * by find_to_group() in tie.c */
			(yyval.intval) = (yyvsp[(3) - (3)].intval);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"to voice must be between %d and %d",
					MINVOICES, MAXVOICES);
			(yyval.intval) = NO_TO_VOICE;
		}
	}
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 3817 "gram.y"
    {
		/* if too many items, get some more space */
		if (Item_count >= Max_items) {
			Max_items += ITEMS;
			if ((Curr_marklist = (char **) realloc(Curr_marklist,
						Max_items * sizeof(char **)))
						== (char **) 0) {
				l_no_mem(__FILE__, __LINE__);
			}
		}
		Curr_marklist[Item_count++] = (yyvsp[(1) - (1)].stringval);
	}
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 3831 "gram.y"
    {
		MALLOCA(char, (yyval.stringval), strlen((yyvsp[(1) - (1)].stringval)) + 3);
		(yyval.stringval)[0] = FONT_TR;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, (yyvsp[(1) - (1)].stringval));
	}
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 3844 "gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(dot)" : "\\(smdot)");
	}
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 3851 "gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(leg)" : "\\(smleg)");
	}
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 3858 "gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_gt)" : "\\(smacc_gt)");
	}
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 3865 "gram.y"
    {
		(yyval.stringval) = (Curr_grpsyl_p->grpsize == GS_NORMAL
					? "\\(acc_hat)" : "\\(smacc_hat)");
	}
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 3871 "gram.y"
    {
		if (Curr_grpsyl_p->grpvalue == GV_ZERO) {
			l_warning(Curr_filename, yylineno,
				"both grace and cue specified; using last instance");
		}
		Curr_grpsyl_p->grpvalue = GV_NORMAL;
		Curr_grpsyl_p->grpsize = GS_SMALL;
	}
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 3882 "gram.y"
    {
		if (Curr_grpsyl_p->grpsize == GS_SMALL
					&& Curr_grpsyl_p->grpvalue != GV_ZERO) {
			l_warning(Curr_filename, yylineno,
				"both cue and grace specified; using last instance");
		}

		Curr_grpsyl_p->grpsize = GS_SMALL;
		Curr_grpsyl_p->grpvalue = GV_ZERO;
	}
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 3895 "gram.y"
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"diam is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num("diam");
	}
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 3905 "gram.y"
    {
		if (Curr_grpsyl_p->headshape != HS_UNKNOWN) {
			l_warning(Curr_filename, yylineno,
				"xnote is overriding previous headshapes specification");
		}
		Curr_grpsyl_p->headshape = get_shape_num(
					Doing_tab_staff == YES ? "allx" : "x");
	}
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 3916 "gram.y"
    {
		(yyval.intval) = UP;
	}
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 3922 "gram.y"
    {
		(yyval.intval) = DOWN;
	}
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 3928 "gram.y"
    {
		/* custom beaming cannot be nested */
		struct GRPSYL *prev_like_gs_p;
		/* Find previous group with same grace-ness. Can't use
		 * prevsimilar() here, since it looks at grpcont too. */
		for (prev_like_gs_p = Last_grpsyl_p; prev_like_gs_p != 0 &&
			prev_like_gs_p->grpvalue != Curr_grpsyl_p->grpvalue;
			prev_like_gs_p = prev_like_gs_p->prev) {
			;
		}
		if (prev_like_gs_p != 0 &&
				((prev_like_gs_p->beamloc == STARTITEM)
				|| (prev_like_gs_p->beamloc == INITEM)) ) {
			yyerror("custom beaming may not be nested");
		}
		/* Non-custom beaming, if any, is done later, in do_bar() */
		else {
			/* begin custom beaming */
			Curr_grpsyl_p->beamloc = STARTITEM;
			if (Curr_grpsyl_p->basictime < 8 && (yyvsp[(2) - (2)].intval) == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
		Curr_grpsyl_p->beamto = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 3956 "gram.y"
    {
		Curr_grpsyl_p->breakbeam = YES;
	}
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 3962 "gram.y"
    {
		struct GRPSYL *last_nongrace_p;

		/* find the previous group, skipping grace groups */
		for (last_nongrace_p = Last_grpsyl_p;
				last_nongrace_p != (struct GRPSYL *) 0
				&& last_nongrace_p->grpvalue == GV_ZERO;
				last_nongrace_p = last_nongrace_p->prev) {
			;
		}

		/* check that a custom beam is in progress */
		if ((last_nongrace_p == (struct GRPSYL *) 0)
				|| ((last_nongrace_p != (struct GRPSYL *) 0)
				&& (last_nongrace_p->beamloc != STARTITEM)
				&& (last_nongrace_p->beamloc != INITEM) )) {
			l_warning(Curr_filename, yylineno,
				"'ebm' unexpected: no custom beaming in progress; ignoring");
		}
		else {
			Curr_grpsyl_p->beamloc = ENDITEM;
			Curr_grpsyl_p->beamto = last_nongrace_p->beamto;
			if (Curr_grpsyl_p->basictime < 8
					&& Last_grpsyl_p->beamto == CS_SAME) {
				yyerror("beamed notes must be 8th or shorter");
			}
		}
	}
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 3992 "gram.y"
    {
		/* Use the same as last time or default timeunit.
		 * If that involves additive time values,
		 * save pointer to that info in Extra_time_p for later use. */
		Extra_time_p = copy_timeunit(Curr_grpsyl_p, Prev_grpsyl_p,
						Extra_time_p);
	}
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 4002 "gram.y"
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			Curr_grpsyl_p->fulltime = Score.time;
		}
		else {
			Curr_grpsyl_p->fulltime = (yyvsp[(1) - (1)].ratval);
		}
	}
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 4012 "gram.y"
    {
		(yyval.intval) = CS_SAME;
	}
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 4018 "gram.y"
    {
		CSBused = YES;
		switch ((yyvsp[(3) - (3)].intval)) {
		case PL_ABOVE:
			(yyval.intval) = CS_ABOVE;
			break;
		case PL_BELOW:
			(yyval.intval) = CS_BELOW;
			break;
		default:
			yyerror("bm with staff must be 'above' or 'below'");
			(yyval.intval) = CS_SAME;
		}
	}
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 4034 "gram.y"
    {
		(yyval.ratval).n = (yyvsp[(1) - (1)].intval);
		(yyval.ratval).d = 1;

		/* if filling in a GRPSYL struct, need to fill in basic time,
		 * could also be here due to beamstyle, in which case the
		 * Curr_grpsyl_p will be NULL, or when getting tuplet duration,
		 * in which case flag will be set */
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			/* If we are gathering basictime as part of a list
			 * of additive times, we will save the value a few
			 * lines down from here. But in the normal case,
			 * we set basictime in the current GRPSYL. */
			if (Extra_time_p == 0) {
				/* 1/2 is 0 internally. 1/4 is -1 internally */
				 Curr_grpsyl_p->basictime = ((yyvsp[(1) - (1)].intval) == 2 ? 0 : -1);
			}
		}
		/* If doing additive times, need to save value. */
		if (Extra_time_p != 0) {
			Extra_basictime = ((yyvsp[(1) - (1)].intval) == 2 ? 0 : -1);
		}
	}
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 4061 "gram.y"
    {
		/* check that a power of two from 1 to MAXBASICTIME */
		if (power_of2check((yyvsp[(1) - (1)].intval), "note basic time value") == NO) {
			/* force to a power to two, so that other code
			 * (like in expandgrp) that expect a sane value
			 * will not blow up. This may lead to a somewhat
			 * misleading "time does not add up to time
			 * signature" message, but we don't know what
			 * time they really meant, and this is better
			 * than pfataling. */
			(yyvsp[(1) - (1)].intval) = 2;
		}
		/* can't use rangecheck here because the error message would
		 * say 0 and -1 are valid times, which is only true internally--
		 * the user has to use 1/2, 1/4 or m. */
		if ((yyvsp[(1) - (1)].intval) < MINBASICTIME || (yyvsp[(1) - (1)].intval) > MAXBASICTIME) {
			l_yyerror(Curr_filename, yylineno,
				"time value must be between 1 and %d, or 1/2 or 1/4 or m",
				MAXBASICTIME);
			/* If user entered outrageous value, clamp to
			 * something semi-reasonable, else we could get
			 * rational overflow, and pfatal, even though it
			 * it is really a user error. */
			if ((yyvsp[(1) - (1)].intval) > MAXBASICTIME * 4) {
				(yyvsp[(1) - (1)].intval) = MAXBASICTIME * 4;
			}
		}
		(yyval.ratval).n = 1;
		/* avoid division by zero */
		if ((yyvsp[(1) - (1)].intval) == 0) {
			(yyvsp[(1) - (1)].intval) = 1;
		}
		(yyval.ratval).d = (yyvsp[(1) - (1)].intval);
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			if (Curr_timelist_p == 0) {
				Curr_grpsyl_p->basictime = (yyvsp[(1) - (1)].intval);
			}
		}
		/* If doing additive times, need to save value */
		if (Extra_time_p != 0) {
			Extra_basictime = (yyvsp[(1) - (1)].intval);
		}
	}
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 4108 "gram.y"
    {
		free_extra_time();
	}
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 4118 "gram.y"
    {
		/* Set basictime to what we saved in basic_time_val rule,
		 * then calculate fulltime from that and number of dots. */
		Curr_timelist_p->basictime = Extra_basictime;
		Curr_timelist_p->fulltime = calcfulltime((yyvsp[(3) - (4)].ratval), (yyvsp[(4) - (4)].intval));
		/* handle subtracted times by negating the fulltime */
		if ((yyvsp[(1) - (4)].intval) == -1) {
			Curr_timelist_p->fulltime = rneg(Curr_timelist_p->fulltime);
		}
	}
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 4132 "gram.y"
    {
		struct TIMELIST *timelist_p;

		MALLOC(TIMELIST, timelist_p, 1);
		/* Add to end of linked list */
		timelist_p->next = 0;
		/* Init fulltime to something to avoid garbage if there
		 * in a user input error */
		timelist_p->fulltime = Zero;
		if (Extra_time_p == 0) {
			Last_alloced_timelist_p = Extra_time_p = timelist_p;
		}
		else {
			Curr_timelist_p->next = timelist_p;
		}
		/* Keep track of where to append next item to list, if any */
		Curr_timelist_p = timelist_p;
	}
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 4153 "gram.y"
    {
		User_meas_time = NO;
	}
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 4159 "gram.y"
    {
		if (Curr_grpsyl_p != (struct GRPSYL *) 0
					&& Getting_tup_dur == NO) {
			Curr_grpsyl_p->is_meas = YES;
			User_meas_time = YES;
		}
		else {
			yyerror("'m' is not valid here");
		}
	}
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 4171 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 4177 "gram.y"
    {
		/* count up the number of dots */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 4183 "gram.y"
    {
		/* We can't distinguish between the default 0.0 and
		 * if user explicitly sets to 0.0, so if they set to 0.0
		 * then to something else, we won't catch that as setting
		 * twice, but that shouldn't be common. Besides, if they
		 * expect them to be additive, adding to zero will work
		 * as they expect... Because of roundoff, we can't do
		 * exact compare for specifying the same value more than once,
		 * so treat as identical if pretty close. */
		if (Curr_grpsyl_p->padding != 0.0 && 
				fabs(Curr_grpsyl_p->padding - ((yyvsp[(1) - (1)].floatval) * STEPSIZE))
				> 0.0001) {
			l_warning(Curr_filename, yylineno,
				"padding specified more than once; using last instance");
		}
		Curr_grpsyl_p->padding = (yyvsp[(1) - (1)].floatval) * STEPSIZE;
	}
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 4203 "gram.y"
    {
		(yyval.floatval) = (float) (yyvsp[(2) - (3)].intval) * (yyvsp[(3) - (3)].floatval);
	}
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 4208 "gram.y"
    {
		/* no sign--must be a positive number */
		(yyval.intval) = 1;
	}
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 4215 "gram.y"
    {
		/* user wants a negative number */
		(yyval.intval) = -1;
	}
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 4221 "gram.y"
    {
		Curr_grpsyl_p->grpcont = GC_NOTES;
		if ((yyvsp[(1) - (1)].intval) == 0) {
			/* no notes listed, use same as previous group */
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else {
			resize_notelist(Curr_grpsyl_p);
		}
	}
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 4246 "gram.y"
    {
		/* allocate GRPSYL for the case where everything is defaulted
		 * from the previous group, with just an extra attribute
		 * like ? or ~ specified. */
		if (Curr_grpsyl_p == (struct GRPSYL *) 0) {
			/* shouldn't ever happen, but just in case... */
			Curr_grpsyl_p = newGRPSYL(GS_GROUP);
		}
		if (Last_grpsyl_p != (struct GRPSYL *) 0 &&
					Last_grpsyl_p->nnotes >= 1) {
			copy_notes(Curr_grpsyl_p, Last_grpsyl_p);
		}
		else if (Last_grpsyl_p != (struct GRPSYL *) 0 && 
				Last_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpcont = GC_REST;
		}
	}
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 4266 "gram.y"
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
						.notesize = GS_SMALL;
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			Curr_grpsyl_p->grpsize  = GS_SMALL;
		}
		else {
			yyerror("no note specified for '?'");
		}
	}
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 4282 "gram.y"
    {
		if (Curr_grpsyl_p->grpcont != GC_NOTES) {
			yyerror("can't tie a rest or space");
		}
		else if (Curr_grpsyl_p->nnotes > 0) {
			struct NOTE *n_p;
			n_p = &(Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]);
			n_p->tie = YES;
			n_p->tiestyle = (yyvsp[(1) - (3)].intval);
			n_p->tiedir = (yyvsp[(2) - (3)].intval);
			n_p->tied_to_voice = (yyvsp[(3) - (3)].intval);
		}
		else {
			yyerror("no note specified for '~'");
		}
	}
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 4301 "gram.y"
    {
		if (Curr_grpsyl_p->nnotes > 0) {
			switch (Curr_grpsyl_p->notelist
                                        [Curr_grpsyl_p->nnotes - 1].letter) {
			case PP_REST:
				/* If we haven't already allocated space for
				 * the restc array, so that now. It could
				 * already be allocated if user specified
				 * more than one tag. */
				if (Curr_grpsyl_p->restc == 0) {
					MALLOCA(float, Curr_grpsyl_p->restc, NUMCTYPE);
				}
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->restc, CT_NOTE);
				break;
			case PP_SPACE:
			case PP_RPT:
			case PP_NO_PITCH:  /* this one not really possible */
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
				break;
			default:
				addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->notelist
					[Curr_grpsyl_p->nnotes - 1].c, CT_NOTE);
				break;
			}
			var_valid();
		}
		else if (Curr_grpsyl_p->grpcont == GC_REST) {
			/* This should really never be hit anymore since
			 * chord-at-a-time code was added, but shouldn't
			 * hurt to leave it, just in case. */
			addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"no note specified for location tag '%s'", (yyvsp[(2) - (2)].stringval));
		}
	}
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 4342 "gram.y"
    {
		/* this is for bend on a non-tablature staff */
		if (Doing_tab_staff == YES) {
			yyerror("^ bend not allowed on tablature staff; use quoted bend string");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval),
					Curr_grpsyl_p->nnotes - 1, L_NORMAL);
			if (Curr_grpsyl_p->nnotes > 0) {
				Curr_grpsyl_p->notelist
						[Curr_grpsyl_p->nnotes - 1]
						.is_bend = YES;
			}
		}
	}
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 4360 "gram.y"
    {
		/* this is for a small bend (1/4 step) on a non-tab staff */
		if (Doing_tab_staff == YES) {
			yyerror("^/ not allowed on tablature staff; use quoted bend string");
		}
		else if (Curr_grpsyl_p != 0 && Curr_grpsyl_p->nnotes > 0) {
			Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.smallbend = YES;
		}
	}
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 4373 "gram.y"
    {
		if (Curr_grpsyl_p->grpcont == GC_NOTES &&
					Curr_grpsyl_p->nnotes > 0) {
			if ((Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1]
					.headshape = get_shape_num((yyvsp[(2) - (2)].stringval) + 2))
					== HS_UNKNOWN) {
				l_yyerror(Curr_filename, yylineno,
					"'%s' is not a valid head shape name",
					ascii_str((yyvsp[(2) - (2)].stringval), YES, NO, TM_NONE));
			}
		}
		else {
			yyerror("no note specified for headshape");
		}
		FREE((yyvsp[(2) - (2)].stringval));
	}
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 4402 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + (yyvsp[(2) - (2)].intval);	/* total number of notes */
	}
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 4408 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 4414 "gram.y"
    {
		switch ((yyvsp[(3) - (3)].intval)) {
		case PL_ABOVE:
			Curr_grpsyl_p->stemto = CS_ABOVE;
			break;
		case PL_BELOW:
			Curr_grpsyl_p->stemto = CS_BELOW;
			break;
		default:
			yyerror("cross staff stem must be with 'above' or 'below'");
			Curr_grpsyl_p->stemto = CS_SAME;
		}
		if ((yyvsp[(2) - (3)].intval) == 0) {
			/* Maybe this wouldn't really hurt to allow,
			 * but it's rather silly--why would user bother to go
			 * to the trouble of saying there are cross staff stem
			 * notes, but then not list any?
			 */
			yyerror("cross-staff stem note list is empty");
		}

		/* It doesn't make sense to do "with r below" or "with s below"
		 * since we don't allow mixing rests and notes, and the only
		 * reason for CSS is for something that has a stem. */
		else if ((yyvsp[(2) - (3)].intval) > 0) {
			int idx;
			int pitch;

			for (idx = FCNI(Curr_grpsyl_p);
					idx <= LCNI(Curr_grpsyl_p); idx++) {
				pitch = Curr_grpsyl_p->notelist[idx].letter;
				if (pitch == PP_REST || pitch == PP_SPACE) {
					yyerror("can't use with above/below on rest or space");
				}
			}
		}
		(yyval.intval) = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 4454 "gram.y"
    {
		CSSused = YES;
		Curr_grpsyl_p->stemto_idx = Curr_grpsyl_p->nnotes;
	}
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 4460 "gram.y"
    {
		/* No notes.  If this is for the list of "normal" staff notes,
		 * and there are no "other" staff notes (for cross-staff stems),
		 * this means use the same notes as the last group. */
		(yyval.intval) = 0;
	}
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 4469 "gram.y"
    {
		/* return number of notes in notelist */
		(yyval.intval) = (yyvsp[(1) - (3)].intval) + 1;
	}
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 4478 "gram.y"
    {
		add_note(Curr_grpsyl_p, (int) PP_REST, No_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
	}
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 4485 "gram.y"
    {
		/* temporarily stash uncompressibility (NO in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, NO,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure space is pointless; ignoring");
		}
	}
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 4498 "gram.y"
    {
		/* temporarily stash uncompressibility (YES in this case)
		 * in the octave field */
		add_note(Curr_grpsyl_p, (int) PP_SPACE, No_accs, YES,
							0, NO, (char *) 0);
		if (Curr_grpsyl_p->is_meas == YES && User_meas_time == YES) {
			l_warning(Curr_filename, yylineno,
				"specifying time value on measure uncollapseable space is pointless; ignoring");
		}
	}
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 4511 "gram.y"
    {
		if (Curr_grpsyl_p->is_meas == YES) {
			if (User_meas_time == YES) {
				l_warning(Curr_filename, yylineno,
					"specifying time value on measure repeat is pointless; ignoring");
			}
		}
		else {
			yyerror("rpt can only be used with m");
		}
		add_note(Curr_grpsyl_p, (int) PP_RPT, No_accs, USE_DFLT_OCTAVE,
							0, NO, (char *) 0);
	}
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 4527 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == SINGLEBAR) {
			/* lexer thinks this is 'bar'
			 * but is really 'b' 'a' 'r' */
			keyword_notes(yytext);
		}
		else if ((yyvsp[(1) - (1)].intval) == ENDBAR) {
			/* lexer thinks this is 'endbar'
			 * but is really 'en' 'd' 'b' 'a' 'r' */
			add_acc("nat");
			add_note(Curr_grpsyl_p, (int) 'e', Curr_accs,
				USE_DFLT_OCTAVE, 0, NO, (char *) 0);
			keyword_notes(yytext + 2);
		}
		else {
			yyerror("bar type not valid here");
		}
	}
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 4548 "gram.y"
    {
		/* lexer thinks this is 'grace' but really 'g' 'r' 'a' 'c' 'e' */
		keyword_notes(yytext);
	}
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 4555 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == ENDING_BARRED) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 4566 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == J_RAGPARA) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 4578 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == BRACELIST) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 4590 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == BASS) {
			keyword_notes(yytext);
		}
		else {
			l_yyerror(Curr_filename, yylineno,
					"%s not valid here", yytext);
		}
	}
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 4602 "gram.y"
    {
		/* in chord-at-time mode, lex could mistake useaccs
		 * for a 6-note chord: us e a c c s  */
		keyword_notes(yytext);
	}
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 4610 "gram.y"
    {
		Curr_grpsyl_p->notelist[Curr_grpsyl_p->nnotes - 1].note_has_paren = YES;
	}
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 4615 "gram.y"
    {
		if (Doing_tab_staff == YES) {
			add_note(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), No_accs, NOFRET, 0, NO, (yyvsp[(2) - (2)].stringval));
		}
		else {
			add_note(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), No_accs, USE_DFLT_OCTAVE,
								0, NO, (yyvsp[(2) - (2)].stringval));
		}
	}
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 4627 "gram.y"
    {
		if (Doing_tab_staff == YES) {
			l_warning(Curr_filename, yylineno,
				"parentheses around accidentals are extraneous on tab staffs; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(5) - (5)].intval), 0, YES, (char *) 0);
	}
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 4637 "gram.y"
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"parentheses around octave are extraneous; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), No_accs, (yyvsp[(3) - (5)].intval), 0, YES, (yyvsp[(5) - (5)].stringval));
	}
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 4647 "gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (3)].intval), No_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			0, NO, (char *) 0);
	}
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 4663 "gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(4) - (5)].intval), (yyvsp[(3) - (5)].intval), NO, (yyvsp[(5) - (5)].stringval));
	}
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 4669 "gram.y"
    {
		if (Doing_tab_staff == NO) {
			l_warning(Curr_filename, yylineno,
				"extraneous parentheses around octave; ignoring");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (7)].intval), Curr_accs, (yyvsp[(5) - (7)].intval), (yyvsp[(3) - (7)].intval), YES, (yyvsp[(7) - (7)].stringval));
	}
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 4679 "gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs,
			(Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE),
			(yyvsp[(3) - (5)].intval), NO, (char *) 0);
	}
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 4695 "gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), No_accs, (yyvsp[(3) - (4)].intval), (yyvsp[(2) - (4)].intval), NO, (yyvsp[(4) - (4)].stringval));
	}
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 4701 "gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (6)].intval), No_accs, (yyvsp[(4) - (6)].intval), (yyvsp[(2) - (6)].intval), YES, (yyvsp[(6) - (6)].stringval));
	}
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 4707 "gram.y"
    {
		if (Doing_tab_staff == YES && Curr_accs[0] != '\0') {
			yyerror("accidental must be before fret number");
		}
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), Curr_accs, (yyvsp[(2) - (4)].intval), 0, NO, (yyvsp[(4) - (4)].stringval));
	}
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 4716 "gram.y"
    {
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (5)].intval), Curr_accs, (yyvsp[(2) - (5)].intval), 0, YES, (char *) 0);
	}
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 4722 "gram.y"
    {
		/* Whoops! The left paren was really for a new note,
		 * which happens to be parenthesized. But beause yacc only
		 * looks ahead one token, it finds out too late. So we
		 * catch it here, push the parenthesis and pitch back into
		 * the input and return back to the parent grammar rule,
		 * since we now have complete note. */
		pushback(yytext[0]);
		pushback('(');
		add_note(Curr_grpsyl_p, (yyvsp[(1) - (4)].intval), No_accs, (yyvsp[(2) - (4)].intval), 0, NO, (char *) 0);
	}
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 4735 "gram.y"
    {
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 4741 "gram.y"
    {
		if (Doing_tab_staff == NO) {
			/* try to give helpful error message */
			if (get_shape_num((yyvsp[(1) - (1)].stringval) + 2) != HS_UNKNOWN) {
				yyerror("missing 'hs' before headshape string");
			}
			else if (strcmp((yyvsp[(1) - (1)].stringval) + 2, "full") == 0 || isdigit((yyvsp[(1) - (1)].stringval)[2])) {
				yyerror("bend string not allowed on non-tablature staff; use ^");
			}
			else {
				yyerror("unexpected string");
			}
			(yyval.stringval) = (char *) 0;
		}
	}
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 4758 "gram.y"
    {
		/* return 'a' to 'g' value */
		(yyval.intval) = (int) *yytext;
	}
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 4764 "gram.y"
    {
		/* no accidental */
		(yyval.intval) = 0;
	}
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 4771 "gram.y"
    {
	}
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 4775 "gram.y"
    {
		clear_curr_accs();
	}
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 4781 "gram.y"
    {
	}
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 4784 "gram.y"
    {
		/* no octave or fret designation */
		(yyval.intval) = (Doing_tab_staff ? NOFRET : USE_DFLT_OCTAVE);
	}
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 4791 "gram.y"
    {
	}
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 4796 "gram.y"
    {
	}
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 4800 "gram.y"
    {
		clear_curr_accs();
	}
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 4805 "gram.y"
    {
	}
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 4810 "gram.y"
    {
	}
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 4815 "gram.y"
    {
		add_acc("sharp");
	}
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 4821 "gram.y"
    {
		add_acc("flat");
	}
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 4827 "gram.y"
    {
		add_acc("nat");
	}
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 4833 "gram.y"
    {
		add_acc("dblsharp");
	}
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 4839 "gram.y"
    {
		add_acc("dblflat");
	}
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 4845 "gram.y"
    {
		add_acc((yyvsp[(2) - (3)].stringval) + 2);
		Tuning_used = YES;
	}
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 4852 "gram.y"
    {
		(yyval.intval) = '#';
	}
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 4858 "gram.y"
    {
		(yyval.intval) = '&';
	}
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 4864 "gram.y"
    {
		/* natural */
		(yyval.intval) = 'n';
	}
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 4871 "gram.y"
    {
		/* double sharp */
		(yyval.intval) = 'x';
	}
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 4878 "gram.y"
    {
		(yyval.intval) = 'B';
	}
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 4884 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 4890 "gram.y"
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		/* this will be a negative number */
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 4902 "gram.y"
    {
		/* we can't really fill in the actual octave yet, because
		 * it may be different on different staffs or voices, so
		 * we store the relative octave and fill in actual value
		 * later.
		 */
		(yyval.intval) = USE_DFLT_OCTAVE + (yyvsp[(1) - (1)].intval);
	}
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 4912 "gram.y"
    {
		(yyval.intval) = -1;
	}
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 4918 "gram.y"
    {
		/* count up the number of minus signs */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) - 1;
	}
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 4924 "gram.y"
    {
		(yyval.intval) = 1;
	}
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 4930 "gram.y"
    {
		/* count up the number of plus signs */
		(yyval.intval) = (yyvsp[(1) - (2)].intval) + 1;
	}
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 4937 "gram.y"
    {
		set_slurdir(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1, (yyvsp[(4) - (5)].intval), (yyvsp[(5) - (5)].intval));
	}
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 4944 "gram.y"
    {
		Linetype = (yyvsp[(1) - (1)].intval);
		begin_slur(Curr_grpsyl_p, Curr_grpsyl_p->nnotes - 1);
	}
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 4950 "gram.y"
    {
		/* empty list. Only allowed if only one note in following
		 * group. However, we don't know that yet, so marked pitch
		 * as 'U' for unknown */
		add_slurto(Curr_grpsyl_p, 'U', USE_DFLT_OCTAVE,
				Curr_grpsyl_p->nnotes - 1, Linetype);
	}
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 4960 "gram.y"
    {
		add_slurto(Curr_grpsyl_p, 0, (yyvsp[(1) - (1)].intval), Curr_grpsyl_p->nnotes - 1,
						Linetype);
	}
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 4978 "gram.y"
    {
		if (Doing_tab_staff == YES) {
			yyerror("cannot specify string inside <> on tab staffs");
		}
		else {
			add_slurto(Curr_grpsyl_p, (yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval),
					Curr_grpsyl_p->nnotes - 1, Linetype);
		}
	}
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 4990 "gram.y"
    {
		/* save address associated with entire group */
		if ( (yyvsp[(2) - (2)].stringval) != (char *) 0) {
			addsym((yyvsp[(2) - (2)].stringval), Curr_grpsyl_p->c, CT_GRPSYL);
			var_valid();
		}
	}
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 4999 "gram.y"
    {
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 5005 "gram.y"
    {
		/* a-g are usually pitches, but in this context, they
		 * are 1-character variable names. */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 5013 "gram.y"
    {
		/* usually m means measure, but here it is the variable m */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 5020 "gram.y"
    {
		/* usually rest, here variable r */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 5027 "gram.y"
    {
		/* usually space, here variable s */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 5034 "gram.y"
    {
		/* usually uncompressible, here variable u */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 5041 "gram.y"
    {
		/* usually natural, here variable n */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 5048 "gram.y"
    {
		/* usually double sharp, here variable x */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 5054 "gram.y"
    {
		/* longer variable -- one with more than one character name */
		(yyval.stringval) = strcpy(Stringbuff, yytext);
	}
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 5060 "gram.y"
    {
		end_tuplet((yyvsp[(5) - (8)].intval), (yyvsp[(7) - (8)].ratval), (yyvsp[(6) - (8)].intval), (yyvsp[(4) - (8)].intval));
		Getting_tup_dur = NO;
	}
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 5066 "gram.y"
    {
		/* nothing -- use default of when to print tuplet number/bracket */
		(yyval.intval) = PT_DEFAULT;
	}
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 5073 "gram.y"
    {
		/* don't print tuplet or bracket */
		(yyval.intval) = PT_NEITHER;
	}
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 5080 "gram.y"
    {
		/* print number only */
		(yyval.intval) = PT_NUMBER;
	}
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 5087 "gram.y"
    {
		if (*yytext == 'y') {
			(yyval.intval) = PT_BOTH;
		}
		else {
			yyerror("tuplet number/bracket qualifier must be y or n or num");
		}
	}
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 5099 "gram.y"
    {
		begin_tuplet();
	}
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 5104 "gram.y"
    {
		Getting_tup_dur = YES;
	}
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 5109 "gram.y"
    {
		(yyval.intval) = PL_UNKNOWN;
	}
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 5115 "gram.y"
    {
		if (yylval.intval == PL_BETWEEN) {
			yyerror("between not allowed for tuplet side");
			(yyval.intval) = PL_UNKNOWN;
		}
	}
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 5123 "gram.y"
    {
		/* optional time value is missing */
		(yyval.ratval).n = 0;
		(yyval.ratval).d = 1;
	}
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 5131 "gram.y"
    {
		(yyval.ratval) = (yyvsp[(2) - (2)].ratval);
	}
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 5136 "gram.y"
    {
	}
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 5140 "gram.y"
    {
		Last_grpsyl_p = Curr_grpsyl_p = (struct GRPSYL *) 0;
	}
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 5145 "gram.y"
    {
		/* If user does "all" without specifying a place,
		 * all() will call dflt_place() which was really intended
		 * to only handle STUFF. So we have to tell it we have lyrics,
		 * not a true STUFF. */
		set_stuff_type(-1);
	}
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 5154 "gram.y"
    {
		/* empty, use default */
		begin_range(PL_UNKNOWN);
		(yyval.intval) = PL_UNKNOWN;
	}
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 5162 "gram.y"
    {
		begin_range((yyvsp[(1) - (1)].intval));
	}
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 5167 "gram.y"
    {
		(yyval.intval)= PL_UNKNOWN;
	}
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 5173 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) == PL_BETWEEN) {
			yyerror("place for ph, if specified, must be above or below, not between");
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 5184 "gram.y"
    {
		/* means goes above or below all the staffs, regardless if
		 * some happen to be invisible at the moment, so find top
		 * or bottom visible staff as appropriate,and save that
		 * away as the staff range */
		all();
	}
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 5197 "gram.y"
    {
		/* if staff_range == 0, then only one staff specified, so
		 * use first staff number for both beginning and end of range */
		save_staff_range((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)) );
	}
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 5204 "gram.y"
    {
		/* empty */
		chk_range_type(NO);
		(yyval.intval) = 0;
	}
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 5212 "gram.y"
    {
		chk_range_type(NO);
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
		if ((yyvsp[(2) - (2)].intval) == 0) {
			yyerror("staff of 0 is illegal");
		}
	}
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 5222 "gram.y"
    {
		chk_range_type(YES);
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 5231 "gram.y"
    { Place = (yyvsp[(3) - (3)].intval); }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 5236 "gram.y"
    {
	}
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 5241 "gram.y"
    {
		if (*yytext != 'c') {
			yyerror("verse must be 'c' or number(s)");
		}
		else {
			save_vno_range(0, 0);
		}
	}
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 5252 "gram.y"
    {
	}
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 5257 "gram.y"
    {
	}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 5262 "gram.y"
    {
		/* if end of range is 0, not really a range, use first number
		 * for both beginning and end */
		lyr_verse((yyvsp[(1) - (2)].intval), ((yyvsp[(2) - (2)].intval) == 0 ? (yyvsp[(1) - (2)].intval) : (yyvsp[(2) - (2)].intval)));
	}
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 5269 "gram.y"
    {
		/* empty */
		(yyval.intval) = 0;
	}
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 5276 "gram.y"
    {
		(yyval.intval) = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 5281 "gram.y"
    {
		/* null token to allocate a GRPSYL for a lyric */
		Last_grpsyl_p = Curr_grpsyl_p;
		Curr_grpsyl_p = newGRPSYL(GS_SYLLABLE);
		if (Last_grpsyl_p == (struct GRPSYL *) 0) {
			Lyrics_p = Curr_grpsyl_p;
		}
	}
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 5291 "gram.y"
    {
		/* If user didn't specify a place, fix that. */
		if (Place == PL_UNKNOWN) {
			Place = PL_BELOW;
		}
		/* copies of the lyrics info has been made for all staffs/verses
		 * at this point, so get rid of master copy */
		free_grpsyls(Lyrics_p);
	}
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 5302 "gram.y"
    {
		/* empty -- need to derive times from music */
		Lyrics_p = derive_lyrtime();
	}
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 5309 "gram.y"
    {
		not_derived();
	}
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 5324 "gram.y"
    {
		link_notegroup(Curr_grpsyl_p, Last_grpsyl_p);
		/* Save pointer to current GRPSYL in case the next
		 * group gets its time value based on this one,
		 * and there are additive times on this one. */
		Prev_grpsyl_p = Curr_grpsyl_p;
		/* If there are additive times, add those in.
		 * We don't need to make extra groups for lyrics, because we
		 * don't need to tie groups together--the lyrics time
		 * can hold any legal RATIONAL, even those that aren't
		 * specifiable with a single time value. */
		if (Extra_time_p != 0) {
			struct TIMELIST *timelist_p;
			for (timelist_p = Extra_time_p; timelist_p != 0;
						timelist_p = timelist_p->next) {
				Curr_grpsyl_p->fulltime = radd(Curr_grpsyl_p->fulltime, timelist_p->fulltime);
			}
		}
	}
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 5346 "gram.y"
    {
	}
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 5350 "gram.y"
    {
		end_tuplet((yyvsp[(4) - (5)].intval), (yyvsp[(5) - (5)].ratval), NO, PL_UNKNOWN);
		Getting_tup_dur = NO;
	}
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 5356 "gram.y"
    {
		/* empty, will fill in an actual syllable later */
		Curr_grpsyl_p->syl = (char *) 0;
	}
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 5363 "gram.y"
    {
		/* space, not a lyric, so mark for later use */
		Curr_grpsyl_p->grpcont = GC_SPACE;
	}
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 5376 "gram.y"
    {
		/* If no [verseno] is specified, use -1 as special flag
		 * to be resolved later to "one more than previous",
		 * or if there wasn't a previous, to verse 1.
		 */
		lyr_verse(-1, -1);
		proc_lyrics(Lyrics_p, (yyvsp[(1) - (2)].stringval));
	}
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 5387 "gram.y"
    {
		proc_lyrics(Lyrics_p, (yyvsp[(4) - (5)].stringval));
	}
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 5392 "gram.y"
    {
		/* If user set measnum=every N and did not already put some
		 * kind of reh mark on this bar, and this measure is a
		 * multiple of N, we add a mnum mark,
		 * but using measnumstyle */
		if (Currstruct_p != 0 && IS_EVERY(Score.measnum) &&
				Currstruct_p->u.bar_p->reh_type == REH_NONE &&
				Meas_num % Score.measnum == 0) {
			Currstruct_p->u.bar_p->reh_type = REH_BAR_MNUM;
			/* Do like the code in set_reh_string() except use the
			 * measnum* parameters for family, font, and size. */
			Currstruct_p->u.bar_p->reh_string =
					copy_string(num2str(Meas_num) + 2,
                        		Score.measnumfamily + Score.measnumfont,
                        		Score.measnumsize);
		}

		Currstruct_p = (struct MAINLL *) 0;
		/* If there are alternating time signature,
		 * add an implicit time signature SSV for the
		 * next time signature in the list.
		 */
		if (Alt_timesig_list != 0) {
			end_prev_context();
			Context = C_SCORE;
			Currstruct_p = newMAINLLstruct(S_SSV, -1);
			Currstruct_p->u.ssv_p->context = Context;
			if (Tsig_visibility == PTS_ALWAYS &&
					Next_alt_timesig != Alt_timesig_list) {
				/* If user wants alternating time signatures
				 * printed on every measure, if there is
				 * a multirest, we will print multiple
				 * time signatures there, and might have to
				 * wrap around to the beginning of the list.
				 * So make a copy of the entire list,
				 * starting from wherever we are now,
				 * wrapping around to the beginning,
				 * and ending just before where we are now.
				 * Most of the time,
				 * there probably won't be a multirest,
				 * so this will be a waste, but unfortunately,
				 * we don't know yet whether there will be
				 * one or not, so need to do the whole list
				 * just in case.
				 *
				 * Calculate length of the two pieces:
				 * from where we are to end, and from
				 * beginning to where we are.
				 */
				int remlength;
				int wraplength;
				remlength = strlen(Next_alt_timesig);
				wraplength = strlen(Alt_timesig_list)
						- remlength;
				/* need one more for terminator. */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
						remlength + wraplength + 1);

				/* copy remainder into beginning */
				strcpy(Currstruct_p->u.ssv_p->timerep,
						Next_alt_timesig);
				/* copy the wrap-around part of list,
				 * but move the TSR_ALTERNATING from the
				 * end of that part to between the two parts */
				Currstruct_p->u.ssv_p->timerep[remlength]
						= TSR_ALTERNATING;
				strncpy(Currstruct_p->u.ssv_p->timerep +
						remlength + 1, Alt_timesig_list,
						wraplength - 1);
				/* Add the terminator */
				Currstruct_p->u.ssv_p->timerep
						[remlength + wraplength]
						= TSR_END;

				assign_timesig(Currstruct_p, PTS_ALWAYS,
							&Next_alt_timesig);


				/* Make this new copy the new
				 * head of the list */
				Alt_timesig_list =
						Currstruct_p->u.ssv_p->timerep;
			}
			else {
				/* make a copy of the remaining alternating
				 * signatures and assign that */
				MALLOCA(char, Currstruct_p->u.ssv_p->timerep,
					strlen(Next_alt_timesig) + 1);
				strcpy(Currstruct_p->u.ssv_p->timerep,
							Next_alt_timesig);
				assign_timesig(Currstruct_p,
					(Tsig_visibility == PTS_ALWAYS ?
					PTS_ALWAYS : PTS_NEVER),
					&Next_alt_timesig);

				/* If we reached end of list, start over */
				if (Next_alt_timesig == 0) {
					Next_alt_timesig = Alt_timesig_list;
				}
			}

			asgnssv(Currstruct_p->u.ssv_p);
			end_prev_context();
			Context = C_MUSIC;
		}
	}
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 5507 "gram.y"
    {
		struct MAINLL * mll_p;
		char *name;


		name = (yylval.intval == YES ? "newpage" : "newscore");

		(void) contextcheck(C_MUSIC | C_BLOCK, name);
		Currstruct_p = newMAINLLstruct(S_FEED, yylineno);
		Currstruct_p->u.feed_p->pagefeed = (yyvsp[(1) - (1)].intval);

		/* make sure we're not in the middle of a measure. Go
		 * backwards in main list. If we hit STAFF before a BAR,
		 * then there is a problem.
		 */
		for (mll_p = Mainlltc_p; mll_p != (struct MAINLL *) 0;
					mll_p = mll_p->prev) {

			if (mll_p->str == S_BAR) {
				break;
			}
			else if (mll_p->str == S_STAFF) {
				l_yyerror(Curr_filename, yylineno,
					"%s not allowed in middle of measure",
					name);
				break;
			}
			else if (mll_p->str == S_FEED) {
				struct MAINLL *m_p;
				/* Need to look backwards for blocks, but need
				 * to ignore any SSVs that are in between */
				for (m_p = mll_p->prev;
						m_p != 0 && m_p->str == S_SSV;
						m_p = m_p->prev) {
					;
				}
				if (m_p != 0 && m_p->str == S_BLOCKHEAD) {
					/* This is a feed following a block.
					 * If it was an implicit feed,
					 * we can get rid of it, because
					 * user now put an explicit one.
					 */
					if (mll_p->inputlineno == -1) {
						unlinkMAINLL(mll_p);
						FREE(mll_p);
					}
					/* We must be in block context,
					 * so no need to check farther back.
					 */
					break;
				}
				else {
					l_yyerror(Curr_filename, yylineno,
						"consecutive newscore/newpage not allowed");
				}
				break;
			}
		}
		insertMAINLL(Currstruct_p, Mainlltc_p);

		/* If this is inside a block, we need to create a new block
		 * and feed after it.
		 */
		if (Context == C_BLOCK) {
			CALLOC(BLOCKHEAD, Currblock_p, 1);
			set_win_coord(Currblock_p->c);
			Next_print_link_p_p = &(Currblock_p->printdata_p);
			insertMAINLL(newMAINLLstruct(S_BLOCKHEAD, yylineno),
						Mainlltc_p);
			Mainlltc_p->u.blockhead_p = Currblock_p;
			insertMAINLL(newMAINLLstruct(S_FEED, -1), Mainlltc_p);
		}

	}
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 5582 "gram.y"
    {
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 5598 "gram.y"
    {
		int mot;	/* margin override type */

		if ((yyvsp[(3) - (4)].intval) == 0) {
			/* User didn't specify a sign, so this is an
			 * absolute, not relative value. Or auto. */
			if ((yyvsp[(4) - (4)].floatval) == MG_AUTO) {
				mot = MOT_AUTO;
			}
			else {
				mot = MOT_ABSOLUTE;
			}
		}
		else {
			mot = MOT_RELATIVE;
		}

		if ((yyvsp[(4) - (4)].floatval) > 0.0) {
			(yyvsp[(3) - (4)].intval) = adjust2inches((yyvsp[(3) - (4)].intval));	/* in case we are in centimeter mode */
		}
		if ((yyvsp[(1) - (4)].intval) == RIGHTMARGIN) {
			if (Currstruct_p->u.feed_p->right_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"rightmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->rightmargin = (yyvsp[(4) - (4)].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->rightmargin
						= Score.rightmargin + (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->right_mot = mot;
		}
		else if ((yyvsp[(1) - (4)].intval) == LEFTMARGIN) {
			if (mot == MG_AUTO) {
				l_warning(Curr_filename, yylineno,
					"auto can only be used with rightmargin, not leftmargin; ignoring");
				mot = MOT_UNUSED;
			}
			if (Currstruct_p->u.feed_p->left_mot != MOT_UNUSED) {
				l_warning(Curr_filename, yylineno,
					"leftmargin specified more than once, using last instance");
				/* fall through to override the previous */
			}
			if (mot == MOT_ABSOLUTE) {
				Currstruct_p->u.feed_p->leftmargin = (yyvsp[(4) - (4)].floatval);
			}
			else if (mot == MOT_RELATIVE) {
				Currstruct_p->u.feed_p->leftmargin
						= Score.leftmargin + (yyvsp[(3) - (4)].intval) * (yyvsp[(4) - (4)].floatval);
				/* Even if user specified as relative,
				 * we have now converted to absolute */
				mot = MOT_ABSOLUTE;
			}
			Currstruct_p->u.feed_p->left_mot = mot;
		}
		else {
			yyerror("unexpected parameter; only 'leftmargin' or 'rightmargin' allowed here");
		}
		chkmargin(Score.topmargin, Score.botmargin,
				Currstruct_p->u.feed_p->leftmargin,
				Currstruct_p->u.feed_p->rightmargin);
	}
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 5668 "gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 5674 "gram.y"
    {
		(yyval.floatval) = MG_AUTO;
	}
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 5698 "gram.y"
    {

		/* build a BAR struct and add it to the main list */
		if (contextcheck(C_MUSIC, "bar") == YES) {

			Currstruct_p = add_bar((yyvsp[(3) - (3)].intval), (yyvsp[(1) - (3)].intval), Endingloc, Mainlltc_p);
			Got_ending = NO;
		}
		if ((yyvsp[(3) - (3)].intval) == RESTART && Endingloc != NOITEM) {
			yyerror("restart cannot be used inside an ending");
		}

		/* User can specify bar type to use on preceding staff when
		 * a repeatstart gets moved to the next scores's pseudo-bar */
		if ((yyvsp[(2) - (3)].intval) != -1) {
			if ((yyvsp[(3) - (3)].intval) != REPEATSTART) {
				l_warning(Curr_filename, yylineno,
					"bar type for preceding score only allowed on repeatstart; ignoring");
			}
			else if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = (yyvsp[(2) - (3)].intval);
				if ((yyvsp[(2) - (3)].intval) != SINGLEBAR && (yyvsp[(2) - (3)].intval) != DOUBLEBAR &&
						(Linetype == L_DASHED ||
						Linetype == L_DOTTED)) {
					l_warning(Curr_filename, yylineno,
						"dashed/dotted only allowed on bar or dblbar; ignoring");
					Linetype = L_NORMAL;
				}
				Currstruct_p->u.bar_p->linetype = Linetype;
			}
		}
		else {
			/* Default is single bar. It could be argued that in
			 * the case of a key change on this bar, it really
		 	 * should be a dblbar, but user can force that
			 * if they want it. */
			if (Currstruct_p != 0 && Currstruct_p->u.bar_p != 0) {
				Currstruct_p->u.bar_p->precbartype = SINGLEBAR;
			}
		}
		/* Placement phase indirectly uses Doing_tab_staff when it
		 * calls notecomp, so clear it in case we don't get a
		 * non-tab staff input before the end of file.
		 * We could probably get by just doing after parsing is done,
		 * but this seems cleaner, and cheap enough.
		 */
		Doing_tab_staff = NO;
	}
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 5749 "gram.y"
    {
		(yyval.intval) = -1;	/* special value to mean "none specified" */
		Linetype = L_NORMAL;
	}
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 5756 "gram.y"
    {
		/* Parens wouldn't be strictly necessary to be able to parse,
		 * but seem useful semantically to make it clear this is
		 * optional, only applying when repeatstart is moved to
		 * next score's pseudo bar. */
		(yyval.intval) = (yyvsp[(3) - (4)].intval);
		if ((yyvsp[(2) - (4)].intval) == L_DOTTED || (yyvsp[(2) - (4)].intval) == L_DASHED) {
			if ((yyvsp[(3) - (4)].intval) != SINGLEBAR && (yyvsp[(3) - (4)].intval) != DOUBLEBAR) {
				l_warning(Curr_filename, yylineno,
					"Only bar or dblbar can be dashed or dotted; ignoring");
			}
			else {
				Linetype = (yyvsp[(2) - (4)].intval);
			}
		}
		else if ((yyvsp[(2) - (4)].intval) != L_NORMAL) {
			l_warning(Curr_filename, yylineno,
					"Bar line type modifier can only can be dashed or dotted; ignoring");
		}
	}
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 5778 "gram.y"
    {
		/* Call proc_emptymeas() to free up the last buffer, if any,
		 * and return back to normal input stream. */
		proc_emptymeas(MAXSTAFFS+1);
		(yyval.intval) = (yyvsp[(1) - (2)].intval);
	}
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 5786 "gram.y"
    {
		/* If there was any empty voices in the input for this
		 * measure which have emptymeas parameter set,
		 * proc_emptymeas() will arrange to create just-in-time
		 * virtual input for it that will get parsed via
		 * the emptymeas_input rule.
		 * We pass arg of 1 to tell it to start looking from
		 * staff 1. Subsequent calls to proc_emptymeas(), if any,
		 * will generate input for additional voices, until
		 * no more are needed for this measure.
		 */
		if ((yyvsp[(1) - (1)].intval) != RESTART) {
			EM_staff = proc_emptymeas(1);
		}
		else {
			/* don't create any music before a restart */
			EM_staff = MAXSTAFFS + 1;
		}
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 5808 "gram.y"
    {
	}
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 5813 "gram.y"
    {
		/* See if there is any more virtual input needed */
		EM_staff = proc_emptymeas(EM_staff);
	}
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 5826 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->padding += (yyvsp[(1) - (1)].floatval) * STEPSIZE;
		}
	}
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 5834 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			/* fill in location info */
			if ((yyvsp[(2) - (2)].stringval) != (char *) 0) {
				addsym((yyvsp[(2) - (2)].stringval), Currstruct_p->u.bar_p->c, CT_BAR);
			}
		}
	}
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 5845 "gram.y"
    {
		if (Got_ending == YES) {
			yyerror("Only one ending allowed per bar");
		}
		Got_ending = YES;

		if (Currstruct_p != (struct MAINLL *) 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				yyerror("ending not allowed on restart");
			}
			/* fill in ending label if any */
			Currstruct_p->u.bar_p->endinglabel = (yyvsp[(1) - (1)].stringval);
			Currstruct_p->u.bar_p->endingloc = Endingloc;
			ped_endings(Endingloc);

			/* for next time around, figure out what endingloc will
			 * be if user doesn't specify something different */
			switch (Endingloc) {
			case STARTITEM:
				Endingloc = INITEM;
				break;
			case ENDITEM:
				Endingloc = NOITEM;
				break;
			default:
				break;
			}
		}
	}
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 5877 "gram.y"
    {
		if (Currstruct_p != 0) {
			if (Currstruct_p->u.bar_p->bartype == RESTART) {
				l_warning(Curr_filename, yylineno,
					"hidechanges not allowed on restart; ignoring");
			}
			else {
				Currstruct_p->u.bar_p->hidechanges = YES;
			}
		}
	}
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 5890 "gram.y"
    {
		if (Currstruct_p != 0) {
			set_mnum(Currstruct_p->u.bar_p, (yyvsp[(3) - (3)].intval));
		}
	}
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 5897 "gram.y"
    {
		/* +2 to skip font/size */
		init_reh(-1, (yyvsp[(3) - (3)].stringval) + 2, Currstruct_p);
	}
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 5903 "gram.y"
    {
		init_reh((yyvsp[(3) - (3)].intval), (char *)0, Currstruct_p);
	}
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 5909 "gram.y"
    {
		if (Currstruct_p != 0 && Currstruct_p->str == S_BAR) {
			if (Currstruct_p->u.bar_p->reh_string != 0) {
				/* This indicates user specified multiple
				 * rehearsal strings. We would have already
				 * given a warning message. */
				FREE(Currstruct_p->u.bar_p->reh_string);
				Currstruct_p->u.bar_p->reh_string = 0;
			}
			set_reh_string(Currstruct_p->u.bar_p, (yyvsp[(3) - (7)].intval), (yyvsp[(4) - (7)].intval), (yyvsp[(5) - (7)].intval), (yyvsp[(6) - (7)].stringval));
			Currstruct_p->u.bar_p->dist = Dist;
			Currstruct_p->u.bar_p->dist_usage = Dist_usage;
		}
	}
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 5926 "gram.y"
    {
		(yyval.stringval) = (yyvsp[(2) - (2)].stringval);
		(void) fix_string((yyvsp[(2) - (2)].stringval), FONT_TR, DFLT_SIZE, Curr_filename, yylineno);
		Endingloc = STARTITEM;
	}
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 5934 "gram.y"
    {
		if (Endingloc == NOITEM) {
			l_warning(Curr_filename, yylineno,
				"no ending in progress; extraneous 'endending' ignored");
		}
		else {
			Endingloc = ENDITEM;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 5946 "gram.y"
    {
		/* null token to check for more than one rehearsal mark
		 * on one BAR */
		if (Currstruct_p != (struct MAINLL *) 0 &&
				Currstruct_p->u.bar_p->reh_type != REH_NONE) {
			l_warning(Curr_filename, yylineno,
				"only one rehearsal mark allowed per bar; using last");
		}
	}
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 5957 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_STRING;
		}
	}
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 5965 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_MNUM;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 5974 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_NUM;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 5983 "gram.y"
    {
		if (Currstruct_p != (struct MAINLL *) 0) {
			Currstruct_p->u.bar_p->reh_type = REH_LET;
		}
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 5991 "gram.y"
    {
		(yyval.inpcoord_p) = (yyvsp[(2) - (6)].inpcoord_p);
		(yyvsp[(2) - (6)].inpcoord_p)->hexpr_p = (yyvsp[(3) - (6)].expr_p);
		(yyvsp[(2) - (6)].inpcoord_p)->vexpr_p = (yyvsp[(5) - (6)].expr_p);
	}
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 5998 "gram.y"
    {
		/* null token to allocate an INPCOORD */
		CALLOC(INPCOORD, Curr_loc_info_p, 1);
		(yyval.inpcoord_p) = Curr_loc_info_p;
		/* set to positive in case input starts with an absolute
		 * x coordinate */
		Plus_minus = 1;
	}
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 6008 "gram.y"
    {
		(yyval.intval) = Plus_minus = 1;
	}
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 6014 "gram.y"
    {
		(yyval.intval) = Plus_minus = -1;
	}
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 6021 "gram.y"
    {
		(yyval.expr_p) = (yyvsp[(2) - (2)].expr_p);
		Curr_timeref_tag_p = 0;
	}
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 6029 "gram.y"
    {
		(yyval.expr_p) = (yyvsp[(1) - (1)].expr_p);

		/* Put lex back into normal (not coord arithemetic) mode */
		set_lex_mode(NO);
	}
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 6038 "gram.y"
    {
		/* Put lex into special mode to return different tokens
		 * for arithmetic operators. This is just in case the
		 * precedence rules might mess up other rules if we used
		 * the same tokens. The + - * / symbols are used for very
		 * different things elsewhere in the grammer, where
		 * precedence doesn't make sense. It probably wouldn't hurt,
		 * but it seems better to be safe, and only do the precedence
		 * when really needed.
		 */
		set_lex_mode(YES);
		Curr_timeref_tag_p = 0;
	}
    break;

  case 606:

/* Line 1806 of yacc.c  */
#line 6056 "gram.y"
    {
		(yyval.expr_p) = (yyvsp[(2) - (3)].expr_p);
	}
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 6062 "gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(2) - (3)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(1) - (3)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(3) - (3)].expr_p);
	}
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 6070 "gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(2) - (3)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(1) - (3)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(3) - (3)].expr_p);
	}
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 6078 "gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(1) - (4)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(3) - (4)].expr_p);
	}
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 6086 "gram.y"
    {
		(yyval.expr_p) = newnode((yyvsp[(1) - (6)].intval));
		(yyval.expr_p)->left.lchild_p = (yyvsp[(3) - (6)].expr_p);
		(yyval.expr_p)->right.rchild_p = (yyvsp[(5) - (6)].expr_p);
	}
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 6094 "gram.y"
    {
		(yyval.expr_p) = newnode(OP_FLOAT_LITERAL);
		(yyval.expr_p)->left.value = (yyvsp[(1) - (1)].floatval);
	}
    break;

  case 612:

/* Line 1806 of yacc.c  */
#line 6101 "gram.y"
    {
		(yyval.expr_p) = newnode(OP_TAG_REF);

		/* Get space to save info about this tag reference */
		MALLOC(TAG_REF, (yyval.expr_p)->left.ltag_p, 1);

		/* Get the address of the c[] associated with this tag.
		 * We also save which index into the c[]
		 */
		if (((yyval.expr_p)->left.ltag_p->c = symval((yyvsp[(1) - (3)].stringval), &((yyval.expr_p)->left.ltag_p->c))) == 0) {
			l_yyerror(Curr_filename, yylineno,
				"unable to find tag %s\n", (yyvsp[(1) - (3)].stringval));
		}
		else {
			(yyval.expr_p)->left.ltag_p->c_index = (yyvsp[(3) - (3)].intval);
			save_tag_ref((yyval.expr_p)->left.ltag_p->c, &((yyval.expr_p)->left.ltag_p->c));
		}

		if (index_type((yyvsp[(3) - (3)].intval)) == AX) {
			/* Remember this tag, in case user
			 * wants to do a time offset relative to it.
			 * We always take time offsets relative
			 * to the most recent horizontal tag
			 * in the current expression.
			 * Since there may be expressions as arguments
			 * to functions, we keep a stack of these. */
			Curr_timeref_tag_p = (yyval.expr_p)->left.ltag_p;
		}

		/* If this is the first tag of the proper direction in the
		 * expression, that's the base tag used to determine
		 * which staff/score the tag is associated with, if any */
		if (index_type((yyvsp[(3) - (3)].intval)) == AX && Curr_loc_info_p->hor_p == 0) {
			Curr_loc_info_p->hor_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->hor_p,
						&(Curr_loc_info_p->hor_p));
		}
		else if (index_type((yyvsp[(3) - (3)].intval)) == AY && Curr_loc_info_p->vert_p == 0) {
			Curr_loc_info_p->vert_p = (yyval.expr_p)->left.ltag_p->c;
			save_tag_ref(Curr_loc_info_p->vert_p,
						&(Curr_loc_info_p->vert_p));
		}
	}
    break;

  case 613:

/* Line 1806 of yacc.c  */
#line 6147 "gram.y"
    {
		if (Curr_timeref_tag_p == 0) {
			yyerror("time offset requires a prior horizontal tag reference");
			(yyval.expr_p) = 0;
		}
		else if (is_builtin_tag(Curr_timeref_tag_p->c)) {
			yyerror("cannot have a time offset relative to a builtin tag like _win or _page");
			(yyval.expr_p) = 0;
		}
		else {
			(yyval.expr_p) = newnode(OP_TIME_OFFSET);
			(yyval.expr_p)->left.value = (yyvsp[(2) - (2)].floatval);
			MALLOC(TAG_REF, (yyval.expr_p)->right.rtag_p, 1);
			(yyval.expr_p)->right.rtag_p = Curr_timeref_tag_p;
			save_tag_ref((yyval.expr_p)->right.rtag_p->c,
						&((yyval.expr_p)->right.rtag_p->c));
		}
	}
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 6169 "gram.y"
    {
		/* only valid letters are w and y */
		if (*yytext == 'w') {
			(yyval.intval) = AW;
		}
		else if (*yytext == 'y') {
			(yyval.intval) = AY;
		}
		else {
			yyerror("invalid direction: must be x, y, e, w, n or s");
			/* Return something valid, so if any code tries
			 * to use it later, it won't core dump */
			(yyval.intval) = AX;
		}
	}
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 6186 "gram.y"
    {
		(yyval.intval) = AX;
	}
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 6192 "gram.y"
    {
		/* only valid value is e */
		if (*yytext != 'e') {
			yyerror("invalid direction: must be x, y, e, w, n or s");
		}
		(yyval.intval) = AE;
	}
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 6202 "gram.y"
    {
		(yyval.intval) = AN;
	}
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 6208 "gram.y"
    {
		(yyval.intval) = AS;
	}
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 6214 "gram.y"
    {
		(yyval.floatval) = (float) (yyvsp[(1) - (1)].intval);
	}
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 6219 "gram.y"
    {
		sprintf(Tmpbuff,"%d.%s", (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 6225 "gram.y"
    {
		sprintf(Tmpbuff,"0.%s", (yyvsp[(2) - (2)].stringval));
		(yyval.floatval) = (float) atof(Tmpbuff);
	}
    break;

  case 622:

/* Line 1806 of yacc.c  */
#line 6231 "gram.y"
    {
		/* no decimal fraction part of float number */
		(yyval.stringval) = "";
	}
    break;

  case 624:

/* Line 1806 of yacc.c  */
#line 6241 "gram.y"
    {
		(yyval.stringval) = yytext;
	}
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 6249 "gram.y"
    {
		Currstruct_p->u.line_p->linetype = (yyvsp[(1) - (7)].intval);
		Currstruct_p->u.line_p->start = *((yyvsp[(4) - (7)].inpcoord_p));
		Currstruct_p->u.line_p->end = *((yyvsp[(6) - (7)].inpcoord_p));
		rep_inpcoord((yyvsp[(4) - (7)].inpcoord_p), &(Currstruct_p->u.line_p->start));
		rep_inpcoord((yyvsp[(6) - (7)].inpcoord_p), &(Currstruct_p->u.line_p->end));
		Currstruct_p->u.line_p->string = (yyvsp[(7) - (7)].stringval);

		/* copies of the location info went into the LINE struct,
		 * so we can free the original copy of the information */
		if ((yyvsp[(4) - (7)].inpcoord_p)) {
			FREE((yyvsp[(4) - (7)].inpcoord_p));
		}
		if ((yyvsp[(6) - (7)].inpcoord_p)) {
			FREE((yyvsp[(6) - (7)].inpcoord_p));
		}
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 6270 "gram.y"
    {
		/* null token to cause allocation of LINE struct */
		(void) contextcheck(C_MUSIC, "line");
		Currstruct_p = newMAINLLstruct(S_LINE, yylineno);
	}
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 6277 "gram.y"
    {
		(yyval.intval) = L_NORMAL;
	}
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 6287 "gram.y"
    {
		(yyval.stringval) = 0;
	}
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 6292 "gram.y"
    {
		(yyval.stringval) = fix_string((yyvsp[(4) - (4)].stringval), Titlefont, Titlesize, Curr_filename, yylineno);
	}
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 6298 "gram.y"
    {
		if ((yyvsp[(1) - (7)].intval) == L_WAVY) {
			l_warning(Curr_filename, yylineno,
						"wavy curve not allowed; using normal curve");
			(yyvsp[(1) - (7)].intval) = L_NORMAL;
		}
		Currstruct_p->u.curve_p->curvetype = (yyvsp[(1) - (7)].intval);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p = (struct MAINLL *) 0;
	}
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 6310 "gram.y"
    {
		(void) contextcheck(C_MUSIC, "curve");
		Currstruct_p = newMAINLLstruct(S_CURVE, yylineno);

		/* get space for a list of locations and mark it as empty */
		Item_count = 0;
		Currstruct_p->u.curve_p->ncoord = (short) Item_count;
		Currstruct_p->u.curve_p->nbulge = (short) Item_count;
		MALLOC(INPCOORD, Currstruct_p->u.curve_p->coordlist, ITEMS);
		Max_items = ITEMS;
	}
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 6344 "gram.y"
    {
		/* get enough space to store some values if don't have enough */
		if (Currstruct_p->u.curve_p->nbulge == 0) {
			MALLOCA(float, Currstruct_p->u.curve_p->bulgelist, ITEMS);
		}
		else if ( (Currstruct_p->u.curve_p->nbulge % ITEMS) == 0) {
			REALLOCA(float, Currstruct_p->u.curve_p->bulgelist,
				Currstruct_p->u.curve_p->nbulge + ITEMS);
		}

		/* fill in the value and increment the count of how many */
		Currstruct_p->u.curve_p->bulgelist[Currstruct_p->u.curve_p->nbulge] = (yyvsp[(1) - (2)].intval) * (yyvsp[(2) - (2)].floatval);
		(Currstruct_p->u.curve_p->nbulge)++;
	}
    break;

  case 641:

/* Line 1806 of yacc.c  */
#line 6360 "gram.y"
    {
		struct INPCOORD *curve_inpcoord_p;

		/* If ran off end of list, make list bigger.
		 * We cannot use REALLOC here, since we need to update
		 * the tag reference information on each individual array
		 * element, so we alloc all new space, copy the existing data,
		 * and update the tag references, then free the old space,
		 * and redirect the pointer to the new space. */
		if (Currstruct_p->u.curve_p->ncoord >= Max_items) {
			struct INPCOORD *newlist_p;
			int n;
			Max_items += ITEMS;
			MALLOC(INPCOORD, newlist_p, Max_items);
			for (n = 0; n < Currstruct_p->u.curve_p->ncoord; n++) {
				newlist_p[n] = Currstruct_p->u.curve_p->coordlist[n];
				rep_inpcoord(
				    &(Currstruct_p->u.curve_p->coordlist[n]),
				    &(newlist_p[n]));
			}
			FREE(Currstruct_p->u.curve_p->coordlist);
			Currstruct_p->u.curve_p->coordlist = newlist_p;
		}

		/* Add this entry to the end of the list, update the
		 * tag reference to point to this permanent copy rather
		 * the temporary one we will be deleting, and update the
		 * count of how many elements in the list. */
		curve_inpcoord_p = &(Currstruct_p->u.curve_p->coordlist
					[Currstruct_p->u.curve_p->ncoord]);
		*curve_inpcoord_p = *((yyvsp[(1) - (1)].inpcoord_p));
		rep_inpcoord((yyvsp[(1) - (1)].inpcoord_p), curve_inpcoord_p);
		(Currstruct_p->u.curve_p->ncoord)++;
		FREE((yyvsp[(1) - (1)].inpcoord_p));
	}
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 6397 "gram.y"
    {
		attach_stuff();
		/* so reset flag */
		Defining_multiple = NO;
	}
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 6405 "gram.y"
    {
		chk_stuff_header((yyvsp[(2) - (7)].intval), (yyvsp[(3) - (7)].intval), (yyvsp[(4) - (7)].intval), Dist_usage);
		add_to_sv_list();
	}
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 6412 "gram.y"
    {
		/* Separate rule for phrase because it has the linetype
		 * modifier in front, unlike any other STUFF. The size,
		 * and dist are not really allowed, but we match them
		 * if they are there in order to give more clear error
		 * message than just "syntax error," since there was
		 * already code elsewhere to check for these errors.
		 */
		set_stuff_type(ST_PHRASE);
		chk_stuff_header((yyvsp[(3) - (6)].intval), (yyvsp[(1) - (6)].intval), (yyvsp[(4) - (6)].intval), Dist_usage);
		add_to_sv_list();
		Aligntag = NOALIGNTAG;
	}
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 6427 "gram.y"
    {
		/* need a separate rule for midi, because it can include
		 * a voice as well as staff. It also cannot have the chord,
		 * size or place, although those are checked elsewhere anyway */
		chk_stuff_header(-1, NO, PL_UNKNOWN, SD_NONE);
		Aligntag = NOALIGNTAG;
	}
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 6437 "gram.y"
    {
		set_stuff_type(ST_MIDI);
		begin_range(PL_UNKNOWN);
	}
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 6447 "gram.y"
    {
		all();
		add_to_sv_list();
	}
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 6454 "gram.y"
    {
		/* dummy token for sole purpose of saving away current
		 * stuff type. We have to do this in order to have it in
		 * time to figure out the default place for "all" */
		set_stuff_type((yyvsp[(1) - (1)].intval));
	}
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 6463 "gram.y"
    {
		Curr_family = (yyvsp[(1) - (2)].intval);

		switch ((yyvsp[(2) - (2)].intval)) {
		case FONT_TR:
			(yyval.intval) = ST_ROM;
			break;
		case FONT_TI:
			(yyval.intval) = ST_ITAL;
			break;
		case FONT_TB:
			(yyval.intval) = ST_BOLD;
			break;
		case FONT_TX:
			(yyval.intval) = ST_BOLDITAL;
			break;
		default:
			pfatal("unknown font");
			break;
		}
	}
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 6487 "gram.y"
    {
		if ((yyvsp[(1) - (1)].intval) != L_NORMAL) {
			/* user used 'dotted' or 'dashed' which applies only
			 * to use of T_L_ANGLE for slurs. Use generic error
			 * message so looks like any other similar error. */
			yyerror("syntax error");
		}
		(yyval.intval) = ST_CRESC;
	}
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 6499 "gram.y"
    {
		(yyval.intval) = ST_DECRESC;
	}
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 6505 "gram.y"
    {
		(yyval.intval) = ST_PEDAL;
	}
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 6511 "gram.y"
    {
		(yyval.intval) = ST_MUSSYM;
	}
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 6517 "gram.y"
    {
		(yyval.intval) = ST_OCTAVE;
	}
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 6523 "gram.y"
    {
		/* use -1 to indicate user didn't specify so must use default */
		(yyval.intval) = -1;
	}
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 6530 "gram.y"
    {
		(yyval.intval) = (yyvsp[(2) - (3)].intval);
	}
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 6535 "gram.y"
    {
		(yyval.intval) = TM_NONE;
	}
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 6541 "gram.y"
    {
		(yyval.intval) = (yyvsp[(1) - (1)].intval);
	}
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 6546 "gram.y"
    {
		Dist = 0.0;
		Dist_usage = SD_NONE;
	}
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 6553 "gram.y"
    {
		if ((yyvsp[(1) - (2)].intval) != DIST) {
			yyerror("unexpected parameter name instead of 'dist'");
		}
		else {
			if (frangecheck((yyvsp[(2) - (2)].floatval), -MAXDIST, MAXDIST, "dist") == YES) {
				Dist = (yyvsp[(2) - (2)].floatval);
			}
		}
	}
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 6566 "gram.y"
    {
		(yyval.floatval) = (yyvsp[(1) - (2)].floatval);
	}
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 6572 "gram.y"
    {
		if (Dist_usage != SD_FORCE) {
			l_warning(Curr_filename, yylineno,
				"negative dist requires !, setting to 0");
			(yyval.floatval) = 0.0;
		}
		else {
			(yyval.floatval) = - (yyvsp[(2) - (3)].floatval);
		}
	}
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 6584 "gram.y"
    {
		Dist_usage = SD_MIN;
	}
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 6590 "gram.y"
    {
		Dist_usage = SD_FORCE;
	}
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 6595 "gram.y"
    {
		Aligntag = NOALIGNTAG;
	}
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 6601 "gram.y"
    {
		if (rangecheck((yyvsp[(2) - (2)].intval), MINALIGNTAG, MAXALIGNTAG, "align tag number") == YES) {
			Aligntag = (yyvsp[(2) - (2)].intval);
		}
		else {
			Aligntag = NOALIGNTAG;
		}
	}
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 6619 "gram.y"
    {
		add_stuff_item((yyvsp[(1) - (5)].floatval), (yyvsp[(2) - (5)].floatval), Start_gracebackup, (yyvsp[(3) - (5)].stringval),
			Til_bars, Til_offset, Til_steps, End_gracebackup,
			Dist, Dist_usage, Aligntag);
	}
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 6627 "gram.y"
    {
		Til_bars = 0;
		Til_offset = 0.0;
		Til_steps = 0.0;
		(yyval.floatval) = (yyvsp[(1) - (2)].floatval);
		Start_gracebackup = (yyvsp[(2) - (2)].intval);
	}
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 6636 "gram.y"
    {
		(yyval.intval) = 0;
	}
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 6642 "gram.y"
    {
		(yyval.intval) = (yyvsp[(3) - (4)].intval);
	}
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 6647 "gram.y"
    {
		(yyval.floatval) = 0.0;
	}
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 6653 "gram.y"
    {
		(yyval.floatval) = (yyvsp[(3) - (4)].floatval) * (float) (yyvsp[(2) - (4)].intval);
	}
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 6658 "gram.y"
    {
		(yyval.stringval) = (char *) 0;
	}
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 6664 "gram.y"
    {
		if (get_stuff_type() != ST_PEDAL) {
			yyerror("'*' only valid with pedal");
		}
		MALLOCA(char, (yyval.stringval), 12);
		(yyval.stringval)[0] = FONT_MUSIC;
		(yyval.stringval)[1] = DFLT_SIZE;
		sprintf((yyval.stringval) + 2, "\\(endped)");
	}
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 6676 "gram.y"
    {
		(yyval.stringval) = (yyvsp[(1) - (1)].stringval);
	}
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 6681 "gram.y"
    {
		End_gracebackup = 0;
	}
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 6687 "gram.y"
    {
	}
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 6692 "gram.y"
    {
		/** if there is a non-empty til_suffix, the floatnum better
		 ** have been an integer, and is really the number
		 * of bars. **/
		if ((yyvsp[(2) - (2)].intval) == YES) {
			Til_bars = (int) (yyvsp[(1) - (2)].floatval);
			if ((yyvsp[(1) - (2)].floatval) - Til_bars != 0.0) {
				yyerror("number of measures in til clause must be a whole number");
			}
		}
		else {
			/* only a number, that means it was really a beat offset */
			Til_offset = (yyvsp[(1) - (2)].floatval);
		}
	}
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 6710 "gram.y"
    {
		(yyval.intval) = NO;
		End_gracebackup = (yyvsp[(1) - (2)].intval);
		Til_steps = (yyvsp[(2) - (2)].floatval);
	}
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 6718 "gram.y"
    {
		(yyval.intval) = YES;
	}
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 6724 "gram.y"
    {
		Til_offset = 0.0;
		Til_steps = (yyvsp[(2) - (2)].floatval);
		End_gracebackup = (yyvsp[(1) - (2)].intval);
	}
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 6732 "gram.y"
    {
		Til_offset = (yyvsp[(2) - (4)].floatval);
		Til_steps = (yyvsp[(4) - (4)].floatval);
		End_gracebackup = (yyvsp[(3) - (4)].intval);
	}
    break;

  case 687:

/* Line 1806 of yacc.c  */
#line 6742 "gram.y"
    {
		newROLLINFO();
	}
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 6748 "gram.y"
    {
		newROLLINFO();
		setrolldir(UP);
	}
    break;

  case 689:

/* Line 1806 of yacc.c  */
#line 6755 "gram.y"
    {
		newROLLINFO();
		setrolldir(DOWN);
	}
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 6766 "gram.y"
    {
		/* save staffnum and voice 1 for start of roll */
		rollparam((yyvsp[(1) - (1)].intval), 1, -1, -1);
	}
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 6773 "gram.y"
    {
		/* save staff and voice for start of roll */
		rollparam((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval), -1, -1);
	}
    break;

  case 694:

/* Line 1806 of yacc.c  */
#line 6782 "gram.y"
    {
		/* save staffnum, voice 1 for end of roll */
		rollparam(-1, -1, (yyvsp[(2) - (2)].intval), 1);
	}
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 6789 "gram.y"
    {
		/* save staffnum and voice for end of roll */
		rollparam(-1, -1, (yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval));
	}
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 6796 "gram.y"
    {
		rolloffset( (double) (yyvsp[(1) - (2)].floatval));
	}
    break;

  case 697:

/* Line 1806 of yacc.c  */
#line 6802 "gram.y"
    {	
		rolloffset( (double) (yyvsp[(2) - (3)].floatval));
	}
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 6807 "gram.y"
    {
		if (Curr_family == FAMILY_DFLT) {
			Curr_family = Score.fontfamily;
		}
		String1 = (yyvsp[(3) - (3)].stringval);
		Extra = extra_needed(Curr_family + Curr_font, Curr_size, &String1);
		proc_printcmd((yyvsp[(1) - (3)].intval), Curr_loc_info_p, String1,
			Curr_family + Curr_font, Curr_size, (yyvsp[(2) - (3)].intval),
			NO, ((yyvsp[(2) - (3)].intval) == YES ? Extra : (double) 0.0));
	}
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 6820 "gram.y"
    {
		if ((yyvsp[(2) - (3)].intval) == YES) {
			warning("nl ignored for postscript");
		}
		proc_printcmd(J_NONE, Curr_loc_info_p, (yyvsp[(3) - (3)].stringval), FONT_UNKNOWN,
			DFLT_SIZE, NO, YES, (double) 0.0);
		end_raw();
	}
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 6831 "gram.y"
    {
		begin_raw();
	}
    break;

  case 702:

/* Line 1806 of yacc.c  */
#line 6839 "gram.y"
    {
		/* this means print at default location */
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = NO;
	}
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 6847 "gram.y"
    {
		Curr_loc_info_p = (struct INPCOORD *) 0;
		(yyval.intval) = YES;
	}
    break;

  case 704:

/* Line 1806 of yacc.c  */
#line 6854 "gram.y"
    {
		(yyval.intval) = NO;
	}
    break;



/* Line 1806 of yacc.c  */
#line 10626 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 6859 "gram.y"


#include <stdio.h>


/* print error message along with current filename and line number */

int
yyerror(msg)

char *msg;

{
	if (strncmp(msg, "syntax error", 12) == 0 ||
			strncmp(msg, "parse error", 11) == 0) {
		/* beef up yacc's default syntax error message */
		if (*yytext == '\n') {
			l_yyerror(Curr_filename, yylineno,
				"error detected at end of line (maybe missing semicolon or other required element?)");
		}
		else if (is_internal_token(yytext) == YES) { 
			/* We add some funny tokens for our internal use
			 * when doing emptymeas parameter expansion.
			 * It is conceivable that there could be
			 * some (rare) scenarios where a user error
			 * in their value for that parameter would cause the
			 * parser to detect the error when it got to our
			 * funny token, and it would be very confusing to the
			 * user if we printed that out as the offending token,
			 * since they didn't input it, and it is chosen
			 * specifically to be strange looking.
			 */
			l_yyerror(Curr_filename, yylineno,
				"error detected during internal emptymeas parameter processing");
		}
		else {
			l_yyerror(Curr_filename, yylineno,
				"error detected at '%s'", yytext);
		}
	}
	else {
		l_yyerror(Curr_filename, yylineno, "%s", msg);
	}

	/* return something to keep lint happy */
	return(0);
}


/* if argument is surrounded by double quotes, remove them and return the
 * unquoted string. Actually just NULL out the end quote and return a
 * pointer to beyond the leading quote */

static char *
stripquotes(string)

char *string;

{
	char *p;

	p = string + strlen(string) - 1;
	if (*p == '"') {
		*p = '\0';
	}
	return( *string == '"' ? string + 1 : string);
}


/* Check if the given header/footer type has already been specified,
 * and if so, issue a warning. In any case, set Currblock_p
 * to the passed in BLOCKHEAD pointer. */

static void
chkdup_headfoot(bit, which, block_p)

int bit;	/* which GOT_* bit is associated with this head/foot thing */
char *which;	/* header, footer, header2, footer2 or left/right versions */
struct BLOCKHEAD *block_p;	/* assign this to Currblock_p */

{
	if ((bit & Gotheadfoot) != 0) {
		l_yyerror(Curr_filename, yylineno,
				"%s context specified more than once", which);
	}
	Gotheadfoot |= bit;
	Currblock_p = block_p;
}


/* If the given top/bot block has already been set without having been used,
 * issue a warning. In any case, set it to the Currblock_p value.
 */

static void
chkdup_topbot(block_p_p, blocktype)

struct BLOCKHEAD **block_p_p;	/* address of a FEED field like top_p, bot2_p,
				 * lefttop_p, rightbot_p, etc. What it points
				 * to will be updated with the value of
				 * Currblock_p. */
char *blocktype;		/* Name to be used on error message if the
				 * field was already set before. */

{
	if (*block_p_p != 0) {
		warning("%s redefined before being used", blocktype);
	}
	*block_p_p = Currblock_p;

}


/* when entering new context, need to save away everything about current one */

static void
end_prev_context()

{
	struct MAINLL *place_p;		/* where to insert SSV in main list */


	/* assume we will place at the end of main list. Later we'll set
	 * the right value if that assumption is wrong */
	place_p = Mainlltc_p;

	/* If current main list item hasn't been added to list yet,
	 * do that now. */
	if (Currstruct_p != (struct MAINLL *) 0 && Currstruct_p != place_p) {

		if (Currstruct_p->str == S_SSV) {

			if (List_of_staffs_p != (struct MAINLL *) 0) {
				yyerror("can't change context inside a measure");
				Currstruct_p = (struct MAINLL *) 0;
				return;
			}

			/* if is an SSV struct, we also need to set the
			 * correct values at this point, because the
			 * parser needs to know current values of some
			 * things (like font and point size) */
			asgnssv(Currstruct_p->u.ssv_p);

			/* if this SSV is after a FEED, we have to move it
			 * before the FEED in order to follow the rules of
			 * what comes when on the main list */
			for (   ; place_p != (struct MAINLL *) 0 &&
					place_p->str == S_FEED;
					place_p = place_p->prev) {
			}
		}

		insertMAINLL(Currstruct_p, place_p);
	}

	if (Currstruct_p != 0 && Currstruct_p->str == S_SSV) {
		/* memorize or recall beamstyle and timeunit if appropriate */
		remember_tsig_params(Currstruct_p);

		/* If user specified multiple staffs/voices, clone the
		 * necessary SSV nows */
		if (Currstruct_p->u.ssv_p->context == C_STAFF) {
			clone_staff_ssvs(place_p);
			free_rlists();
		}
		else if (Currstruct_p->u.ssv_p->context == C_VOICE) {
			clone_voice_ssvs(place_p);
			free_rlists();
		}
		Defining_multiple = NO;
	}

	if (Curr_usym_p != 0) {
		define_usym();
		Curr_usym_p = 0;
	}

	Curr_grpsyl_p = (struct GRPSYL *) 0;
	Currblock_p = (struct BLOCKHEAD *) 0;
	set_win_coord(0);
}


/* If user gave a list of staffs for a "staff" context, clone copies of
 * the SSV that we made for the first on the list for the rest of the list. */

static void
clone_staff_ssvs(insert_p)

struct MAINLL *insert_p;
{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */

	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
		for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
			for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
				if (clone_src_p->staffno == s) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, clone_src_p->voiceno);
			}
		}
	}
}


/* If user gave a list of staffs and/or voices  for a "voice" context,
 * clone copies of the SSV that we made for the first on the list
 * for the rest of the list. */

static void
clone_voice_ssvs(insert_p)

struct MAINLL *insert_p;

{
	struct SVRANGELIST *svr_p;
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	struct SSV *clone_src_p;	/* the SSV to clone */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */
	int have_non_v3 = NO;		/* If any voice other than voice 3 */


	clone_src_p = Currstruct_p->u.ssv_p;
	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end && s <= Score.staffs; s++) {
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) {
			for (v = vr_p->begin; v <= vr_p->end && v <= numvoices; v++) {
				if (v != 3) {
					have_non_v3 = YES;
				}
				if (clone_src_p->staffno == s
						&& clone_src_p->voiceno == v) {
					/* skip past the clone source */
					continue;
				}
				clone1ssv(clone_src_p, insert_p, s, v);
			}
		    }
		}
	    }
	}

	if (clone_src_p->used[ALIGNRESTS] == YES && have_non_v3 == NO) {
		l_warning(Curr_filename, yylineno,
				"alignrests not used for voice 3; ignoring");
	}
}

/* Clone the given SSV and insert it in the specified place in the main list.
 * Change the copied versions staffno/voiceno to the specified values,
 * and do any additional error checks and processsing as needed.
 */

static void
clone1ssv(clone_src_p, insert_p, staffno, voiceno)

struct SSV *clone_src_p;
struct MAINLL *insert_p;
int staffno;
int voiceno;

{
	struct MAINLL *newmllssv_p;	/* the cloned SSV */

	newmllssv_p = newMAINLLstruct(S_SSV, Currstruct_p->inputlineno);
	memcpy(newmllssv_p->u.ssv_p, clone_src_p, sizeof(struct SSV));
	newmllssv_p->u.ssv_p->staffno = staffno;
	newmllssv_p->u.ssv_p->voiceno = voiceno;
	/* Fix beamstyle/timeunit. It could be different for each clone */
	remember_tsig_params(newmllssv_p);
	insertMAINLL(newmllssv_p, insert_p);

	/* Make sure any tab staffs have non-tabs above them.
	 * One disadvantage of waiting till making the clone to check this is
	 * that if there is a user error, the line number will be the end
	 * of the context rather than the one with "stafflines" on it.
	 * But the error message will tell them which staff is the problem,
	 * and this should be pretty rare--they have to be setting stafflines
	 * in a staff context for multiple staffs where the combination of
	 * staffs is illegal--so it doesn't seem worth the extra work it would
	 * be to be more precise. */
	if (newmllssv_p->u.ssv_p->context == C_STAFF &&
				newmllssv_p->u.ssv_p->used[STAFFLINES] == YES) {
		chk_tab(newmllssv_p);
	}
	asgnssv(newmllssv_p->u.ssv_p);
}


/* Check that the staffs/voices specified for an SSV are valid.
 * We only give a warning if all values specified are out of range.
 * If at least one is valid, we assume user did something like
 * 	voice 1-40 3
 * to set something for voice 3 on all staffs without having to worry
 * about which staffs actually have a voice 3.
 */

static void
chk_ssv_ranges(context)

UINT32B context;	/* expected to only be either C_STAFF or C_VOICE */

{
	struct SVRANGELIST *svr_p;	/* list of staff/voice ranges */
	struct RANGELIST *sr_p;		/* list of staff ranges */
	struct RANGELIST *vr_p;		/* list of voice ranges */
	int s;				/* staff number */
	int v;				/* voice number */
	int numvoices;			/* how many voices on current staff */


	for (svr_p = Svrangelist_p; svr_p != 0; svr_p = svr_p->next) {
	    for (sr_p = svr_p->stafflist_p; sr_p != 0; sr_p = sr_p->next) { 
		for (s = sr_p->begin; s <= sr_p->end; s++) {
		    if (context == C_STAFF) {
			if (s >= MINSTAFFS && s <= Score.staffs) {
				/* Found a valid one. One is all we need. */
				return;
			}
			continue;
		    }

		    /* a voice context */
		    numvoices = vscheme_voices(svpath(s, VSCHEME)->vscheme);
		    for (vr_p = svr_p->vnolist_p; vr_p != 0; vr_p = vr_p->next) { 
			for (v = vr_p->begin; v <= vr_p->end; v++) {
			    if (s >= MINSTAFFS && s <= Score.staffs &&
					v >= MINVOICES && v <= numvoices) {
				/* Found a valid one. One is all we need. */
				return;
			    }
			}
		    }
		}
	    }
	}
	/* Fell through all the loops without finding a single valid case */
	if (context == C_STAFF) {
		l_warning(Curr_filename, yylineno,
			"staff out of range; must be between %d and %d",
			MINSTAFFS, Score.staffs);
	}
	else {
		l_warning(Curr_filename, yylineno,
			"staff/voice combination out of range; staff must be between %d and %d, voice between %d and %d and within vscheme limit for the staff",
			MINSTAFFS, MAXSTAFFS, MINVOICES, MAXVOICES);
	}
}


/* if defining more than one voice at the moment, not valid to set
 * a location variable. Print message and reset flag so we don't
 * give any more of the same message this measure */

static void
var_valid()

{
	if (Defining_multiple == YES) {
		yyerror("location tag is only allowed when defining a single voice");
		Defining_multiple = NO;
	}
	else if (Chord_at_a_time == YES) {
		yyerror("location tag not allowed with chord-at-a-time input");
	}
}


/* do a print command like left, right, or center. Allocate a PRINTDATA
 * struct and fill in all the information about what to print and where
 * to print it. */

static void
proc_printcmd(justifytype, inpc_p, str, font, size, got_nl, isPostScript, extra)

int justifytype;	/* J_LEFT, etc */
struct INPCOORD *inpc_p;	/* where to print */
char *str;		/* the string to print */
int font;
int size;
int got_nl;	/* YES if should go to next line before printing */
int isPostScript;	/* YES if is raw PostScript rather than normal print */
double extra;	/* how much extra vertical padding to add */

{
	struct PRINTDATA *curr_print_p;
	struct EXPR_NODE *node_p;
	int htype;


	(void) contextcheck(C_MUSIC | C_BLOCKHEAD, "print");

	/* save all the info in a PRINTDATA struct */
	MALLOC(PRINTDATA, curr_print_p, 1);

	if (inpc_p == (struct INPCOORD *) 0) {

		/* print at default location */
		curr_print_p->location.vert_p = symval("_cur", (float **) 0);
		/* Create an expression that is _cur - extra */
		node_p = newnode(OP_SUB);
		curr_print_p->location.vexpr_p = node_p;

		node_p->left.lchild_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, node_p->left.lchild_p->left.ltag_p, 1);
		node_p->left.lchild_p->left.ltag_p->c = curr_print_p->location.vert_p;
		node_p->left.lchild_p->left.ltag_p->c_index = AY;
		save_tag_ref(node_p->left.lchild_p->left.ltag_p->c,
					&(node_p->left.lchild_p->left.ltag_p->c));

		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = extra;

		switch (justifytype) {
		case J_LEFT:
		case J_RAGPARA:
		case J_JUSTPARA:
			/* default x is relative to _win.w */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AW;
			break;
		case J_RIGHT:
			/* default x is relative to _win.e */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AE;
			break;
		case J_CENTER:
			/* default x is relative to _win.x */
			curr_print_p->location.hor_p = symval("_win", (float **) 0);
			htype = AX;
			break;
		case J_NONE:
		default:
			/* default is at current location */
			curr_print_p->location.hor_p = symval("_cur", (float **) 0);
			htype = AX;
			break;
		}

		curr_print_p->location.hexpr_p = newnode(OP_TAG_REF);
		MALLOC(TAG_REF, curr_print_p->location.hexpr_p->left.ltag_p, 1);
		curr_print_p->location.hexpr_p->left.ltag_p->c = curr_print_p->location.hor_p;
		curr_print_p->location.hexpr_p->left.ltag_p->c_index = htype;
		save_tag_ref(curr_print_p->location.hexpr_p->left.ltag_p->c,
			&(curr_print_p->location.hexpr_p->left.ltag_p->c));

		/* If this is the first print command in a block,
		 * we implicitly go down by the font ascent. */
		if (isPostScript == NO && Currblock_p != 0
					&& Next_print_link_p_p
					== &(Currblock_p->printdata_p) ) {
			/* Alter expression, to subtract the fontascent */
			node_p = newnode(OP_SUB);
			node_p->left.lchild_p = curr_print_p->location.vexpr_p;
			curr_print_p->location.vexpr_p = node_p;
			node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
			node_p->right.rchild_p->left.value = fontascent(font, size) / STEPSIZE;

			got_nl = NO;
		}

	}
	else {
		curr_print_p->location = *(inpc_p);
		rep_inpcoord(inpc_p, &(curr_print_p->location) );
		FREE(inpc_p);
	}

	curr_print_p->isPostScript = isPostScript;
	if (isPostScript == YES) {
		curr_print_p->width = 0.0;
	}
	else {
		curr_print_p->width = strwidth(str);
	}
	curr_print_p->justifytype = (short) justifytype;
	curr_print_p->string = str;
	curr_print_p->inputfile = Curr_filename;
	curr_print_p->inputlineno = (short) yylineno;

	/* special case of user asking that this be printed
	 * on the next line. In this case we go down by the
	 * current point size */
	if (got_nl) {
		node_p = newnode(OP_SUB);
		node_p->left.lchild_p = curr_print_p->location.vexpr_p;
		curr_print_p->location.vexpr_p = node_p;
		node_p->right.rchild_p = newnode(OP_FLOAT_LITERAL);
		node_p->right.rchild_p->left.value = fontheight(font, size) / STEPSIZE;
	}

	/* Now link onto proper list -- could be in BLOCKHEAD
	 * context or doing a PRHEAD. If we are in BLOCKHEAD context, we
	 * definitely have something in the main list to attach to.
	 * If in C_MUSIC, we may or may not depending on whether
	 * this is the first in a series of print commands. */
	if ( ((Context & C_BLOCKHEAD) != 0)
		|| ((Currstruct_p != (struct MAINLL *) 0) &&
		(Currstruct_p->str == S_PRHEAD) ) ) {
			if (Next_print_link_p_p == (struct PRINTDATA **) 0) {
				pfatal("Next_print_link_p_p is null");
			}
			/* this means the value of Next_print_link_p_p
			 * is valid and will tell us where to link */
			*Next_print_link_p_p = curr_print_p;
	}
	else {
		/* We must be in music context, but the last
		 * thing we saw wasn't a print command, so
		 * we have to allocate a PRHEAD and put it
		 * in the main list and attach to that. */
		/* allocate a new struct, put on main list and attach
		 * the print command to it */
		Currstruct_p = newMAINLLstruct(S_PRHEAD, yylineno);
		insertMAINLL(Currstruct_p, Mainlltc_p);
		Currstruct_p->u.prhead_p->printdata_p = curr_print_p;
		Currstruct_p = (struct MAINLL *) 0;
	}

	/* in any case, if we get another print command right away, it
	 * should be linked onto this one, so remember where we are */
	Next_print_link_p_p = &(curr_print_p->next);
	curr_print_p->next = (struct PRINTDATA *) 0;
}


/* if the given string has a higher ascent than the given font/size, return
 * the amount is it higher, in stepsizes */

static double
extra_needed(font, size, string_p)

int font;	/* default font for this string */
int size;	/* default size for this string */
char **string_p;/* string, before being put in internal format,
		 * which might contain \s(xx) to make it bigger than normal.
		 * If it is key-mapped, the passed-in pointer will be
		 * updated to point to the mapped string. */

{
	double usual_ascent;
	double this_string_ascent;


	/* get expected ascent for this font/size and actual for string */
	usual_ascent = fontascent(font, size);
	(void) fix_string(*string_p, font, size, Curr_filename, yylineno);
	*string_p = map_print_str(*string_p, Curr_filename, yylineno);
	this_string_ascent = strascent(*string_p);

	/* if this string is too tall, return by how much it is too tall */
	if (this_string_ascent > usual_ascent) {
		return (this_string_ascent - usual_ascent) / STEPSIZE;
	}
	else {
		return(0.0);
	}
}


/* Sometimes lexer will recognize something as a keyword, but it's
 * really a bunch of note letters, due to context. This function turns
 * the mistaken keyword into notes. It handles a through g and r and s, and
 * us, but not n, which would also be troublesome, but which we don't (yet)
 * need to handle.
 */

static void
keyword_notes(str)

char *str;

{
	for (  ; *str != '\0'; str++) {
		if (*str == 'u' && *(str+1) == 's') {
			str++;
			continue;
		}

		/* On the last letter, if it's a true pitch, have to
		 * push it back into input, because it could be followed
		 * by an accidental or octave mark or tick or something. */
		if (*(str+1) == '\0' && *str >= 'a' && *str <= 'g') {
			pushback(*str);
		}
		else {
			add_note(Curr_grpsyl_p, (int) *str, No_accs,
					USE_DFLT_OCTAVE, 0, NO, (char *) 0);
		}
	}
}


/* Free up the current additive time list, if any */

static void
free_extra_time()
{
	struct TIMELIST *tl_p;

	/* If this was the most recently allocated list, we can free it.
	 * We can't free otherwise, since Extra_time_p might be
	 * pointing to one from an SSV, which must be kept around. */
	if (Extra_time_p == Last_alloced_timelist_p) {
		while (Extra_time_p != 0) {
			tl_p = Extra_time_p->next;
			FREE(Extra_time_p);
			Extra_time_p = tl_p;
		}
	}
	Extra_time_p = 0;
	Last_alloced_timelist_p = 0;
	Curr_timelist_p = 0;
}


/* Add an item to the internal representation of the time signature
 * currently being collected */

static void
tsig_item(item)

int item;	/* the byte to add to timerep */

{
	if (Tsig_offset >= MAXTSLEN  - 1) {
		l_ufatal(Curr_filename, yylineno,
				"time signature is too complicated");
	}
	Timerep[Tsig_offset++] = (char) item;
}


/* Allocate a new expression node, fill in its opearator field, and return it. */

static struct EXPR_NODE *
newnode(op)

int op;		/* OP_* value for the new node */

{
	struct EXPR_NODE * node_p;

	CALLOC(EXPR_NODE, node_p, 1);
	node_p->op = op;
	return(node_p);
}


/* Zero out the list of accidentals for the current note */

static void
clear_curr_accs()

{
	CLEAR_ACCS(Curr_accs);
	Acc_offset = 0;
}


/* Add given accidental to the list of accidental for the current note.
 * (if it is valid and there is room) */

static void
add_acc(acc_name)

char *acc_name;

{
	int code;
	int font;

	if (Acc_offset >= 2 * MAX_ACCS) {
		l_yyerror(Curr_filename, yylineno,
				"Too many accidentals (%d max)", MAX_ACCS);
		return;
	}
	if (is_bad_char((code = find_char(acc_name, &font, NO, NO))) == YES) {
		l_yyerror(Curr_filename, yylineno,
			"No symbol named %s to use as accidental", acc_name);
		return;
	}

	/* Note that probably the font should be either one of the music
	 * fonts or user defined font, but we go ahead and allow anything. */
	Curr_accs[Acc_offset++] = font;
	Curr_accs[Acc_offset++] = code;

	/* If we have a non standard accidental, or if the accidentals
	 * net out to something outside the range of double flat to
	 * double sharp, mark Tuning_used, because we can't use simple
	 * ordinary MIDI commands. */
	if (accs_offset(Curr_accs) == BAD_ACCS_OFFSET) {
		Tuning_used = YES;
	}
}


/* Add another entry to the list of accidentals in accidentals context.
 * It is passed the name of the accidental. It allocates an entry,
 * if necessary, sets Curr_acc_index to the index of the entry, fills in
 * the code and font, and sets offsets to a negative value to indicate
 * "not yet filled in."
 */

static void
new_acc_entry(acc_name)

char *acc_name;		/* like "sharp" or "dlbflat" or a user name */

{
	int i;
	int is_small;


	if (Acc_contexts_list_p == 0) {
		/* must have been an earlier error */
		return;
	}

	/* Check for already defined */
	for (i = 0; i < Acc_contexts_list_p->size; i++) {
		if (strcmp(acc_name, get_charname(
				Acc_contexts_list_p->info[i].code,
				Acc_contexts_list_p->info[i].font))
				== 0) {
			/* Use the existing entry */
			Curr_acc_index = i;
			return;
		}
	}

	/* If space is full, alloc another chunk */
	if (Acc_contexts_list_p->size % ITEMS == 0
				&& Acc_contexts_list_p->size > 0) {
		REALLOC(ACCINFO, Acc_contexts_list_p->info,
				Acc_contexts_list_p->size + ITEMS);
	}

	/* Use the next available slot */
	Curr_acc_index = Acc_contexts_list_p->size;

	/* One more slot being used */
	(Acc_contexts_list_p->size)++;

	/* Fill in all the offset slots with an illegal
	 * (i.e., negative) value, so we can tell later which the user
	 * has set. Normally I wouldn't hard-code a 7, but if the
	 * number of "white keys" a-g changes from 7, we have
	 * much bigger problems ;-). 
	 */
	for (i = 0; i < 7; i++) {
		CURR_ACC_ENTRY.offset[i] = -1.0;
	}

	/* Translate symbol name to code and font */
	CURR_ACC_ENTRY.code = find_char(acc_name,
					&(CURR_ACC_ENTRY.font), &is_small, YES);
}


/* Fill in an element of the offset[] array for a accidental,
 * in accidentals context. 
 */

static void
add_acc_offset(letter, offset)

int letter;	/* which index into offset[], 'a' is 0, 'b' is 1, etc */
double offset;	/* what value to fill in */

{
	int index;

	if (Context != C_ACCIDENTALS) {
		return;
	}
	if (Acc_contexts_list_p == 0) {
		/* Must have been earlier error */
		return;
	}

	index = letter - 'a';

	/* Check if already has been set */
	if (CURR_ACC_ENTRY.offset[index] >= 0 ) {
		l_warning(Curr_filename, yylineno,
			"offset for accidental '%s' specified more than once, using last", get_charname(CURR_ACC_ENTRY.code, CURR_ACC_ENTRY.font));
	}

	/* Warn about outrageous values. We consider an accidental
	 * that changes by more than a major third outrageous. */
	if (offset < 0.8 || offset > 1.25) {
		l_warning(Curr_filename, yylineno,
			"dubious accidental offset (factor of %f alters pitch by more than a major third)", offset);
	}

	/* Fill in the value */
	CURR_ACC_ENTRY.offset[index] = offset;
}

